within AICE.Blocks.Electrical.Components;

model MotorStarter_AITO
  //replaceable AICE.Electrical.MotorStarter acausal_model;
  //extends AICE.Electrical.MotorStarter;
  extends AICE.Electrical.BaseClasses.MotorParameters;

  AICE.Electrical.BaseClasses.MotorStarter acausal_model(k=k, BackVoltage_table=BackVoltage_table) annotation(
    Placement(visible = true, transformation(origin = {-2, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Mechanics.Rotational.Interfaces.Adaptors.Adaptor_AITO adaptor_AITO annotation(
    Placement(visible = true, transformation(origin = {45, 1}, extent = {{-19, -19}, {19, 19}}, rotation = 0)));
  AICE.Blocks.Electrical.Interfaces.Adaptors.Adaptor_AITO adaptor_elec_AOTI annotation(
    Placement(visible = true, transformation(origin = {-2, 46}, extent = {{-22, 22}, {22, -22}}, rotation = 90)));
  AICE.Blocks.Interfaces.VoltageInput voltage annotation(
    Placement(visible = true, transformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.CurrentOutput current annotation(
    Placement(visible = true, transformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Interfaces.AngularVelocityInput angularVelocity annotation(
    Placement(visible = true, transformation(origin = {100, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {100, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.TorqueOutput torque annotation(
    Placement(visible = true, transformation(origin = {100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(acausal_model.flange_b, adaptor_AITO.flange_a) annotation(
    Line(points = {{8, 0}, {20, 0}, {20, 1}, {26, 1}}));
  connect(acausal_model.pin_ap, adaptor_elec_AOTI.pin_p) annotation(
    Line(points = {{4, 10}, {12, 10}, {12, 24}, {11, 24}}, color = {0, 0, 255}));
  connect(acausal_model.pin_an, adaptor_elec_AOTI.pin_n) annotation(
    Line(points = {{-8, 10}, {-15, 10}, {-15, 24}}, color = {0, 0, 255}));
  connect(current, adaptor_elec_AOTI.current) annotation(
    Line(points = {{-40, 100}, {-40, 100}, {-40, 80}, {-16, 80}, {-16, 68}, {-16, 68}}, color = {0, 0, 127}));
  connect(voltage, adaptor_elec_AOTI.voltage) annotation(
    Line(points = {{40, 100}, {40, 100}, {40, 80}, {12, 80}, {12, 68}, {12, 68}}, color = {0, 0, 127}));
  connect(angularVelocity, adaptor_AITO.angularVelocity_b) annotation(
    Line(points = {{100, 60}, {64, 60}, {64, 12}, {64, 12}}, color = {0, 0, 127}));
  connect(adaptor_AITO.torque_b, torque) annotation(
    Line(points = {{64, -10}, {68, -10}, {68, -60}, {100, -60}, {100, -60}}, color = {0, 0, 127}));
end MotorStarter_AITO;
