within AICE.Blocks.Electrical.Components;

model MotorStarter_OnewayGearSimple_AITO
  //replaceable AICE.Electrical.MotorStarter acausal_model;
  extends AICE.Icons.Electrical.Starter;
  extends AICE.Electrical.BaseClasses.MotorParameters;
  parameter Real ratio(min=0.001, max=1000) "Gear Ratio";
  parameter AICE.Blocks.Types.Energy energy_flange = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_electric = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  AICE.Electrical.BaseClasses.MotorStarter acausalMotor(BackVoltage_table = BackVoltage_table, k = k)  annotation(
    Placement(visible = true, transformation(origin = {-50, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Mechanics.Rotational.Interfaces.Adaptors.Adaptor_AITO adaptor_AITO(energy = energy_flange) annotation(
    Placement(visible = true, transformation(origin = {48, 1.88738e-15}, extent = {{-12, -12}, {12, 12}}, rotation = 0)));
  AICE.Blocks.Electrical.Interfaces.Adaptors.Adaptor_AITO adaptor_elec_AOTI(energy = energy_electric) annotation(
    Placement(visible = true, transformation(origin = {-50, 52}, extent = {{-10, 10}, {10, -10}}, rotation = 90)));
  AICE.Blocks.Interfaces.VoltageInput voltageInput annotation(
    Placement(visible = true, transformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.CurrentOutput currentOutput annotation(
    Placement(visible = true, transformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Interfaces.AngularVelocityInput angularVelocityInput annotation(
    Placement(visible = true, transformation(origin = {100, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {100, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.TorqueOutput torqueOutput annotation(
    Placement(visible = true, transformation(origin = {100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Electrical.BaseClasses.OnewayGearSimple simpleOnewayGear(ratio = ratio)  annotation(
    Placement(visible = true, transformation(origin = {-2, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.Greater greater annotation(
    Placement(visible = true, transformation(origin = {-18, 38}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  greater.u1 = acausalMotor.pin_ap.v + 1;
  greater.u2 = acausalMotor.pin_an.v + 2;

  connect(acausalMotor.pin_ap, adaptor_elec_AOTI.pin_p) annotation(
    Line(points = {{-44, 10}, {-44, 42}}, color = {0, 0, 255}));
  connect(acausalMotor.pin_an, adaptor_elec_AOTI.pin_n) annotation(
    Line(points = {{-56, 10}, {-56, 42}}, color = {0, 0, 255}));
  connect(currentOutput, adaptor_elec_AOTI.current) annotation(
    Line(points = {{-40, 100}, {-40, 80}, {-56, 80}, {-56, 62}}, color = {0, 0, 127}));
  connect(voltageInput, adaptor_elec_AOTI.voltage) annotation(
    Line(points = {{40, 100}, {40, 74}, {-44, 74}, {-44, 62}}, color = {0, 0, 127}));
  connect(angularVelocityInput, adaptor_AITO.angularVelocity_b) annotation(
    Line(points = {{100, 60}, {60, 60}, {60, 7}}, color = {0, 0, 127}));
  connect(adaptor_AITO.torque_b, torqueOutput) annotation(
    Line(points = {{60, -7}, {60, -60}, {100, -60}}, color = {0, 0, 127}));
  connect(acausalMotor.flange_b, simpleOnewayGear.flange_a) annotation(
    Line(points = {{-40, 0}, {-12, 0}, {-12, 0}, {-12, 0}}));
  connect(simpleOnewayGear.flange_b, adaptor_AITO.flange_a) annotation(
    Line(points = {{8, 0}, {36, 0}, {36, 0}, {36, 0}}));
  connect(greater.y, simpleOnewayGear.Gear_flag) annotation(
    Line(points = {{-7, 38}, {-2, 38}, {-2, 10}}, color = {255, 0, 255}));
  annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end MotorStarter_OnewayGearSimple_AITO;
