within AICE.Blocks.Electrical.Components;

model MotorStarter_OnewayGear_AITO
  //replaceable AICE.Electrical.MotorStarter acausal_model;
  //extends AICE.Electrical.MotorStarter;
  extends AICE.Electrical.BaseClasses.MotorParameters;

  AICE.Electrical.BaseClasses.MotorStarter acausalMotor(k=k, BackVoltage_table = BackVoltage_table) annotation(
    Placement(visible = true, transformation(origin = {-50, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Mechanics.Rotational.Interfaces.Adaptors.Adaptor_AITO adaptor_AITO(energy = AICE.Blocks.Types.Energy.Source) annotation(
    Placement(visible = true, transformation(origin = {48, 1.88738e-15}, extent = {{-12, -12}, {12, 12}}, rotation = 0)));
  AICE.Blocks.Electrical.Interfaces.Adaptors.Adaptor_AITO adaptor_elec_AOTI(energy = AICE.Blocks.Types.Energy.Sink) annotation(
    Placement(visible = true, transformation(origin = {-50, 52}, extent = {{-10, 10}, {10, -10}}, rotation = 90)));
  AICE.Blocks.Interfaces.VoltageInput voltage annotation(
    Placement(visible = true, transformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.CurrentOutput current annotation(
    Placement(visible = true, transformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Interfaces.AngularVelocityInput angularVelocity annotation(
    Placement(visible = true, transformation(origin = {100, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {100, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.TorqueOutput torque annotation(
    Placement(visible = true, transformation(origin = {100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Electrical.BaseClasses.OnewayGear acausalOnewayGear annotation(
    Placement(visible = true, transformation(origin = {2, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(acausalMotor.pin_ap, adaptor_elec_AOTI.pin_p) annotation(
    Line(points = {{-44, 10}, {-44, 42}}, color = {0, 0, 255}));
  connect(acausalMotor.pin_an, adaptor_elec_AOTI.pin_n) annotation(
    Line(points = {{-56, 10}, {-56, 42}}, color = {0, 0, 255}));
  connect(current, adaptor_elec_AOTI.current) annotation(
    Line(points = {{-40, 100}, {-40, 80}, {-56, 80}, {-56, 62}}, color = {0, 0, 127}));
  connect(voltage, adaptor_elec_AOTI.voltage) annotation(
    Line(points = {{40, 100}, {40, 74}, {-44, 74}, {-44, 62}}, color = {0, 0, 127}));
  connect(angularVelocity, adaptor_AITO.angularVelocity_b) annotation(
    Line(points = {{100, 60}, {60, 60}, {60, 7}}, color = {0, 0, 127}));
  connect(adaptor_AITO.torque_b, torque) annotation(
    Line(points = {{60, -7}, {60, -60}, {100, -60}}, color = {0, 0, 127}));
  connect(acausalMotor.flange_b, acausalOnewayGear.flange_a) annotation(
    Line(points = {{-40, 0}, {-8, 0}}));
  connect(acausalOnewayGear.flange_b, adaptor_AITO.flange_a) annotation(
    Line(points = {{12, 0}, {36, 0}}));
  annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end MotorStarter_OnewayGear_AITO;
