within AICE.Blocks.Electrical.Interfaces.Adaptors.BaseClasses;

partial model PartialAdaptor

  parameter AICE.Blocks.Types.Energy energy
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );
  Modelica.Electrical.Analog.Interfaces.PositivePin pin_p annotation(
    Placement(visible = true, transformation(origin = {-100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Electrical.Analog.Interfaces.NegativePin pin_n annotation(
    Placement(visible = true, transformation(origin = {-100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
protected

  SI.Voltage volt;
  SI.Current current_a, current_b;


equation

  0 = current_a + current_b;

  pin_p.v - pin_n.v = volt;
  pin_p.i = current_a;
  pin_n.i = current_b;

  
end PartialAdaptor;