within AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors;

model AdaptorThermoFluid_AITO
  extends AICE.Icons.Blocks.FluidPort_ab;
  extends BaseClasses.PartialAdaptorThermoFluid;
  extends ThermoFluidPort_AITO_b;

equation
  p = absolutePressure_b;
  //T_b = temperature_b; //Defined but not used by Modelica acausal model

  if energy == AICE.Blocks.Types.Energy.Source then
    m_flow_b = -massFlowRate_b;
    dH = -enthalpyFlowRate_b; 
  elseif energy == AICE.Blocks.Types.Energy.Sink then
    m_flow_b = +massFlowRate_b;
    dH = +enthalpyFlowRate_b; 
  end if;

  h_b = specificEnthalpy_mix_b;
  Xi_b[:] = massFractions_mix_b[:];

  h_a = specificEnthalpy_outflow_b;
  Xi_a[:] = massFractions_outflow_b[:];

end AdaptorThermoFluid_AITO;
