within AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors;

block CausalTwoPortTransport_TFAIITOO
  extends Interfaces.ThermoFluidPort_AITO_a;
  extends Interfaces.ThermoFluidPort_AITO_b;

  extends BaseClasses.PartialCausalTwoPortTransport;

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AITO adaptor_a(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_a
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)
    )
  );

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AITO adaptor_b(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_b
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)
    )
  );

equation

  connect(acausalModel.port_a, adaptor_a.port_a) annotation(
    Line(points = {{-20, 0}, {-40, 0}}, color = {0, 127, 255})
  );
  connect(acausalModel.port_b, adaptor_b.port_a) annotation(
    Line(points = {{+20, 0}, {+40, 0}}, color = {0, 127, 255})
  );
  connect(adaptor_a.specificEnthalpy_mix_b, specificEnthalpy_mix_a) annotation(
    Line(points = {{-60,  +8}, {-76,  +8}, {-76, +40}, {-100, +40}}, color = {0, 0, 127})
  );
  connect(adaptor_a.massFractions_mix_b[:], massFractions_mix_a[:]) annotation(
    Line(points = {{-60,  +4}, {-80,  +4}, {-80, +20}, {-100, +20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_a.massFractions_outflow_b[:], massFractions_outflow_a[:]) annotation(
    Line(points = {{-60,  -4}, {-80,  -4}, {-80, -20}, {-100, -20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_a.specificEnthalpy_outflow_b, specificEnthalpy_outflow_a) annotation(
    Line(points = {{-60,  -8}, {-76,  -8}, {-76, -40}, {-100, -40}}, color = {0, 0, 127})
  );
  connect(adaptor_a.massFlowRate_b, massFlowRate_a) annotation(
    Line(points = {{-60, -12}, {-72, -12}, {-72, -60}, {-100, -60}}, color = {0, 0, 127})
  );
  connect(adaptor_b.specificEnthalpy_mix_b, specificEnthalpy_mix_b) annotation(
    Line(points = {{+60,  +8}, {+76,  +8}, {+76, +40}, {+100, +40}}, color = {0, 0, 127})
  );
  connect(adaptor_b.massFractions_mix_b[:], massFractions_mix_b[:]) annotation(
    Line(points = {{+60,  +4}, {+80,  +4}, {+80, +20}, {+100, +20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_b.massFractions_outflow_b[:], massFractions_outflow_b[:]) annotation(
    Line(points = {{+60,  -4}, {+80,  -4}, {+80, -20}, {+100, -20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_b.specificEnthalpy_outflow_b, specificEnthalpy_outflow_b) annotation(
    Line(points = {{+60,  -8}, {+76,  -8}, {+76, -40}, {+100, -40}}, color = {0, 0, 127})
  );
  connect(adaptor_b.massFlowRate_b, massFlowRate_b) annotation(
    Line(points = {{+60, -12}, {+72, -12}, {+72, -60}, {+100, -60}}, color = {0, 0, 127})
  );
  connect(adaptor_a.absolutePressure_b, absolutePressure_a) annotation(
    Line(points = {{-60, 16}, {-68, 16}, {-68, 80}, {-100, 80}, {-100, 80}}, color = {0, 0, 127}));
  connect(adaptor_a.temperature_b, temperature_a) annotation(
    Line(points = {{-60, 12}, {-74, 12}, {-74, 60}, {-100, 60}, {-100, 60}}, color = {0, 0, 127}));
  connect(adaptor_a.enthalpyFlowRate_b, enthalpyFlowRate_a) annotation(
    Line(points = {{-60, -16}, {-68, -16}, {-68, -80}, {-100, -80}, {-100, -80}}, color = {0, 0, 127}));
  connect(absolutePressure_b, adaptor_b.absolutePressure_b) annotation(
    Line(points = {{100, 80}, {64, 80}, {64, 16}, {60, 16}, {60, 16}}, color = {0, 0, 127}));
  connect(temperature_b, adaptor_b.temperature_b) annotation(
    Line(points = {{100, 60}, {70, 60}, {70, 12}, {60, 12}, {60, 12}}, color = {0, 0, 127}));
  connect(adaptor_b.enthalpyFlowRate_b, enthalpyFlowRate_b) annotation(
    Line(points = {{60, -16}, {68, -16}, {68, -80}, {100, -80}, {100, -80}}, color = {0, 0, 127}));
end CausalTwoPortTransport_TFAIITOO;