within AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors;

block CausalTwoPortTransport_TFAOOOOTIIII
  extends Interfaces.FluidPort_TFAOTI_a_1;
  extends Interfaces.FluidPort_TFAOTI_b_2;
  //extends BaseClasses.PartialCausalTwoPortTransportDual;
  parameter AICE.Blocks.Types.Energy energy_port_a = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_port_b = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_port_1 = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_port_2 = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_a(redeclare replaceable package Medium = Medium, energy = energy_port_a) annotation(
    Placement(visible = true, transformation(origin = {-42, 60}, extent = {{10, -20}, {-10, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_b(redeclare replaceable package Medium = Medium, energy = energy_port_b) annotation(
    Placement(visible = true, transformation(origin = {50, 60}, extent = {{-10, -20}, {10, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_2(redeclare replaceable package Medium = Medium,
  energy = energy_port_2) annotation(
    Placement(visible = true, transformation(origin = {50, -60}, extent = {{-10, -20}, {10, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_1(redeclare replaceable package Medium = Medium,
  energy = energy_port_1) annotation(
    Placement(visible = true, transformation(origin = {-42, -60}, extent = {{10, -20}, {-10, 20}}, rotation = 0)));
equation
  connect(adaptor_a.absolutePressure_b, absolutePressure_a) annotation(
    Line(points = {{-52, 76}, {-56, 76}, {-56, 180}, {-100, 180}}, color = {0, 0, 127}));
  connect(adaptor_a.temperature_b, temperature_a) annotation(
    Line(points = {{-52, 72}, {-60, 72}, {-60, 160}, {-100, 160}}, color = {0, 0, 127}));
  connect(adaptor_a.specificEnthalpy_outflow_b, specificEnthalpy_outflow_a) annotation(
    Line(points = {{-52, 68}, {-64, 68}, {-64, 140}, {-92, 140}}, color = {0, 0, 127}));
  connect(adaptor_a.massFractions_outflow_b[:], massFractions_outflow_a[:]) annotation(
    Line(points = {{-52, 64}, {-68, 64}, {-68, 120}, {-102, 120}}, color = {0, 0, 127}, thickness = 0.5));

  connect(adaptor_a.massFractions_mix_b[:], massFractions_mix_a[:]) annotation(
    Line(points = {{-52, 56}, {-72, 56}, {-72, 80}, {-100, 80}, {-100, 80}, {-100, 80}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_a.specificEnthalpy_mix_b, specificEnthalpy_mix_a) annotation(
    Line(points = {{-52, 52}, {-76, 52}, {-76, 60}, {-96, 60}, {-96, 60}, {-100, 60}}, color = {0, 0, 127}));
  connect(adaptor_a.massFlowRate_b, massFlowRate_a) annotation(
    Line(points = {{-52, 48}, {-76, 48}, {-76, 40}, {-100, 40}, {-100, 40}}, color = {0, 0, 127}));
  connect(adaptor_a.enthalpyFlowRate_b, enthalpyFlowRate_a) annotation(
    Line(points = {{-52, 44}, {-70, 44}, {-70, 20}, {-100, 20}, {-100, 20}}, color = {0, 0, 127}));

  connect(adaptor_b.absolutePressure_b, absolutePressure_b) annotation(
    Line(points = {{60, 76}, {64, 76}, {64, 180}, {100, 180}}, color = {0, 0, 127}));
  connect(adaptor_b.temperature_b, temperature_b) annotation(
    Line(points = {{60, 72}, {70, 72}, {70, 160}, {100, 160}}, color = {0, 0, 127}));
  connect(adaptor_b.specificEnthalpy_outflow_b, specificEnthalpy_outflow_b) annotation(
    Line(points = {{60, 68}, {74, 68}, {74, 140}, {92, 140}}, color = {0, 0, 127}));
  connect(adaptor_b.massFractions_outflow_b[:], massFractions_outflow_b[:]) annotation(
    Line(points = {{60, 64}, {78, 64}, {78, 120}, {100, 120}}, color = {0, 0, 127}, thickness = 0.5));

  connect(adaptor_b.massFractions_mix_b[:], massFractions_mix_b[:]) annotation(
    Line(points = {{60, 56}, {84, 56}, {84, 80}, {100, 80}, {100, 80}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_b.specificEnthalpy_mix_b, specificEnthalpy_mix_b) annotation(
    Line(points = {{60, 52}, {90, 52}, {90, 60}, {100, 60}, {100, 60}}, color = {0, 0, 127}));
  connect(adaptor_b.massFlowRate_b, massFlowRate_b) annotation(
    Line(points = {{60, 48}, {90, 48}, {90, 40}, {100, 40}}, color = {0, 0, 127}));
  connect(adaptor_b.enthalpyFlowRate_b, enthalpyFlowRate_b) annotation(
    Line(points = {{60, 44}, {84, 44}, {84, 20}, {100, 20}, {100, 20}}, color = {0, 0, 127}));

  connect(adaptor_1.absolutePressure_b, absolutePressure_1) annotation(
    Line(points = {{-52, -44}, {-56, -44}, {-56, -20}, {-94, -20}, {-94, -20}, {-100, -20}}, color = {0, 0, 127}));
  connect(adaptor_1.temperature_b, temperature_1) annotation(
    Line(points = {{-52, -48}, {-60, -48}, {-60, -40}, {-100, -40}, {-100, -40}}, color = {0, 0, 127}));
  connect(adaptor_1.specificEnthalpy_outflow_b, specificEnthalpy_outflow_1) annotation(
    Line(points = {{-52, -52}, {-84, -52}, {-84, -60}, {-100, -60}, {-100, -60}}, color = {0, 0, 127}));
  connect(adaptor_1.massFractions_outflow_b[:], massFractions_outflow_1[:]) annotation(
    Line(points = {{-52, -56}, {-80, -56}, {-80, -80}, {-100, -80}, {-100, -80}}, color = {0, 0, 127}, thickness = 0.5));

  connect(adaptor_1.massFractions_mix_b[:], massFractions_mix_1[:]) annotation(
    Line(points = {{-52, -64}, {-76, -64}, {-76, -120}, {-100, -120}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_1.specificEnthalpy_mix_b, specificEnthalpy_mix_1) annotation(
    Line(points = {{-52, -68}, {-70, -68}, {-70, -140}, {-100, -140}}, color = {0, 0, 127}));
  connect(adaptor_1.massFlowRate_b, massFlowRate_1) annotation(
    Line(points = {{-52, -72}, {-66, -72}, {-66, -160}, {-100, -160}}, color = {0, 0, 127}));
  connect(adaptor_1.enthalpyFlowRate_b, heatFlowRate_1) annotation(
    Line(points = {{-52, -76}, {-62, -76}, {-62, -180}, {-100, -180}}, color = {0, 0, 127}));

  connect(adaptor_2.absolutePressure_b, absolutePressure_2) annotation(
    Line(points = {{60, -44}, {66, -44}, {66, -20}, {100, -20}, {100, -20}}, color = {0, 0, 127}));
  connect(adaptor_2.temperature_b, temperature_2) annotation(
    Line(points = {{60, -48}, {70, -48}, {70, -40}, {100, -40}, {100, -40}}, color = {0, 0, 127}));
  connect(adaptor_2.specificEnthalpy_outflow_b, specificEnthalpy_outflow_2) annotation(
    Line(points = {{60, -52}, {84, -52}, {84, -60}, {100, -60}, {100, -60}}, color = {0, 0, 127}));
  connect(adaptor_2.massFractions_outflow_b[:], massFractions_outflow_2[:]) annotation(
    Line(points = {{60, -56}, {80, -56}, {80, -80}, {100, -80}, {100, -80}}, color = {0, 0, 127}, thickness = 0.5));

  connect(adaptor_2.massFractions_mix_b[:], massFractions_mix_2[:]) annotation(
    Line(points = {{60, -64}, {76, -64}, {76, -120}, {100, -120}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_2.specificEnthalpy_mix_b, specificEnthalpy_mix_2) annotation(
    Line(points = {{60, -68}, {72, -68}, {72, -140}, {100, -140}}, color = {0, 0, 127}));
  connect(adaptor_2.massFlowRate_b, massFlowRate_2) annotation(
    Line(points = {{60, -72}, {68, -72}, {68, -160}, {100, -160}}, color = {0, 0, 127}));
  connect(adaptor_2.enthalpyFlowRate_b, heatFlowRate_2) annotation(
    Line(points = {{60, -76}, {64, -76}, {64, -180}, {100, -180}}, color = {0, 0, 127}));

end CausalTwoPortTransport_TFAOOOOTIIII;