within AICE.Blocks.Fluid.Compressible.Machines;

model FixGeometryTurboCharger_TFAIIIITOOOO
  replaceable package Medium = AICE.Media.IdealGases.Examples.Sample5MixtureGas;
  //Modelica.Media.Interfaces.PartialMedium;
  extends AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.CausalTwoPortTransport_TFAIIIITOOOO;
  extends AICE.Icons.Fluid.TurboCharger;

  extends AICE.Fluid.Machines.BaseClasses.TCParameters;
  parameter Modelica.SIunits.Area Av_wastegate;

  AICE.Fluid.Machines.CompressorFixGeom compressorAcausal(redeclare replaceable package Medium = Medium, EfficiencyMap = EfficiencyMap_comp, FluidMachineType = FluidMachineType_comp, MapType = MapType_comp, MassFlowMap = MassFlowMap_comp, allowFlowReversal = false, dia_in = dia_in_comp) annotation(
    Placement(visible = true, transformation(origin = {0, 68}, extent = {{-10, 10}, {10, -10}}, rotation = 0)));

  AICE.Fluid.Machines.TurbineFixGeomWG turbineAcausal(redeclare replaceable package Medium = Medium, EfficiencyMap = EfficiencyMap_turb, FluidMachineType = FluidMachineType_turb, MapType = MapType_turb, MassFlowMap = MassFlowMap_turb, allowFlowReversal = false, dia_in = dia_in_turb, Av_wastegate = Av_wastegate) annotation(
    Placement(visible = true, transformation(origin = {0, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));

  Modelica.Mechanics.Rotational.Components.Inertia shaftAcausal(J = Inertia, w(fixed = true, start = w_shaft_init)) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Interfaces.RealInput wasteGateOpening annotation(
    Placement(visible = true, transformation(origin = {0, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {0, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  Modelica.Mechanics.Rotational.Sensors.PowerSensor power_comp annotation(
    Placement(visible = true, transformation(origin = {0, 34}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  Modelica.Mechanics.Rotational.Sensors.PowerSensor power_turb annotation(
    Placement(visible = true, transformation(origin = {0, -28}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));

equation
  connect(compressorAcausal.flange_a, power_comp.flange_b) annotation(
    Line(points = {{0, 58}, {0, 58}, {0, 44}, {0, 44}}));
  connect(shaftAcausal.flange_b, power_comp.flange_a) annotation(
    Line(points = {{0, 10}, {0, 10}, {0, 24}, {0, 24}}));
  connect(shaftAcausal.flange_a, power_turb.flange_b) annotation(
    Line(points = {{0, -10}, {0, -10}, {0, -18}, {0, -18}}));
  connect(turbineAcausal.flange_a, power_turb.flange_a) annotation(
    Line(points = {{0, -50}, {0, -50}, {0, -38}, {0, -38}}));
  connect(wasteGateOpening, turbineAcausal.WasgeGateOpening) annotation(
    Line(points = {{0, -100}, {0, -100}, {0, -70}, {0, -70}}, color = {0, 0, 127}));
  connect(adaptor_a.port_a, compressorAcausal.port_a) annotation(
    Line(points = {{-32, 60}, {-20, 60}, {-20, 68}, {-10, 68}, {-10, 68}}, color = {0, 127, 255}));
  connect(adaptor_b.port_a, compressorAcausal.port_b) annotation(
    Line(points = {{40, 60}, {28, 60}, {28, 68}, {10, 68}, {10, 68}}, color = {0, 127, 255}));
  connect(adaptor_1.port_a, turbineAcausal.port_a) annotation(
    Line(points = {{-32, -60}, {-10, -60}, {-10, -60}, {-10, -60}}, color = {0, 127, 255}));
  connect(adaptor_2.port_a, turbineAcausal.port_b) annotation(
    Line(points = {{40, -60}, {10, -60}, {10, -60}, {10, -60}}, color = {0, 127, 255}));

  annotation(
    Icon(coordinateSystem(initialScale = 0.5, extent = {{-100, -200}, {100, 200}})),
    Diagram(coordinateSystem(extent = {{-100, -200}, {100, 200}}, initialScale = 0.5)));
end FixGeometryTurboCharger_TFAIIIITOOOO;
