within AICE.Blocks.Fluid.Compressible.Pipes;

model CatalystConversionEfficiency_TFAOOTII
  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;
  //extends AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.CausalTwoPortTransport_TFAOOTII;
  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_a;
  // FluidPort_TFAOTI_a;
  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_b;
  //FluidPort_TFAOTI_b;
  extends AICE.Icons.Fluid.Catalyst;
  parameter Real nParallel;
  parameter Modelica.SIunits.Length length, diameter;
  parameter Modelica.SIunits.Temperature T_start;
  parameter Modelica.SIunits.Pressure p_init;
  parameter Modelica.SIunits.MassFlowRate m_flow_start;
  parameter Real T_vs_eta_conv[:, :];
  parameter Modelica.SIunits.HeatCapacity HeatCapacity_core;
  parameter Modelica.SIunits.HeatCapacity HeatCapacity_can;
  parameter Modelica.SIunits.ThermalConductivity ThermalConductivity_core;
  //(unit="W/(m.K)")
  parameter Modelica.SIunits.ThermalConductance ThermalConductance_ins "Wrapping Insulator Thermal Conductance";
  parameter Modelica.SIunits.Area area_convection = diameter * nParallel ^ 0.5 * 5 * length "Can Surface Area for Convection";
  parameter AICE.Blocks.Types.Energy energy_port_a = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_port_b = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_heatport_a = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_heatport_b = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_heatport_amb = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_a(redeclare replaceable package Medium = Medium, energy = energy_port_a) annotation(
    Placement(visible = true, transformation(origin = {-54, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_b(redeclare replaceable package Medium = Medium, energy = energy_port_b) annotation(
    Placement(visible = true, transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)));
  AICE.Fluid.Pipes.BaseClasses.CatalystConversionEfficiency_NoTracer acausalModel(redeclare replaceable package Medium = Medium,HeatCapacity_can = HeatCapacity_can, HeatCapacity_core = HeatCapacity_core, T_start = T_start, T_vs_eta_conv = T_vs_eta_conv, ThermalConductance_ins = ThermalConductance_ins, ThermalConductivity_core = ThermalConductivity_core, area_convection = area_convection, diameter = diameter, length = length, m_flow_start = m_flow_start, nParallel = nParallel, p_init = p_init) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI heatadaptor_can_b(energy = energy_heatport_b) annotation(
    Placement(visible = true, transformation(origin = {30, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AITO adaptor_can_amb(energy = energy_heatport_amb) annotation(
    Placement(visible = true, transformation(origin = {10, 64}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI heatadaptor_can_a(energy = energy_heatport_a) annotation(
    Placement(visible = true, transformation(origin = {-30, 50}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.TemperatureOutput temperature_can_b annotation(
    Placement(visible = true, transformation(origin = {60, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {60, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Interfaces.HeatFlowRateInput heatFlowRate_can_b annotation(
    Placement(visible = true, transformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {40, 100}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
  AICE.Blocks.Interfaces.HeatFlowRateOutput heatFlowRate_amb annotation(
    Placement(visible = true, transformation(origin = {20, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {20, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Interfaces.RealInput htc_input annotation(
    Placement(visible = true, transformation(origin = {-20, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {-20, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.TemperatureOutput temperature_can_a annotation(
    Placement(visible = true, transformation(origin = {-40, 100}, extent = {{10, -10}, {-10, 10}}, rotation = -90), iconTransformation(origin = {-40, 100}, extent = {{10, -10}, {-10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.HeatFlowRateInput heatFlowRate_can_a annotation(
    Placement(visible = true, transformation(origin = {-60, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {-60, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.TemperatureInput temperature_amb annotation(
    Placement(visible = true, transformation(origin = {0, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {0, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
equation
  connect(adaptor_a.absolutePressure_b, absolutePressure_a) annotation(
    Line(points = {{-64, 16}, {-64, 80}, {-100, 80}}, color = {0, 0, 127}));
  connect(adaptor_a.temperature_b, temperature_a) annotation(
    Line(points = {{-64, 12}, {-70, 12}, {-70, 60}, {-100, 60}}, color = {0, 0, 127}));
  connect(adaptor_a.specificEnthalpy_outflow_b, specificEnthalpy_outflow_a) annotation(
    Line(points = {{-64, 8}, {-74, 8}, {-74, 40}, {-100, 40}, {-100, 40}}, color = {0, 0, 127}));
  connect(adaptor_a.massFractions_outflow_b[:], massFractions_outflow_a[:]) annotation(
    Line(points = {{-64, 4}, {-80, 4}, {-80, 20}, {-100, 20}, {-100, 20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_a.massFractions_mix_b[:], massFractions_mix_a[:]) annotation(
    Line(points = {{-64, -4}, {-80, -4}, {-80, -20}, {-100, -20}, {-100, -20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_a.specificEnthalpy_mix_b, specificEnthalpy_mix_a) annotation(
    Line(points = {{-64, -8}, {-76, -8}, {-76, -40}, {-100, -40}, {-100, -40}}, color = {0, 0, 127}));
  connect(adaptor_a.massFlowRate_b, massFlowRate_a) annotation(
    Line(points = {{-64, -12}, {-72, -12}, {-72, -60}, {-100, -60}, {-100, -60}}, color = {0, 0, 127}));
  connect(adaptor_a.enthalpyFlowRate_b, enthalpyFlowRate_a) annotation(
    Line(points = {{-64, -16}, {-68, -16}, {-68, -80}, {-100, -80}, {-100, -80}}, color = {0, 0, 127}));
  connect(adaptor_b.absolutePressure_b, absolutePressure_b) annotation(
    Line(points = {{60, 16}, {70, 16}, {70, 80}, {100, 80}, {100, 80}}, color = {0, 0, 127}));
  connect(adaptor_b.temperature_b, temperature_b) annotation(
    Line(points = {{60, 12}, {74, 12}, {74, 60}, {100, 60}, {100, 60}}, color = {0, 0, 127}));
  connect(adaptor_b.specificEnthalpy_outflow_b, specificEnthalpy_outflow_b) annotation(
    Line(points = {{60, 8}, {80, 8}, {80, 40}, {100, 40}, {100, 40}}, color = {0, 0, 127}));
  connect(adaptor_b.massFractions_outflow_b[:], massFractions_outflow_b[:]) annotation(
    Line(points = {{60, 4}, {88, 4}, {88, 20}, {100, 20}, {100, 20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_b.massFractions_mix_b[:], massFractions_mix_b[:]) annotation(
    Line(points = {{60, -4}, {88, -4}, {88, -20}, {100, -20}, {100, -20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_b.specificEnthalpy_mix_b, specificEnthalpy_mix_b) annotation(
    Line(points = {{60, -8}, {80, -8}, {80, -40}, {100, -40}, {100, -40}}, color = {0, 0, 127}));
  connect(adaptor_b.massFlowRate_b, massFlowRate_b) annotation(
    Line(points = {{60, -12}, {76, -12}, {76, -60}, {100, -60}, {100, -60}}, color = {0, 0, 127}));
  connect(adaptor_b.enthalpyFlowRate_b, enthalpyFlowRate_b) annotation(
    Line(points = {{60, -16}, {72, -16}, {72, -80}, {100, -80}, {100, -80}}, color = {0, 0, 127}));
  connect(adaptor_can_amb.port_a, acausalModel.heatport_ambient) annotation(
    Line(points = {{10, 54}, {10, 37}, {0, 37}, {0, 20}}, color = {191, 0, 0}));
  connect(adaptor_a.port_a, acausalModel.port_a) annotation(
    Line(points = {{-44, 0}, {-20, 0}, {-20, 0}, {-20, 0}}, color = {0, 127, 255}));
  connect(adaptor_b.port_a, acausalModel.port_b) annotation(
    Line(points = {{40, 0}, {20, 0}, {20, 0}, {20, 0}}, color = {0, 127, 255}));
  connect(heatadaptor_can_a.port_a, acausalModel.heatport_can_a) annotation(
    Line(points = {{-20, 50}, {-20, 12}}, color = {191, 0, 0}));
  connect(heatadaptor_can_b.port_a, acausalModel.heatport_can_b) annotation(
    Line(points = {{20, 50}, {20, 50}, {20, 12}, {20, 12}}, color = {191, 0, 0}));
  connect(heatadaptor_can_a.temperature_b, temperature_can_a) annotation(
    Line(points = {{-40, 56}, {-40, 56}, {-40, 100}, {-40, 100}}, color = {0, 0, 127}));
  connect(heatadaptor_can_a.heatFlowRate_b, heatFlowRate_can_a) annotation(
    Line(points = {{-40, 44}, {-60, 44}, {-60, 100}, {-60, 100}}, color = {0, 0, 127}));
  connect(heatadaptor_can_b.heatFlowRate_b, heatFlowRate_can_b) annotation(
    Line(points = {{40, 44}, {40, 44}, {40, 100}, {40, 100}}, color = {0, 0, 127}));
  connect(heatadaptor_can_b.temperature_b, temperature_can_b) annotation(
    Line(points = {{40, 56}, {60, 56}, {60, 100}, {60, 100}}, color = {0, 0, 127}));
  connect(htc_input, acausalModel.htcInput) annotation(
    Line(points = {{-20, 100}, {-20, 100}, {-20, 60}, {-12, 60}, {-12, 20}, {-12, 20}}, color = {0, 0, 127}));
  connect(adaptor_can_amb.temperature_b, temperature_amb) annotation(
    Line(points = {{4, 74}, {0, 74}, {0, 100}, {0, 100}}, color = {0, 0, 127}));
  connect(adaptor_can_amb.heatFlowRate_b, heatFlowRate_amb) annotation(
    Line(points = {{16, 74}, {20, 74}, {20, 100}, {20, 100}}, color = {0, 0, 127}));
end CatalystConversionEfficiency_TFAOOTII;