within AICE.Blocks.Fluid.Compressible.Sources.BaseClasses;

block PartialSource_TFAOTI
  extends Interfaces.ThermoFluidPort_AOTI;

  parameter AICE.Blocks.Types.Energy energy_port = AICE.Blocks.Types.Energy.Sink
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  replaceable Modelica.Fluid.Sources.BaseClasses.PartialSource acausalModel(
    redeclare replaceable package Medium = Medium,
    nPorts = 1
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)
    )
  );

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor(
    redeclare replaceable package Medium = Medium,
    energy = energy_port
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)
    )
  );

equation

  connect(acausalModel.ports[1], adaptor.port_a) annotation(
    Line(points = {{+20, 0}, {+40, 0}}, color = {0, 127, 255})
  );
  connect(adaptor.specificEnthalpy_outflow_b, specificEnthalpy_outflow) annotation(
    Line(points = {{+60,  +8}, {+76,  +8}, {+76, +40}, {+100, +40}}, color = {0, 0, 127})
  );
  connect(adaptor.massFractions_outflow_b[:], massFractions_outflow[:]) annotation(
    Line(points = {{+60,  +4}, {+80,  +4}, {+80, +20}, {+100, +20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor.massFractions_mix_b[:], massFractions_mix[:]) annotation(
    Line(points = {{+60,  -4}, {+80,  -4}, {+80, -20}, {+100, -20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor.specificEnthalpy_mix_b, specificEnthalpy_mix) annotation(
    Line(points = {{+60,  -8}, {+76,  -8}, {+76, -40}, {+100, -40}}, color = {0, 0, 127})
  );
  connect(adaptor.absolutePressure_b, absolutePressure) annotation(
    Line(points = {{60, 16}, {64, 16}, {64, 80}, {100, 80}, {100, 80}}, color = {0, 0, 127}));
  connect(adaptor.temperature_b, temperature) annotation(
    Line(points = {{60, 12}, {70, 12}, {70, 60}, {92, 60}, {92, 60}, {100, 60}}, color = {0, 0, 127}));
  connect(adaptor.massFlowRate_b, massFlowRate) annotation(
    Line(points = {{60, -12}, {72, -12}, {72, -58}, {100, -58}, {100, -60}}, color = {0, 0, 127}));
  connect(adaptor.enthalpyFlowRate_b, enthalpyFlowRate) annotation(
    Line(points = {{60, -16}, {68, -16}, {68, -80}, {100, -80}, {100, -80}}, color = {0, 0, 127}));
end PartialSource_TFAOTI;