within AICE.Blocks.Fluid.Compressible.Valves.BaseClasses;

partial block PartialValve

  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;

  parameter AICE.Blocks.Types.Energy energy_port_a = AICE.Blocks.Types.Energy.Sink
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  parameter AICE.Blocks.Types.Energy energy_port_b = AICE.Blocks.Types.Energy.Source
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  Modelica.Blocks.Interfaces.RealInput opening(
    min=0, max=1
  ) "Valve position in the range 0..1"
  annotation (
    Placement(
      transformation(
        origin={0,90},
        extent={{-20,-20},{20,20}},
        rotation=270
      ), iconTransformation(
        origin={0,80},
        extent={{-20,-20},{20,20}},
        rotation=270
      )
    )
  );

  replaceable Modelica.Fluid.Valves.BaseClasses.PartialValve acausalModel(
    redeclare replaceable package Medium = Medium
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)
    )
  );

equation

  connect(opening, acausalModel.opening) annotation(
    Line(points = {{0, 90}, {0, 20}}, color = {0, 0, 127})
  );

end PartialValve;
