within AICE.Blocks.Fluid.Compressible.Valves.BaseClasses;

partial block PartialValve_TFAIITOO

  extends Interfaces.ThermoFluidPort_AITO_a;
  extends Interfaces.ThermoFluidPort_AITO_b;

  extends PartialValve;

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AITO adaptor_a(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_a
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)
    )
  );

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AITO adaptor_b(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_b
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)
    )
  );

equation
  connect(absolutePressure_a, adaptor_a.absolutePressure_b) annotation(
    Line(points = {{-100, 80}, {-66, 80}, {-66, 16}, {-60, 16}, {-60, 16}}, color = {0, 0, 127}));
  connect(temperature_a, adaptor_a.temperature_b) annotation(
    Line(points = {{-100, 60}, {-74, 60}, {-74, 12}, {-60, 12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_a, adaptor_a.specificEnthalpy_mix_b) annotation(
    Line(points = {{-100, 40}, {-80, 40}, {-80, 8}, {-60, 8}, {-60, 8}, {-60, 8}}, color = {0, 0, 127}));
  connect(massFractions_mix_a[:], adaptor_a.massFractions_mix_b[:]) annotation(
    Line(points = {{-100, 20}, {-86, 20}, {-86, 4}, {-60, 4}, {-60, 4}}, color = {0, 0, 127}, thickness = 0.5));

  connect(adaptor_a.specificEnthalpy_outflow_b, specificEnthalpy_outflow_a) annotation(
    Line(points = {{-60, -8}, {-80, -8}, {-80, -40}, {-100, -40}, {-100, -40}}, color = {0, 0, 127}));
  connect(adaptor_a.massFlowRate_b, massFlowRate_a) annotation(
    Line(points = {{-60, -12}, {-74, -12}, {-74, -60}, {-92, -60}, {-92, -60}, {-100, -60}}, color = {0, 0, 127}));
  connect(adaptor_a.enthalpyFlowRate_b, enthalpyFlowRate_a) annotation(
    Line(points = {{-60, -16}, {-66, -16}, {-66, -80}, {-100, -80}, {-100, -80}}, color = {0, 0, 127}));
  connect(adaptor_a.massFractions_outflow_b[:], massFractions_outflow_a[:]) annotation(
    Line(points = {{-60, -4}, {-86, -4}, {-86, -20}, {-100, -20}}, color = {0, 0, 127}, thickness = 0.5));

  connect(absolutePressure_b, adaptor_b.absolutePressure_b) annotation(
    Line(points = {{100, 80}, {66, 80}, {66, 16}, {60, 16}, {60, 16}}, color = {0, 0, 127}));
  connect(temperature_b, adaptor_b.temperature_b) annotation(
    Line(points = {{100, 60}, {74, 60}, {74, 12}, {60, 12}, {60, 12}, {60, 12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_b, adaptor_b.specificEnthalpy_mix_b) annotation(
    Line(points = {{100, 40}, {80, 40}, {80, 8}, {60, 8}, {60, 8}}, color = {0, 0, 127}));
  connect(massFractions_mix_b[:], adaptor_b.massFractions_mix_b) annotation(
    Line(points = {{100, 20}, {88, 20}, {88, 4}, {60, 4}, {60, 4}}, color = {0, 0, 127}, thickness = 0.5));

  connect(adaptor_b.massFractions_outflow_b[:], massFractions_outflow_b[:]) annotation(
    Line(points = {{60, -4}, {88, -4}, {88, -20}, {98, -20}, {98, -20}, {100, -20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(adaptor_b.specificEnthalpy_outflow_b, specificEnthalpy_outflow_b) annotation(
    Line(points = {{60, -8}, {80, -8}, {80, -40}, {100, -40}, {100, -40}}, color = {0, 0, 127}));
  connect(adaptor_b.massFlowRate_b, massFlowRate_b) annotation(
    Line(points = {{60, -12}, {74, -12}, {74, -60}, {100, -60}, {100, -60}}, color = {0, 0, 127}));
  connect(adaptor_b.enthalpyFlowRate_b, enthalpyFlowRate_b) annotation(
    Line(points = {{60, -16}, {66, -16}, {66, -80}, {100, -80}, {100, -80}}, color = {0, 0, 127}));

  connect(adaptor_a.port_a, acausalModel.port_a) annotation(
    Line(points = {{-40, 0}, {-20, 0}, {-20, 0}, {-20, 0}}, color = {0, 127, 255}));
  connect(acausalModel.port_b, adaptor_b.port_a) annotation(
    Line(points = {{20, 0}, {40, 0}, {40, 0}, {40, 0}}, color = {0, 127, 255}));
end PartialValve_TFAIITOO;
