within AICE.Blocks.Fluid.Incompressible.Fittings.BaseClasses;

partial block PartialTeeJunction_TFAOOOTIII_down

  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_1;
  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_2;
  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_3_down;

  extends PartialTeeJunction_down;

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_1(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_1
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, +20}}, rotation = 0)
    )
  );

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_2(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_2
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, +20}}, rotation = 0)
    )
  );

  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_3(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_3
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, -50}, extent = {{+10, +20}, {-10, -20}}, rotation = 90)
    )
  );

equation
  connect(acausalModel.port_1, adaptor_1.port_a) annotation(
    Line(points = {{-20, 0}, {-40, 0}, {-40, 0}, {-40, 0}}, color = {0, 127, 255}));
  connect(acausalModel.port_2, adaptor_2.port_a) annotation(
    Line(points = {{20, 0}, {38, 0}, {38, 0}, {40, 0}, {40, 0}}, color = {0, 127, 255}));
  connect(acausalModel.port_3, adaptor_3.port_a) annotation(
    Line(points = {{0, -20}, {0, -20}, {0, -40}, {0, -40}}, color = {0, 127, 255}));

  connect(absolutePressure_1, adaptor_1.absolutePressure_b) annotation(
    Line(points = {{-100, 80}, {-86, 80}, {-86, 64}, {-72, 64}, {-72, 16}, {-60, 16}}, color = {0, 0, 127}));
  connect(temperature_1, adaptor_1.temperature_b) annotation(
    Line(points = {{-100, 60}, {-80, 60}, {-80, 60}, {-76, 60}, {-76, 12}, {-60, 12}, {-60, 12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_outflow_1, adaptor_1.specificEnthalpy_outflow_b) annotation(
    Line(points = {{-100, 40}, {-80, 40}, {-80, 10}, {-80, 10}, {-80, 8}, {-60, 8}, {-60, 8}}, color = {0, 0, 127}));
  connect(massFractions_outflow_1[:], adaptor_1.massFractions_outflow_b[:]) annotation(
    Line(points = {{-100, 20}, {-84, 20}, {-84, 4}, {-60, 4}, {-60, 4}, {-60, 4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(enthalpyFlowRate_1, adaptor_1.enthalpyFlowRate_b) annotation(
    Line(points = {{-100, -80}, {-68, -80}, {-68, -16}, {-60, -16}, {-60, -16}, {-60, -16}}, color = {0, 0, 127}));
  connect(massFlowRate_1, adaptor_1.massFlowRate_b) annotation(
    Line(points = {{-100, -60}, {-74, -60}, {-74, -12}, {-60, -12}, {-60, -12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_1, adaptor_1.specificEnthalpy_mix_b) annotation(
    Line(points = {{-100, -40}, {-80, -40}, {-80, -8}, {-60, -8}, {-60, -8}, {-60, -8}}, color = {0, 0, 127}));
  connect(massFractions_mix_1[:], adaptor_1.massFractions_mix_b[:]) annotation(
    Line(points = {{-100, -20}, {-84, -20}, {-84, -4}, {-60, -4}, {-60, -4}, {-60, -4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(absolutePressure_2, adaptor_2.absolutePressure_b) annotation(
    Line(points = {{100, 80}, {86, 80}, {86, 64}, {74, 64}, {74, 16}, {60, 16}}, color = {0, 0, 127}));
  connect(temperature_2, adaptor_2.temperature_b) annotation(
    Line(points = {{100, 60}, {89, 60}, {89, 58}, {78, 58}, {78, 12}, {60, 12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_outflow_2, adaptor_2.specificEnthalpy_outflow_b) annotation(
    Line(points = {{100, 40}, {82, 40}, {82, 8}, {60, 8}}, color = {0, 0, 127}));
  connect(massFractions_outflow_2[:], adaptor_2.massFractions_outflow_b[:]) annotation(
    Line(points = {{100, 20}, {86, 20}, {86, 4}, {60, 4}, {60, 4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(enthalpyFlowRate_2, adaptor_2.enthalpyFlowRate_b) annotation(
    Line(points = {{100, -80}, {70, -80}, {70, -16}, {60, -16}, {60, -16}}, color = {0, 0, 127}));
  connect(massFlowRate_2, adaptor_2.massFlowRate_b) annotation(
    Line(points = {{100, -60}, {76, -60}, {76, -12}, {60, -12}, {60, -12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_2, adaptor_2.specificEnthalpy_mix_b) annotation(
    Line(points = {{100, -40}, {82, -40}, {82, -8}, {60, -8}, {60, -8}, {60, -8}}, color = {0, 0, 127}));
  connect(massFractions_mix_2[:], adaptor_2.massFractions_mix_b[:]) annotation(
    Line(points = {{100, -20}, {86, -20}, {86, -4}, {60, -4}, {60, -4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(enthalpyFlowRate_3, adaptor_3.enthalpyFlowRate_b) annotation(
    Line(points = {{-80, -100}, {-80, -100}, {-80, -84}, {-64, -84}, {-64, -70}, {-16, -70}, {-16, -60}, {-16, -60}}, color = {0, 0, 127}));
  connect(massFlowRate_3, adaptor_3.massFlowRate_b) annotation(
    Line(points = {{-60, -100}, {-60, -100}, {-60, -74}, {-12, -74}, {-12, -60}, {-12, -60}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_3, adaptor_3.specificEnthalpy_mix_b) annotation(
    Line(points = {{-40, -100}, {-40, -100}, {-40, -80}, {-8, -80}, {-8, -60}, {-8, -60}}, color = {0, 0, 127}));
  connect(massFractions_mix_3[:], adaptor_3.massFractions_mix_b[:]) annotation(
    Line(points = {{-20, -100}, {-20, -100}, {-20, -86}, {-4, -86}, {-4, -60}, {-4, -60}}, color = {0, 0, 127}, thickness = 0.5));
  connect(absolutePressure_3, adaptor_3.absolutePressure_b) annotation(
    Line(points = {{80, -100}, {80, -100}, {80, -84}, {64, -84}, {64, -70}, {16, -70}, {16, -60}, {16, -60}, {16, -60}}, color = {0, 0, 127}));
  connect(temperature_3, adaptor_3.temperature_b) annotation(
    Line(points = {{60, -100}, {60, -100}, {60, -74}, {12, -74}, {12, -60}, {12, -60}}, color = {0, 0, 127}));
  connect(specificEnthalpy_outflow_3, adaptor_3.specificEnthalpy_outflow_b) annotation(
    Line(points = {{40, -100}, {40, -100}, {40, -80}, {8, -80}, {8, -60}, {8, -60}}, color = {0, 0, 127}));
  connect(massFractions_outflow_3[:], adaptor_3.massFractions_outflow_b[:]) annotation(
    Line(points = {{20, -100}, {20, -100}, {20, -86}, {4, -86}, {4, -60}, {4, -60}}, color = {0, 0, 127}, thickness = 0.5));
end PartialTeeJunction_TFAOOOTIII_down;
