within AICE.Blocks.Fluid.Incompressible.Fittings.BaseClasses;

partial model TeeJunctionVolumeParameters

  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;

  outer Modelica.Fluid.System system;

  parameter SI.Volume V "Volume";

  // Assumptions
  parameter Modelica.Fluid.Types.Dynamics energyDynamics=system.energyDynamics
    "Formulation of energy balance"
    annotation(Evaluate=true, Dialog(tab = "Assumptions", group="Dynamics"));

  parameter Modelica.Fluid.Types.Dynamics massDynamics=system.massDynamics
    "Formulation of mass balance"
    annotation(Evaluate=true, Dialog(tab = "Assumptions", group="Dynamics"));

  // Initialization
  parameter Medium.AbsolutePressure p_start = system.p_start "Start value of pressure"
  annotation(Dialog(tab = "Initialization"));

  parameter Boolean use_T_start = true "= true, use T_start, otherwise h_start"
  annotation(Dialog(tab = "Initialization"), Evaluate=true);

  parameter Medium.Temperature T_start = (
    if use_T_start then
      system.T_start
    else
      Medium.temperature_phX(p_start,h_start,X_start)
  ) "Start value of temperature"
  annotation(Dialog(tab = "Initialization", enable = use_T_start));

  parameter Medium.SpecificEnthalpy h_start = (
    if use_T_start then
      Medium.specificEnthalpy_pTX(p_start, T_start, X_start)
    else
      Medium.h_default
  ) "Start value of specific enthalpy"
  annotation(Dialog(tab = "Initialization", enable = not use_T_start));

  parameter Medium.MassFraction X_start[Medium.nX] = Medium.X_default
  "Start value of mass fractions m_i/m"
  annotation (
    Dialog(
      tab="Initialization" // ,
      // enable=Medium.nXi > 0
    )
  );

end TeeJunctionVolumeParameters;
