within AICE.Blocks.Fluid.Incompressible.Interfaces;

partial model FluidPort_AOTI

  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;

  Blocks.Interfaces.AbsolutePressureOutput absolutePressure annotation(
    Placement(
      visible = true,
      transformation(origin = {100, +60}, extent = {{-10, -10}, {+10, 10}}, rotation = 0),
      iconTransformation(origin = {100, +60}, extent = {{-10, -10}, {+10, 10}}, rotation = 0)
    )
  );

  Blocks.Interfaces.SpecificEnthalpyOutput specificEnthalpy_outflow annotation(
    Placement(
      visible = true,
      transformation(origin = {100, +40}, extent = {{-10, -10}, {+10, 10}}, rotation = 0),
      iconTransformation(origin = {100, +40}, extent = {{-10, -10}, {+10, 10}}, rotation = 0)
    )
  );

  Blocks.Interfaces.MassFractionsOutput[Medium.nXi] massFractions_outflow annotation(
    Placement(
      visible = true,
      transformation(origin = {100, +20}, extent = {{-10, -10}, {+10, 10}}, rotation = 0),
      iconTransformation(origin = {100, +20}, extent = {{-10, -10}, {+10, 10}}, rotation = 0)
    )
  );


  Blocks.Interfaces.MassFractionsInput[Medium.nXi] massFractions_mix annotation(
    Placement(
      visible = true,
      transformation(origin = {100, -20}, extent = {{+10, -10}, {-10, 10}}, rotation = 0),
      iconTransformation(origin = {100, -20}, extent = {{+10, -10}, {-10, 10}}, rotation = 0)
    )
  );

  Blocks.Interfaces.SpecificEnthalpyInput specificEnthalpy_mix annotation(
    Placement(
      visible = true,
      transformation(origin = {100, -40}, extent = {{+10, -10}, {-10, 10}}, rotation = 0),
      iconTransformation(origin = {100, -40}, extent = {{+10, -10}, {-10, 10}}, rotation = 0)
    )
  );

  Blocks.Interfaces.VolumeFlowRateInput volumeFlowRate annotation(
    Placement(
      visible = true,
      transformation(origin = {100, -60}, extent = {{+10, -10}, {-10, 10}}, rotation = 0),
      iconTransformation(origin = {100, -60}, extent = {{+10, -10}, {-10, 10}}, rotation = 0)
    )
  );

end FluidPort_AOTI;