within AICE.Blocks.Fluid.Incompressible.Interfaces;

block PartialTwoPortTransport_AOITIO
  extends Interfaces.FluidPort_AOTI_a;
  extends Interfaces.FluidPort_AITO_b;

  extends BaseClasses.PartialTwoPortTransport;

  AICE.Blocks.Fluid.Incompressible.Interfaces.Adaptors.Adaptor_AOTI adaptor_a(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_a
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)
    )
  );

  AICE.Blocks.Fluid.Incompressible.Interfaces.Adaptors.Adaptor_AITO adaptor_b(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_b
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)
    )
  );

equation

  connect(acausalModel.port_a, adaptor_a.port_a) annotation(
    Line(points = {{-20, 0}, {-40, 0}}, color = {0, 127, 255})
  );
  connect(acausalModel.port_b, adaptor_b.port_a) annotation(
    Line(points = {{+20, 0}, {+40, 0}}, color = {0, 127, 255})
  );

  connect(adaptor_a.absolutePressure_b, absolutePressure_a) annotation(
    Line(points = {{-60, +12}, {-72, +12}, {-72, +60}, {-100, +60}}, color = {0, 0, 127})
  );
  connect(adaptor_a.specificEnthalpy_outflow_b, specificEnthalpy_outflow_a) annotation(
    Line(points = {{-60,  +8}, {-76,  +8}, {-76, +40}, {-100, +40}}, color = {0, 0, 127})
  );
  connect(adaptor_a.massFractions_outflow_b[:], massFractions_outflow_a[:]) annotation(
    Line(points = {{-60,  +4}, {-80,  +4}, {-80, +20}, {-100, +20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_a.massFractions_mix_b[:], massFractions_mix_a[:]) annotation(
    Line(points = {{-60,  -4}, {-80,  -4}, {-80, -20}, {-100, -20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_a.specificEnthalpy_mix_b, specificEnthalpy_mix_a) annotation(
    Line(points = {{-60,  -8}, {-76,  -8}, {-76, -40}, {-100, -40}}, color = {0, 0, 127})
  );
  connect(adaptor_a.volumeFlowRate_b, volumeFlowRate_a) annotation(
    Line(points = {{-60, -12}, {-72, -12}, {-72, -60}, {-100, -60}}, color = {0, 0, 127})
  );

  connect(adaptor_b.absolutePressure_b, absolutePressure_b) annotation(
    Line(points = {{+60, +12}, {+72, +12}, {+72, +60}, {+100, +60}}, color = {0, 0, 127})
  );
  connect(adaptor_b.specificEnthalpy_mix_b, specificEnthalpy_mix_b) annotation(
    Line(points = {{+60,  +8}, {+76,  +8}, {+76, +40}, {+100, +40}}, color = {0, 0, 127})
  );
  connect(adaptor_b.massFractions_mix_b[:], massFractions_mix_b[:]) annotation(
    Line(points = {{+60,  +4}, {+80,  +4}, {+80, +20}, {+100, +20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_b.massFractions_outflow_b[:], massFractions_outflow_b[:]) annotation(
    Line(points = {{+60,  -4}, {+80,  -4}, {+80, -20}, {+100, -20}}, color = {0, 0, 127}, thickness = 0.5)
  );
  connect(adaptor_b.specificEnthalpy_outflow_b, specificEnthalpy_outflow_b) annotation(
    Line(points = {{+60,  -8}, {+76,  -8}, {+76, -40}, {+100, -40}}, color = {0, 0, 127})
  );
  connect(adaptor_b.volumeFlowRate_b, volumeFlowRate_b) annotation(
    Line(points = {{+60, -12}, {+72, -12}, {+72, -60}, {+100, -60}}, color = {0, 0, 127})
  );

end PartialTwoPortTransport_AOITIO;
