within AICE.Blocks.Fluid.Incompressible.Machines.BaseClasses;

partial block PartialPump

  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;

  parameter AICE.Blocks.Types.Energy energy_shaft = AICE.Blocks.Types.Energy.Sink
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  parameter AICE.Blocks.Types.Energy energy_port_a = AICE.Blocks.Types.Energy.Sink
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  parameter AICE.Blocks.Types.Energy energy_port_b = AICE.Blocks.Types.Energy.Source
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  AICE.Blocks.Interfaces.AngularVelocityInput angularVelocity
  annotation(
    Placement(
      visible = true,
      transformation(origin = {+60, +100}, extent = {{-10, -10}, {+10, 10}}, rotation = -90),
      iconTransformation(origin = {+60, +100}, extent = {{-10, -10}, {+10, 10}}, rotation = -90)
    )
  );

  AICE.Blocks.Interfaces.TorqueOutput torque
  annotation(
    Placement(
      visible = true,
      transformation(origin = {-60, +100}, extent = {{+10, -10}, {-10, 10}}, rotation = -90),
      iconTransformation(origin = {-60, +100}, extent = {{+10, -10}, {-10, 10}}, rotation = -90)
    )
  );

  replaceable AICE.Fluid.Machines.BaseClasses.PartialPump acausalModel(
    redeclare replaceable package Medium = Medium
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  AICE.Blocks.Mechanics.Rotational.Interfaces.Adaptors.Adaptor_AITO adaptor_shaft(
    energy = energy_shaft
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 60}, extent = {{-10, 20}, {10, -20}}, rotation = 90)
    )
  );

equation

  connect(adaptor_shaft.flange_a, acausalModel.shaft) annotation(
    Line(points = {{0, 50}, {0, 10}})
  );

  connect(angularVelocity, adaptor_shaft.angularVelocity_b) annotation(
    Line(points = {{+60, 100}, {+60, 80}, {+12, 80}, {+12, 70}}, color = {0, 0, 127})
  );

  connect(torque, adaptor_shaft.torque_b) annotation(
    Line(points = {{-60, 100}, {-60, 80}, {-12, 80}, {-12, 70}}, color = {0, 0, 127})
  );

end PartialPump;
