within AICE.Blocks.Fluid.Incompressible.Machines.BaseClasses;

model Test_ElectricPump
  extends Modelica.Icons.Example;
  replaceable package Medium = Modelica.Media.Water.StandardWater;

  AICE.Blocks.Fluid.Incompressible.Machines.BaseClasses.ElectricPump electricPump(redeclare replaceable package Medium = Medium, BackVoltage_table = [-1, 0; 0, 0; 1000, 20; 1001, 20], N_nominal = 1000, V_flow_nominal = {0.0, 0.0005, 0.001}, allowFlowReversal = false, head_nominal = {0.5, 0.4, 0.3}, k = 20) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.FixedBoundary boundaryIn(redeclare replaceable package Medium = Medium,nPorts = 1)  annotation(
    Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.FixedBoundary boundaryOut(redeclare replaceable package Medium = Medium,nPorts = 1)  annotation(
    Placement(visible = true, transformation(origin = {88, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Electrical.Analog.Sources.ConstantVoltage Voltage(V = 12)  annotation(
    Placement(visible = true, transformation(origin = {-4, 54}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  inner Modelica.Fluid.System system(energyDynamics = Modelica.Fluid.Types.Dynamics.FixedInitial, momentumDynamics = Modelica.Fluid.Types.Dynamics.FixedInitial)  annotation(
    Placement(visible = true, transformation(origin = {-72, 72}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Pipes.StaticPipe pipe(redeclare replaceable package Medium = Medium,allowFlowReversal = false, diameter = 0.1, height_ab = 0, length = 1) annotation(
    Placement(visible = true, transformation(origin = {44, -1}, extent = {{-9, -10}, {11, 10}}, rotation = 0)));
equation
  connect(boundaryIn.ports[1], electricPump.port_a) annotation(
    Line(points = {{-50, 0}, {-10, 0}}, color = {0, 127, 255}));
  connect(Voltage.p, electricPump.pin_ap) annotation(
    Line(points = {{6, 54}, {6, 10}}, color = {0, 0, 255}));
  connect(electricPump.pin_an, Voltage.n) annotation(
    Line(points = {{-6, 10}, {-6, 10}, {-6, 40}, {-14, 40}, {-14, 54}, {-14, 54}, {-14, 54}}, color = {0, 0, 255}));
  connect(electricPump.port_b, pipe.port_a) annotation(
    Line(points = {{10, 0}, {34, 0}, {34, 0}, {36, 0}}, color = {0, 127, 255}));
  connect(pipe.port_b, boundaryOut.ports[1]) annotation(
    Line(points = {{56, 0}, {78, 0}, {78, 0}, {78, 0}}, color = {0, 127, 255}));

annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002));
end Test_ElectricPump;