within AICE.Blocks.Fluid.Incompressible.Machines;

model ElectricPump_TFAIITOO
  extends AICE.Fluid.Machines.BaseClasses.PumpParameters;
  extends AICE.Electrical.BaseClasses.MotorParameters;
  extends AICE.Icons.Fluid.EWaterPump;
  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;

  parameter AICE.Blocks.Types.Energy energy_port_electric = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  AICE.Blocks.Interfaces.VoltageInput voltage annotation(
    Placement(visible = true, transformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90), iconTransformation(origin = {40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.CurrentOutput current annotation(
    Placement(visible = true, transformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {-40, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  AICE.Blocks.Electrical.Interfaces.Adaptors.Adaptor_AITO adaptor_electrical(energy = energy_port_electric) annotation(
    Placement(visible = true, transformation(origin = {0, 62}, extent = {{-10, 10}, {10, -10}}, rotation = 90)));

  extends AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.CausalTwoPortTransport_TFAIITOO(redeclare  AICE.Fluid.Machines.ElectricPump acausalModel(replaceable package Medium=Medium, BackVoltage_table = BackVoltage_table, N_nominal = N_nominal, V_flow_nominal = V_flow_nominal, head_nominal = head_nominal, k = k));

equation

connect(adaptor_electrical.pin_n, acausalModel.pin_an);
  connect(adaptor_electrical.pin_p, acausalModel.pin_ap);
  connect(adaptor_electrical.current, current) annotation(
    Line(points = {{-6, 72}, {-6, 72}, {-6, 80}, {-40, 80}, {-40, 100}, {-40, 100}}, color = {0, 0, 127}));
  connect(adaptor_electrical.voltage, voltage) annotation(
    Line(points = {{6, 72}, {6, 72}, {6, 80}, {38, 80}, {38, 100}, {40, 100}}, color = {0, 0, 127}));
  annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002));
end ElectricPump_TFAIITOO;
