within AICE.Blocks.Fluid.Incompressible.Vessels.BaseClasses;

block PartialLumpedVesselOneport_TFAOTI
  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;

  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_a;
  
  parameter AICE.Blocks.Types.Energy energy_port_a = AICE.Blocks.Types.Energy.Sink
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_a(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_a
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)
    )
  );

  replaceable Modelica.Fluid.Vessels.BaseClasses.PartialLumpedVessel acausalModel(
  redeclare replaceable package Medium = Medium,
  nPorts = 1,
  use_HeatTransfer = false,
  use_portsData = false
) annotation(
  Placement(
    visible = true,
    transformation(origin = {0, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
  )
);

equation
  connect(adaptor_a.port_a, acausalModel.ports[1]) annotation(
    Line(points = {{-40, 0}, {0, 0}, {0, 20}, {0, 20}}, color = {0, 127, 255}));
  connect(absolutePressure_a, adaptor_a.absolutePressure_b) annotation(
    Line(points = {{-100, 80}, {-66, 80}, {-66, 16}, {-60, 16}, {-60, 16}}, color = {0, 0, 127}));
  connect(temperature_a, adaptor_a.temperature_b) annotation(
    Line(points = {{-100, 60}, {-72, 60}, {-72, 12}, {-60, 12}, {-60, 12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_outflow_a, adaptor_a.specificEnthalpy_outflow_b) annotation(
    Line(points = {{-100, 40}, {-80, 40}, {-80, 8}, {-60, 8}, {-60, 8}}, color = {0, 0, 127}));
  connect(massFractions_outflow_a[:], adaptor_a.massFractions_outflow_b[:]) annotation(
    Line(points = {{-100, 20}, {-88, 20}, {-88, 4}, {-60, 4}, {-60, 4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(massFractions_mix_a[:], adaptor_a.massFractions_mix_b[:]) annotation(
    Line(points = {{-100, -20}, {-88, -20}, {-88, -4}, {-60, -4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(specificEnthalpy_mix_a, adaptor_a.specificEnthalpy_mix_b) annotation(
    Line(points = {{-100, -40}, {-80, -40}, {-80, -8}, {-60, -8}, {-60, -8}}, color = {0, 0, 127}));
  connect(massFlowRate_a, adaptor_a.massFlowRate_b) annotation(
    Line(points = {{-100, -60}, {-72, -60}, {-72, -12}, {-60, -12}, {-60, -12}}, color = {0, 0, 127}));
  connect(enthalpyFlowRate_a, adaptor_a.enthalpyFlowRate_b) annotation(
    Line(points = {{-100, -80}, {-66, -80}, {-66, -16}, {-60, -16}}, color = {0, 0, 127}));
end PartialLumpedVesselOneport_TFAOTI;
