within AICE.Blocks.Fluid.Incompressible.Vessels.BaseClasses;

partial block PartialLumpedVesselWithHeat

  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;

  parameter AICE.Blocks.Types.Energy energy_heatPort
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  AICE.Blocks.Interfaces.TemperatureOutput temperature annotation(
    Placement(
      visible = true,
      transformation(origin = {+60, +100}, extent = {{10, -10}, {-10, 10}}, rotation = -90),
      iconTransformation(origin = {+60, +100}, extent = {{10, -10}, {-10, 10}}, rotation = -90)
    )
  );

  AICE.Blocks.Interfaces.HeatFlowRateInput heatFlowRate annotation(
    Placement(
      visible = true,
      transformation(origin = {-60, +100}, extent = {{-10, -10}, {10, 10}}, rotation = -90),
      iconTransformation(origin = {-60, +100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)
    )
  );

  replaceable Modelica.Fluid.Vessels.BaseClasses.PartialLumpedVessel acausalModel(
    redeclare replaceable package Medium = Medium,
    nPorts = 2,
    use_HeatTransfer = true,
    use_portsData = false
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI adaptor_heat(
    energy = energy_heatPort
  )annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 60}, extent = {{-10, 20}, {10, -20}}, rotation = 90)
    )
  );

equation

  connect(acausalModel.heatPort, adaptor_heat.port_a) annotation(
    Line(points = {{-10, 30}, {-20, 30}, {-20, 50}, {0, 50}}, color = {191, 0, 0})
  );

  connect(temperature, adaptor_heat.temperature_b) annotation(
    Line(points = {{+60, 100}, {+60, 80}, {+12, 80}, {+12, 70}}, color = {0, 0, 127})
  );
  connect(heatFlowRate, adaptor_heat.heatFlowRate_b) annotation(
    Line(points = {{-60, 100}, {-60, 80}, {-12, 80}, {-12, 70}}, color = {0, 0, 127})
  );

end PartialLumpedVesselWithHeat;
