within AICE.Blocks.Fluid.Incompressible.Vessels.BaseClasses;

block PartialLumpedVesselWithHeat_TFAOOTII
  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_a;
  extends AICE.Blocks.Fluid.Compressible.Interfaces.ThermoFluidPort_AOTI_b;
  extends PartialLumpedVesselWithHeat;
  parameter AICE.Blocks.Types.Energy energy_port_a = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_port_b = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_a(redeclare replaceable package Medium = Medium, energy = energy_port_a) annotation(
    Placement(visible = true, transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_b(redeclare replaceable package Medium = Medium, energy = energy_port_b) annotation(
    Placement(visible = true, transformation(origin = {50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)));
equation
  connect(acausalModel.ports[1], adaptor_a.port_a) annotation(
    Line(points = {{0, 20}, {0, 20}, {0, 0}, {-40, 0}, {-40, 0}}, color = {0, 127, 255}));
  connect(acausalModel.ports[2], adaptor_b.port_a) annotation(
    Line(points = {{0, 20}, {0, 0}, {40, 0}}, color = {0, 127, 255}));
  connect(absolutePressure_a, adaptor_a.absolutePressure_b) annotation(
    Line(points = {{-100, 80}, {-66, 80}, {-66, 16}, {-60, 16}, {-60, 16}}, color = {0, 0, 127}));
  connect(temperature_a, adaptor_a.temperature_b) annotation(
    Line(points = {{-100, 60}, {-72, 60}, {-72, 12}, {-60, 12}, {-60, 12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_outflow_a, adaptor_a.specificEnthalpy_outflow_b) annotation(
    Line(points = {{-100, 40}, {-80, 40}, {-80, 8}, {-60, 8}, {-60, 8}}, color = {0, 0, 127}));
  connect(massFractions_outflow_a[:], adaptor_a.massFractions_outflow_b[:]) annotation(
    Line(points = {{-100, 20}, {-100, 20}, {-100, 14}, {-100, 14}, {-100, 18}, {-86, 18}, {-86, 4}, {-60, 4}, {-60, 4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(enthalpyFlowRate_a, adaptor_a.enthalpyFlowRate_b) annotation(
    Line(points = {{-100, -80}, {-66, -80}, {-66, -16}, {-60, -16}, {-60, -16}}, color = {0, 0, 127}));
  connect(massFlowRate_a, adaptor_a.massFlowRate_b) annotation(
    Line(points = {{-100, -60}, {-72, -60}, {-72, -12}, {-60, -12}, {-60, -12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_a, adaptor_a.specificEnthalpy_mix_b) annotation(
    Line(points = {{-100, -40}, {-80, -40}, {-80, -8}, {-60, -8}, {-60, -8}, {-60, -8}}, color = {0, 0, 127}));
  connect(massFractions_mix_a[:], adaptor_a.massFractions_mix_b[:]) annotation(
    Line(points = {{-100, -20}, {-86, -20}, {-86, -4}, {-60, -4}, {-60, -4}, {-60, -4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(absolutePressure_b, adaptor_b.absolutePressure_b) annotation(
    Line(points = {{100, 80}, {66, 80}, {66, 16}, {60, 16}, {60, 16}, {60, 16}}, color = {0, 0, 127}));
  connect(temperature_b, adaptor_b.temperature_b) annotation(
    Line(points = {{100, 60}, {74, 60}, {74, 12}, {60, 12}, {60, 12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_outflow_b, adaptor_b.specificEnthalpy_outflow_b) annotation(
    Line(points = {{100, 40}, {80, 40}, {80, 8}, {60, 8}, {60, 8}}, color = {0, 0, 127}));
  connect(massFractions_outflow_b[:], adaptor_b.massFractions_outflow_b[:]) annotation(
    Line(points = {{100, 20}, {86, 20}, {86, 4}, {60, 4}, {60, 4}}, color = {0, 0, 127}, thickness = 0.5));
  connect(enthalpyFlowRate_b, adaptor_b.enthalpyFlowRate_b) annotation(
    Line(points = {{100, -80}, {66, -80}, {66, -16}, {60, -16}}, color = {0, 0, 127}));
  connect(massFlowRate_b, adaptor_b.massFlowRate_b) annotation(
    Line(points = {{100, -60}, {72, -60}, {72, -12}, {60, -12}, {60, -12}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_b, adaptor_b.specificEnthalpy_mix_b) annotation(
    Line(points = {{100, -40}, {80, -40}, {80, -8}, {60, -8}, {60, -8}}, color = {0, 0, 127}));
  connect(massFractions_mix_b[:], adaptor_b.massFractions_mix_b[:]) annotation(
    Line(points = {{100, -20}, {88, -20}, {88, -4}, {60, -4}, {60, -4}, {60, -4}}, color = {0, 0, 127}, thickness = 0.5));
end PartialLumpedVesselWithHeat_TFAOOTII;
