within AICE.Blocks.Interfaces;

connector RealVectorOutput = output Real "Real output connector used for vector of connectors" annotation(
  defaultComponentName = "y",
  Icon(
    coordinateSystem(
      preserveAspectRatio=true,
      extent={{-100.0,-100.0},{100.0,100.0}},
      initialScale = 0.2
    ),
    graphics = {
      Ellipse(
        extent = {{-100, 100}, {100, -100}},
        lineColor = {0, 0, 127},
        fillColor = {255, 255, 255},
        fillPattern = FillPattern.Solid
      )
    }
  ),
  Diagram(
    coordinateSystem(
      preserveAspectRatio = false,
      extent = {{-100, -100}, {100, 100}},
      initialScale = 0.2
    ),
    graphics = {
      Ellipse(
        extent = {{-50, 50}, {50, -50}},
        lineColor = {0, 0, 127},
        fillColor = {255, 255, 255},
        fillPattern = FillPattern.Solid
      ),
      Text(
        textString = "%name",
        extent = {{-10, 85}, {-10, 60}},
        lineColor = {0, 0, 127}
      )
    }
  ),
  Documentation(info = "<html>
<p>
Real output connector that is used for a vector of connectors,
has therefore a different icon as Modelica.Blocks.Interfaces.RealOutput connector.
</p>
</html>")
);
