within AICE.Blocks.Mechanics.Rotational.Components;

model FlyWheel_AOTI
  extends Interfaces.Flange_AOTI;
  extends AICE.Mechanics.Rotational.Components.BaseClasses.InertiaParameters;
  
  parameter AICE.Blocks.Types.Energy energy_flange = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));

  
  AICE.Blocks.Mechanics.Rotational.Interfaces.Adaptors.Adaptor_AOTI adaptor(energy = energy_flange) annotation(
    Placement(visible = true, transformation(origin = {50, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Components.Inertia flyWheel(J = Inertia, w(fixed = true, start = w_init))  annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));

equation
  connect(flyWheel.flange_b, adaptor.flange_a) annotation(
    Line(points = {{10, 0}, {40, 0}, {40, 0}, {40, 0}}));
  connect(adaptor.angularVelocity_b, angularVelocity) annotation(
    Line(points = {{60, 6}, {60, 6}, {60, 60}, {100, 60}, {100, 60}}, color = {0, 0, 127}));
  connect(adaptor.torque_b, torque) annotation(
    Line(points = {{60, -6}, {60, -6}, {60, -60}, {100, -60}, {100, -60}}, color = {0, 0, 127}));
end FlyWheel_AOTI;