within AICE.Blocks.Mechanics.Rotational.Interfaces.Adaptors.BaseClasses;

partial model PartialAdaptor_up

  parameter Boolean use_phi_start = false
  annotation(
    Evaluate = true
  );
  parameter SI.Angle phi_start = 0.0;

  //parameter AICE.Blocks.Types.Energy energy
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );

  Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(
    Placement(visible = true, transformation(origin = {0, 102}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 102}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));

protected

  SI.Torque tau_a, tau_b;
  SI.AngularVelocity w;

initial equation

  if use_phi_start then
    flange_a.phi = phi_start;
  end if;

equation

  0 = tau_a + tau_b;

  der(flange_a.phi) = w;
  flange_a.tau = tau_a;

end PartialAdaptor_up;