within AICE.Blocks.Thermal.HeatTransfer.Components;

block HeatCapacitor_AOOOTIII
  extends Icons.HeatTransfer.HeatCapacitor;
  extends Interfaces.HeatPort_AOTI_1;
  extends Interfaces.HeatPort_AOTI_2;
  extends Interfaces.HeatPort_AOTI_3;
  extends BaseClasses.HeatCapacitorParameters;
  extends BaseClasses.PartialHeatCapacitor3way(acausalModel(C = C, T.start = T_start, der_T.start = der_T_start));
  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI adaptor_1(energy = energy_port_1) annotation(
    Placement(visible = true, transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)));
  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI adaptor_2(energy = energy_port_2) annotation(
    Placement(visible = true, transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)));
  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI adaptor_3(energy = energy_port_3) annotation(
    Placement(visible = true, transformation(origin = {0, -50}, extent = {{10, -20}, {-10, 20}}, rotation = 90)));

equation
  connect(acausalModel.port, adaptor_1.port_a) annotation(
    Line(points = {{0, 20}, {0, 0}, {-40, 0}}, color = {191, 0, 0}));
  connect(acausalModel.port, adaptor_2.port_a) annotation(
    Line(points = {{0, 20}, {0, 0}, {+40, 0}}, color = {191, 0, 0}));
  connect(acausalModel.port, adaptor_3.port_a) annotation(
    Line(points = {{0, 20}, {0, -40}}, color = {191, 0, 0}));
  connect(adaptor_1.temperature_b, temperature_1) annotation(
    Line(points = {{-60, +12}, {-72, +12}, {-72, +60}, {-100, +60}}, color = {0, 0, 127}));
  connect(adaptor_1.heatFlowRate_b, heatFlowRate_1) annotation(
    Line(points = {{-60, -12}, {-72, -12}, {-72, -60}, {-100, -60}}, color = {0, 0, 127}));
  connect(adaptor_2.temperature_b, temperature_2) annotation(
    Line(points = {{+60, +12}, {+72, +12}, {+72, +60}, {+100, +60}}, color = {0, 0, 127}));
  connect(adaptor_2.heatFlowRate_b, heatFlowRate_2) annotation(
    Line(points = {{+60, -12}, {+72, -12}, {+72, -60}, {+100, -60}}, color = {0, 0, 127}));

  connect(adaptor_3.heatFlowRate_b, heatFlowRate_3) annotation(
    Line(points = {{12, -60}, {12, -90}, {60, -90}}, color = {0, 0, 127}));

  connect(adaptor_3.temperature_b, temperature_3) annotation(
    Line(points = {{-12, -60}, {-12, -90}, {-60, -90}}, color = {0, 0, 127}));


end HeatCapacitor_AOOOTIII;