within AICE.Blocks.Thermal.HeatTransfer.Components;

block HeatCapacitor_AOOTII
  extends Icons.HeatTransfer.HeatCapacitor;

  extends Interfaces.HeatPort_AOTI_a;
  extends Interfaces.HeatPort_AOTI_b;

  extends BaseClasses.HeatCapacitorParameters;

  extends BaseClasses.PartialHeatCapacitor(
    acausalModel(
      C = C,
      T.start = T_start,
      der_T.start = der_T_start
    )
  );

  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI adaptor_a(
    energy = energy_port_a
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)
    )
  );

  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AOTI adaptor_b(
    energy = energy_port_b
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)
    )
  );

equation

  connect(acausalModel.port, adaptor_a.port_a) annotation(
    Line(points = {{0, 20}, {0, 0}, {-40, 0}}, color = {191, 0, 0})
  );
  connect(acausalModel.port, adaptor_b.port_a) annotation(
    Line(points = {{0, 20}, {0, 0}, {+40, 0}}, color = {191, 0, 0})
  );

  connect(adaptor_a.temperature_b, temperature_a) annotation(
    Line(points = {{-60, +12}, {-72, +12}, {-72, +60}, {-100, +60}}, color = {0, 0, 127})
  );
  connect(adaptor_a.heatFlowRate_b, heatFlowRate_a) annotation(
    Line(points = {{-60, -12}, {-72, -12}, {-72, -60}, {-100, -60}}, color = {0, 0, 127})
  );

  connect(adaptor_b.temperature_b, temperature_b) annotation(
    Line(points = {{+60, +12}, {+72, +12}, {+72, +60}, {+100, +60}}, color = {0, 0, 127})
  );
  connect(adaptor_b.heatFlowRate_b, heatFlowRate_b) annotation(
    Line(points = {{+60, -12}, {+72, -12}, {+72, -60}, {+100, -60}}, color = {0, 0, 127})
  );

end HeatCapacitor_AOOTII;
