within AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors;

block Element1D_AIITOO
  extends Interfaces.HeatPort_AITO_a;
  extends Interfaces.HeatPort_AITO_b;

  extends BaseClasses.Element1D;

  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AITO adaptor_a(
    energy = energy_port_a
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{10, -20}, {-10, 20}}, rotation = 0)
    )
  );

  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AITO adaptor_b(
    energy = energy_port_b
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {+50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)
    )
  );

equation

  connect(acausalModel.port_a, adaptor_a.port_a) annotation(
    Line(points = {{-20, 0}, {-40, 0}}, color = {191, 0, 0})
  );
  connect(acausalModel.port_b, adaptor_b.port_a) annotation(
    Line(points = {{+20, 0}, {+40, 0}}, color = {191, 0, 0})
  );

  connect(adaptor_a.temperature_b, temperature_a) annotation(
    Line(points = {{-60, +12}, {-72, +12}, {-72, +60}, {-100, +60}}, color = {0, 0, 127})
  );
  connect(adaptor_a.heatFlowRate_b, heatFlowRate_a) annotation(
    Line(points = {{-60, -12}, {-72, -12}, {-72, -60}, {-100, -60}}, color = {0, 0, 127})
  );

  connect(adaptor_b.temperature_b, temperature_b) annotation(
    Line(points = {{+60, +12}, {+72, +12}, {+72, +60}, {+100, +60}}, color = {0, 0, 127})
  );
  connect(adaptor_b.heatFlowRate_b, heatFlowRate_b) annotation(
    Line(points = {{+60, -12}, {+72, -12}, {+72, -60}, {+100, -60}}, color = {0, 0, 127})
  );

end Element1D_AIITOO;
