within AICE.Blocks.Thermal.HeatTransfer.Sources;

model FixedTemperature

  extends Interfaces.HeatPort_AOTI;

  parameter SI.Temperature T(start=293.15) "Temperature of port";


equation

  T = temperature;

  annotation(
    Icon(
      graphics = {
        Rectangle(
          fillColor = {255, 85, 0}, fillPattern = FillPattern.Solid,
          extent = {{-100, 100}, {100, -100}}
        ),
        Text(
          extent = {{-80, -80}, {80, 80}}, textString = "T"
        ),
        Text(
          extent={{-150,-150},{150,-110}},
          lineColor={0,0,0},
          textString="T=%T"
        )
      },
      coordinateSystem(initialScale = 0.1)
    )
  );

end FixedTemperature;
