within AICE;

package CarUnits
  extends Modelica.Icons.Package;

  package Conversions
    extends Modelica.Icons.Package;

    function to_deg =
      Modelica.SIunits.Conversions.to_deg;

    function from_deg =
      Modelica.SIunits.Conversions.from_deg;

    function to_rpm =
      Modelica.SIunits.Conversions.to_rpm;

    function from_rpm =
      Modelica.SIunits.Conversions.from_rpm;

  end Conversions;

  type Angle_deg =
    Modelica.SIunits.Conversions.NonSIunits.Angle_deg;

  type ThrottleOpening =
    SI.Angle(min=0, max=Modelica.Constants.pi/2);

  type AngularVelocity =
    SI.AngularVelocity(displayUnit = "rev/min");

  type AngularVelocity_rpm =
    Modelica.SIunits.Conversions.NonSIunits.AngularVelocity_rpm;

  type CompressionRatio = 
    SI.DimensionlessRatio(final quantity = "CompressionRatio", final min=0.0) "V_max/V_min";

  type AirByFuelRatio =
    SI.DimensionlessRatio(final quantity = "AirByFuelRatio", final min = 0.0) "A/F [kg/kg]";

  type Radius = SI.Radius(displayUnit = "mm");

  type Diameter = SI.Diameter(displayUnit = "mm");

  type Position = SI.Position(displayUnit = "mm");

  type Length = SI.Length(displayUnit = "mm");

  type Area = SI.Area(displayUnit = "cm2");

  type Volume = SI.Volume(displayUnit="cm3");

  type Mass = SI.Mass(displayUnit="g");

end CarUnits;
