within AICE.Electrical.BaseClasses;

model IdealOneway
Real ratio_oneway;

  extends Modelica.Mechanics.Rotational.Icons.Gear;
  extends Modelica.Mechanics.Rotational.Interfaces.PartialElementaryTwoFlangesAndSupport2;
  parameter Real ratio(start=1)
    "Transmission ratio (flange_a.phi/flange_b.phi)";
  Modelica.SIunits.Angle phi_a
    "Angle between left shaft flange and support";
  Modelica.SIunits.Angle phi_b
    "Angle between right shaft flange and support";
  AICE.Math.MovingAverage movingAverage annotation(
    Placement(visible = true, transformation(origin = {-26, -42}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  phi_a = flange_a.phi - phi_support;
  phi_b = flange_b.phi - phi_support;
  phi_a = ratio*phi_b;
  0 = ratio*flange_a.tau + flange_b.tau;

end IdealOneway;