within AICE.Electrical.BaseClasses;

model MotorStarter 

 extends AICE.Electrical.BaseClasses.MotorParameters;
//parameter Real BackVoltage_table[:,:];// [-1, 0; 0, 0; 1000, 20; 1001, 20]

Modelica.Electrical.Analog.Interfaces.PositivePin pin_ap
    "Positive armature pin" annotation (Placement(transformation(extent={{
            50,110},{70,90}})));
  Modelica.Electrical.Analog.Interfaces.NegativePin pin_an
    "Negative armature pin" annotation (Placement(transformation(extent={{-70,
            110},{-50,90}})));
  Modelica.Electrical.Analog.Basic.Resistor ra(R = 0.1)  annotation (Placement(transformation(extent={{60,50},{40,
            70}})));
  Modelica.Mechanics.Rotational.Sources.Torque torque annotation(
    Placement(visible = true, transformation(origin = {0, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Sensors.SpeedSensor speedSensor annotation(
    Placement(visible = true, transformation(origin = {46, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Interfaces.Flange_b flange_b annotation(
    Placement(visible = true, transformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable1Ds RevBV_table(table = BackVoltage_table)  annotation(
    Placement(visible = true, transformation(origin = {20, 34}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Gain Current2Torque(k = k)  annotation(
    Placement(visible = true, transformation(origin = {-48, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(
    Placement(visible = true, transformation(origin = {-40, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Electrical.Analog.Sources.SignalVoltage backVoltage annotation(
    Placement(visible = true, transformation(origin = {2, 60}, extent = {{10, 10}, {-10, -10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Components.Fixed fixed annotation(
    Placement(visible = true, transformation(origin = {0, -30}, extent = {{10, 10}, {-10, -10}}, rotation = 180)));
  Modelica.Electrical.Analog.Basic.Ground ground annotation(
    Placement(visible = true, transformation(origin = {-88, 58}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(pin_ap, ra.p) annotation(
    Line(points = {{60, 100}, {60, 100}, {60, 60}, {60, 60}}, color = {0, 0, 255}));
  connect(speedSensor.w, RevBV_table.u) annotation(
    Line(points = {{58, 20}, {56, 20}, {56, 34}, {32, 34}, {32, 34}}, color = {0, 0, 127}));
  connect(torque.tau, Current2Torque.y) annotation(
    Line(points = {{-12, 10}, {-36, 10}, {-36, 10}, {-36, 10}}, color = {0, 0, 127}));
  connect(currentSensor.i, Current2Torque.u) annotation(
    Line(points = {{-40, 50}, {-80, 50}, {-80, 10}, {-60, 10}}, color = {0, 0, 127}));
  connect(RevBV_table.y[1], backVoltage.v) annotation(
    Line(points = {{9, 34}, {2, 34}, {2, 53}}, color = {0, 0, 127}));
  connect(torque.support, fixed.flange) annotation(
    Line(points = {{0, 0}, {0, -30}}));
  connect(torque.flange, flange_b) annotation(
    Line(points = {{10, 10}, {20, 10}, {20, 0}, {100, 0}, {100, 0}}));
  connect(speedSensor.flange, flange_b) annotation(
    Line(points = {{36, 20}, {36, 20}, {36, 0}, {100, 0}, {100, 0}}));
  connect(ground.p, pin_an) annotation(
    Line(points = {{-88, 68}, {-60, 68}, {-60, 100}, {-60, 100}}, color = {0, 0, 255}));
  connect(currentSensor.n, pin_an) annotation(
    Line(points = {{-50, 60}, {-60, 60}, {-60, 100}, {-60, 100}}, color = {0, 0, 255}));
  connect(currentSensor.p, backVoltage.n) annotation(
    Line(points = {{-30, 60}, {-8, 60}, {-8, 60}, {-8, 60}}, color = {0, 0, 255}));
  connect(backVoltage.p, ra.n) annotation(
    Line(points = {{12, 60}, {40, 60}, {40, 60}, {40, 60}}, color = {0, 0, 255}));
  annotation(
    Icon(coordinateSystem(initialScale = 0.1)),
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
  __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end MotorStarter;