within AICE.Electrical.BaseClasses;

model OnewayGear
  //replaceable AICE.Electrical.MotorStarter acausal_model;
  //extends AICE.Electrical.MotorStarter;
  Modelica.Mechanics.Rotational.Components.OneWayClutch oneWayClutch(fn_max = 1, mue_pos = [0, 0.01], peak = 1000) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, 10}, {10, -10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Components.IdealGear idealGear(ratio = 10) annotation(
    Placement(visible = true, transformation(origin = {70, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Sensors.TorqueSensor torqueSensor annotation(
    Placement(visible = true, transformation(origin = {-64, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Components.Inertia inertia1(J = 0.001) annotation(
    Placement(visible = true, transformation(origin = {-30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Components.Inertia inertia2(J = 0.001) annotation(
    Placement(visible = true, transformation(origin = {32, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  //discrete Boolean engaged = false;
  //discrete Real clutch_force;
  //discrete SI.Torque torque_dis;
  Modelica.Blocks.Logical.OnOffController onOffController(bandwidth = 3, pre_y_start = true) annotation(
    Placement(visible = true, transformation(origin = {-20, -66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant const(k = 3) annotation(
    Placement(visible = true, transformation(origin = {-58, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.Switch switch1 annotation(
    Placement(visible = true, transformation(origin = {28, -66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant1(k = 0) annotation(
    Placement(visible = true, transformation(origin = {-20, -38}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant2(k = 1) annotation(
    Placement(visible = true, transformation(origin = {-20, -90}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Components.Damper damper(d = 0.0001) annotation(
    Placement(visible = true, transformation(origin = {-54, 26}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Components.Fixed fixed annotation(
    Placement(visible = true, transformation(origin = {-70, 26}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  Modelica.Blocks.Continuous.FirstOrder firstOrder(T = 0.1) annotation(
    Placement(visible = true, transformation(origin = {-80, -84}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(
    Placement(visible = true, transformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Interfaces.Flange_b flange_b annotation(
    Placement(visible = true, transformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(torqueSensor.flange_b, inertia1.flange_a) annotation(
    Line(points = {{-54, 0}, {-54, 3}, {-40, 3}, {-40, 0}}));
  connect(inertia1.flange_b, oneWayClutch.flange_a) annotation(
    Line(points = {{-20, 0}, {-20, 3}, {-10, 3}, {-10, 0}}));
  connect(oneWayClutch.flange_b, inertia2.flange_a) annotation(
    Line(points = {{10, 0}, {22, 0}}));
  connect(inertia2.flange_b, idealGear.flange_a) annotation(
    Line(points = {{42, 0}, {42, 3}, {60, 3}, {60, 0}}));
  connect(const.y, onOffController.reference) annotation(
    Line(points = {{-47, -60}, {-32, -60}}, color = {0, 0, 127}));
  connect(onOffController.y, switch1.u2) annotation(
    Line(points = {{-9, -66}, {16, -66}}, color = {255, 0, 255}));
  connect(switch1.u3, constant2.y) annotation(
    Line(points = {{16, -74}, {9.5, -74}, {9.5, -90}, {-9, -90}}, color = {0, 0, 127}));
  connect(switch1.y, oneWayClutch.f_normalized) annotation(
    Line(points = {{39, -66}, {48, -66}, {48, -28}, {0, -28}, {0, -11}}, color = {0, 0, 127}));
  connect(damper.flange_b, inertia1.flange_a) annotation(
    Line(points = {{-44, 26}, {-44, 25}, {-40, 25}, {-40, 0}}));
  connect(damper.flange_a, fixed.flange) annotation(
    Line(points = {{-64, 26}, {-70, 26}}));
  connect(switch1.u1, constant1.y) annotation(
    Line(points = {{16, -58}, {8.5, -58}, {8.5, -38}, {-1, -38}, {-1, -39}, {-9, -39}, {-9, -38}}, color = {0, 0, 127}));
  connect(torqueSensor.tau, firstOrder.u) annotation(
    Line(points = {{-72, -11}, {-72, -32}, {-96, -32}, {-96, -84}, {-92, -84}}, color = {0, 0, 127}));
  connect(firstOrder.y, onOffController.u) annotation(
    Line(points = {{-69, -84}, {-40.5, -84}, {-40.5, -72}, {-32, -72}}, color = {0, 0, 127}));
  connect(flange_a, torqueSensor.flange_a) annotation(
    Line(points = {{-100, 0}, {-74, 0}}));
  connect(idealGear.flange_b, flange_b) annotation(
    Line(points = {{80, 0}, {100, 0}}));
  annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end OnewayGear;