within AICE.Electrical.BaseClasses;

model OnewayGearSimple
  extends Modelica.Mechanics.Rotational.Interfaces.PartialElementaryTwoFlangesAndSupport2;
  extends Modelica.Mechanics.Rotational.Icons.Gear;
  Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(
    Placement(visible = true, transformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Rotational.Interfaces.Flange_b flange_b annotation(
    Placement(visible = true, transformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter Real ratio = 10 "Transmission ratio (flange_a.phi/flange_b.phi)";
  Modelica.SIunits.Angle phi_a "Angle between left shaft flange and support";
  Modelica.SIunits.Angle phi_b "Angle between right shaft flange and support";


  Modelica.Blocks.Interfaces.BooleanInput Gear_flag annotation(
    Placement(visible = true, transformation(origin = {0, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90), iconTransformation(origin = {0, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90)));



equation
  phi_a = flange_a.phi - phi_support;
  phi_b = flange_b.phi - phi_support;


  if Gear_flag == false then
    flange_a.tau = 0;
    flange_b.tau = 0;
  else
    der(phi_a) = ratio*der(phi_b);
    0 = ratio*flange_a.tau + flange_b.tau;
  end if;
  
  
  annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end OnewayGearSimple;