within AICE.Examples.METI_2020.Components.BaseClasses;

partial model SingleCylinderEngineParameters


  // # geometry parameters

  // ## total displacement volume
  parameter CarUnits.Volume
    V_displacement "Total displacement volume"
    annotation(
      Dialog(group="Geometries")
    );

  // ## Compression ratio (CR)
  parameter CarUnits.CompressionRatio
    compressionRatio "Compression ratio V_BDC/V_TDC"
    annotation(
      Dialog(group="Geometries")
    );

  // ## crank & chamber
  parameter CarUnits.Length
    l_connRod "Length of connecting rod"
    annotation(
      Dialog(group="Geometries")
    );

  parameter CarUnits.Position
    offset_crank "Crank offset from piston axis"
    annotation(
      Dialog(group="Geometries")
    );

  parameter CarUnits.Diameter
    bore "Diameter of cylinder"
    annotation(
      Dialog(group="Geometries")
    );



  // # other parameters
  parameter Real m_wiebe;

  parameter SI.Angle
    phi_combustion_begin
    "BTDC from piston compression TDC";

  parameter SI.Angle
    phi_combustion_period
    "Anglar period until 1-exp(-a_wiebe) of fuel burns";

  parameter Real c1_woschni_intakeExhaust;
  parameter Real c1_woschni_compressionPower;
  parameter Real c2_woschni;

end SingleCylinderEngineParameters;