within AICE.Examples.METI_2020.Components;

block CycleMean
  extends Modelica.Blocks.Interfaces.SISO;

  AICE.Blocks.Interfaces.AngularVelocityInput angularVelocity annotation(
    Placement(
      visible = true,
      transformation(origin = {-120, 60}, extent = {{-20, -20}, {20, 20}}, rotation = 0),
      iconTransformation(origin = {-120, 60}, extent = {{-20, -20}, {20, 20}}, rotation = 0)
    )
  );

  Real x;

  SI.Angle phi;
  SI.Angle timing = AICE.Math.AngleDifference4Stroke.compare(phi, 0.0);
  SI.Time t0, t1;

initial equation

  t0 = time - 1; // to avoid zero division
  x  = 0;
  y  = 0;

equation

  der(phi) = angularVelocity;
  der(x) = u;

  when timing > 0 then
    y = pre(x) / (t1 - t0);
    reinit(x, 0);
    t1 = time;
    t0 = pre(t1);
  end when;

end CycleMean;
