within AICE.Examples.METI_2020.Components;

block ECU
  extends AICE.Icons.Blocks.ECU;
  parameter String DriverRequestTorqueMap ;
  parameter String DriverRequestTorqueTable = "tbl1";
  parameter String ThrottleMap_drive;
  parameter String ThrottleMap_drive_table;
  parameter Real Tq_ice_max;
  parameter Real Tq_ice_min;
  parameter Boolean IdleStop = true;

  AICE.Examples.METI_2020.Components.ECUDrive ECUDrive(ThrottleMap_drive = ThrottleMap_drive, ThrottleMap_drive_table = ThrottleMap_drive_table)  annotation(
    Placement(visible = true, transformation(origin = {-28, -32}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Gain radps2rpm(k = 60 / (2 * Modelica.Constants.pi))  annotation(
    Placement(visible = true, transformation(origin = {-82, -24}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Examples.METI_2020.Components.ECUIdle ECUIdle annotation(
    Placement(visible = true, transformation(origin = {-22, -72}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable2D DriverRequestTorque(fileName = DriverRequestTorqueMap, tableName = DriverRequestTorqueTable, tableOnFile = true)  annotation(
    Placement(visible = true, transformation(origin = {-72, 28}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable1D MixWeight_Idle_Drive(table = [-1, 1.0; 0, 1.0; 3, 0.0; 4, 0.0])  annotation(
    Placement(visible = true, transformation(origin = {-52, 66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Product productIdle annotation(
    Placement(visible = true, transformation(origin = {16, -66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Product productDrive annotation(
    Placement(visible = true, transformation(origin = {16, -26}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Add add(k1 = -1)  annotation(
    Placement(visible = true, transformation(origin = {12, 66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant const(k = 1)  annotation(
    Placement(visible = true, transformation(origin = {-18, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Add addFinalOutput annotation(
    Placement(visible = true, transformation(origin = {46, -32}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Gain gain(k = Modelica.Constants.pi / 180) annotation(
    Placement(visible = true, transformation(origin = {80, 54}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Nonlinear.Limiter limiter(limitsAtInit = true, uMax = 90, uMin = 0)  annotation(
    Placement(visible = true, transformation(origin = {48, 54}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput ThrottleAngle annotation(
    Placement(visible = true, transformation(origin = {130, 54}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {130, 54}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput EngineTorque_request_idle annotation(
    Placement(visible = true, transformation(origin = {-110, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput EngineTorque annotation(
    Placement(visible = true, transformation(origin = {-110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Blocks.Interfaces.RealInput EngineSpeed annotation(
    Placement(visible = true, transformation(origin = {-110, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput AccelPedalPosition annotation(
    Placement(visible = true, transformation(origin = {-110, 104}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, 104}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput EngineSpeed_idle_target annotation(
    Placement(visible = true, transformation(origin = {130, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {130, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Nonlinear.VariableLimiter RequestedTorqueLimit annotation(
    Placement(visible = true, transformation(origin = {-58, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput TorqueMaxIntervention annotation(
    Placement(visible = true, transformation(origin = {-110, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput TorqueMinIntervention annotation(
    Placement(visible = true, transformation(origin = {-110, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Nonlinear.VariableLimiter RequestTorqueLimit_Drive(limitsAtInit = true)  annotation(
    Placement(visible = true, transformation(origin = {-26, 14}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput Torque_target annotation(
    Placement(visible = true, transformation(origin = {130, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {130, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant1(k = Tq_ice_max) annotation(
    Placement(visible = true, transformation(origin = {80, -22}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant2(k = Tq_ice_min) annotation(
    Placement(visible = true, transformation(origin = {80, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput Torque_max annotation(
    Placement(visible = true, transformation(origin = {130, -22}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {130, -22}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput Torque_min annotation(
    Placement(visible = true, transformation(origin = {130, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {130, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.BooleanConstant IdleStopFlag(k = IdleStop)  annotation(
    Placement(visible = true, transformation(origin = {-42, 140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.Greater AccelOff annotation(
    Placement(visible = true, transformation(origin = {-42, 112}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant3(k = 0.001) annotation(
    Placement(visible = true, transformation(origin = {-73, 117}, extent = {{-7, -7}, {7, 7}}, rotation = 0)));
  Modelica.Blocks.Logical.And and1 annotation(
    Placement(visible = true, transformation(origin = {4, 112}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.Switch switch_fuelmpr annotation(
    Placement(visible = true, transformation(origin = {72, 122}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant4(k = 0.0) annotation(
    Placement(visible = true, transformation(origin = {33, 135}, extent = {{-7, -7}, {7, 7}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant5(k = 1.0) annotation(
    Placement(visible = true, transformation(origin = {41, 109}, extent = {{-7, -7}, {7, 7}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput FuelMpr annotation(
    Placement(visible = true, transformation(origin = {130, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {130, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant6(k = 1) annotation(
    Placement(visible = true, transformation(origin = {-79, 217}, extent = {{-7, -7}, {7, 7}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant7(k = 40) annotation(
    Placement(visible = true, transformation(origin = {-79, 185}, extent = {{-7, -7}, {7, 7}}, rotation = 0)));
  Modelica.Blocks.Logical.And and2 annotation(
    Placement(visible = true, transformation(origin = {4, 190}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.TriggeredTrapezoid StarterPower(amplitude = 12, falling = 0.1, rising = 0.1)  annotation(
    Placement(visible = true, transformation(origin = {172, 186}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.Timer timer annotation(
    Placement(visible = true, transformation(origin = {40, 160}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.Greater greater1 annotation(
    Placement(visible = true, transformation(origin = {90, 168}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant8(k = 1.0) annotation(
    Placement(visible = true, transformation(origin = {63, 177}, extent = {{-7, -7}, {7, 7}}, rotation = 0)));
  Modelica.Blocks.Logical.And and3 annotation(
    Placement(visible = true, transformation(origin = {124, 190}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput StarterPowerOutput annotation(
    Placement(visible = true, transformation(origin = {130, 138}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {130, 138}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.Greater AccelOn annotation(
    Placement(visible = true, transformation(origin = {-46, 212}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Logical.OnOffController onOff50(bandwidth = 70)  annotation(
    Placement(visible = true, transformation(origin = {-48, 182}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput BrakePedalPosition annotation(
    Placement(visible = true, transformation(origin = {-110, 76}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, 76}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(ECUDrive.Neng, radps2rpm.y) annotation(
    Line(points = {{-39, -24}, {-71, -24}}, color = {0, 0, 127}));
  connect(ECUIdle.Neng, radps2rpm.y) annotation(
    Line(points = {{-33, -64}, {-58, -64}, {-58, -24}, {-71, -24}}, color = {0, 0, 127}));
  connect(DriverRequestTorque.u2, radps2rpm.y) annotation(
    Line(points = {{-84, 22}, {-92, 22}, {-92, -2}, {-58, -2}, {-58, -24}, {-71, -24}}, color = {0, 0, 127}));
  connect(ECUIdle.throttle_angle_deg, productIdle.u2) annotation(
    Line(points = {{-11, -72}, {4, -72}}, color = {0, 0, 127}));
  connect(productIdle.u1, MixWeight_Idle_Drive.y[1]) annotation(
    Line(points = {{4, -60}, {-4, -60}, {-4, 36}, {-30, 36}, {-30, 66}, {-41, 66}}, color = {0, 0, 127}));
  connect(productDrive.u2, ECUDrive.throttle_angle_deg) annotation(
    Line(points = {{4, -32}, {-17, -32}}, color = {0, 0, 127}));
  connect(add.u1, MixWeight_Idle_Drive.y[1]) annotation(
    Line(points = {{0, 72}, {-30, 72}, {-30, 66}, {-41, 66}}, color = {0, 0, 127}));
  connect(add.u2, const.y) annotation(
    Line(points = {{0, 60}, {-7, 60}}, color = {0, 0, 127}));
  connect(add.y, productDrive.u1) annotation(
    Line(points = {{23, 66}, {28, 66}, {28, -4}, {-1, -4}, {-1, -20}, {4, -20}}, color = {0, 0, 127}));
  connect(addFinalOutput.u1, productDrive.y) annotation(
    Line(points = {{34, -26}, {27, -26}}, color = {0, 0, 127}));
  connect(addFinalOutput.u2, productIdle.y) annotation(
    Line(points = {{34, -38}, {30, -38}, {30, -66}, {27, -66}}, color = {0, 0, 127}));
  connect(limiter.y, gain.u) annotation(
    Line(points = {{59, 54}, {68, 54}}, color = {0, 0, 127}));
  connect(gain.y, ThrottleAngle) annotation(
    Line(points = {{91, 54}, {130, 54}}, color = {0, 0, 127}));
  connect(ECUDrive.Torque_Engine_Actual, EngineTorque) annotation(
    Line(points = {{-39, -40}, {-50.5, -40}, {-50.5, 0}, {-110, 0}}, color = {0, 0, 127}));
  connect(radps2rpm.u, EngineSpeed) annotation(
    Line(points = {{-94, -24}, {-98, -24}, {-98, 40}, {-110, 40}, {-110, 40}}, color = {0, 0, 127}));
  connect(DriverRequestTorque.u1, AccelPedalPosition) annotation(
    Line(points = {{-84, 34}, {-90, 34}, {-90, 104}, {-110, 104}}, color = {0, 0, 127}));
  connect(MixWeight_Idle_Drive.u[1], AccelPedalPosition) annotation(
    Line(points = {{-64, 66}, {-76, 66}, {-76, 104}, {-110, 104}}, color = {0, 0, 127}));
  connect(ECUIdle.w_engine_idle_radps, EngineSpeed_idle_target) annotation(
    Line(points = {{-10, -64}, {-6, -64}, {-6, -80}, {130, -80}}, color = {0, 0, 127}));
  connect(ECUIdle.Torue_Engine_Target, RequestedTorqueLimit.u) annotation(
    Line(points = {{-32, -80}, {-72, -80}, {-72, -80}, {-70, -80}}, color = {0, 0, 127}));
  connect(RequestedTorqueLimit.u, EngineTorque_request_idle) annotation(
    Line(points = {{-70, -80}, {-80, -80}, {-80, -40}, {-110, -40}}, color = {0, 0, 127}));
  connect(RequestedTorqueLimit.limit1, TorqueMaxIntervention) annotation(
    Line(points = {{-70, -72}, {-104, -72}, {-104, -70}, {-110, -70}}, color = {0, 0, 127}));
  connect(RequestedTorqueLimit.limit2, TorqueMinIntervention) annotation(
    Line(points = {{-70, -88}, {-80, -88}, {-80, -100}, {-110, -100}, {-110, -100}}, color = {0, 0, 127}));
  connect(RequestTorqueLimit_Drive.u, DriverRequestTorque.y) annotation(
    Line(points = {{-38, 14}, {-54, 14}, {-54, 28}, {-60, 28}}, color = {0, 0, 127}));
  connect(RequestTorqueLimit_Drive.y, ECUDrive.Torue_Engine_Target) annotation(
    Line(points = {{-14, 14}, {-12, 14}, {-12, -12}, {-44, -12}, {-44, -32}, {-38, -32}, {-38, -32}}, color = {0, 0, 127}));
  connect(RequestTorqueLimit_Drive.limit1, TorqueMaxIntervention) annotation(
    Line(points = {{-38, 22}, {-50, 22}, {-50, 6}, {-66, 6}, {-66, -62}, {-84, -62}, {-84, -70}, {-110, -70}, {-110, -70}}, color = {0, 0, 127}));
  connect(RequestTorqueLimit_Drive.limit2, TorqueMinIntervention) annotation(
    Line(points = {{-38, 6}, {-46, 6}, {-46, 4}, {-64, 4}, {-64, -64}, {-82, -64}, {-82, -100}, {-110, -100}, {-110, -100}}, color = {0, 0, 127}));
  connect(limiter.u, addFinalOutput.y) annotation(
    Line(points = {{36, 54}, {34, 54}, {34, -10}, {60, -10}, {60, -32}, {58, -32}}, color = {0, 0, 127}));
  connect(Torque_target, RequestTorqueLimit_Drive.y) annotation(
    Line(points = {{130, 0}, {60, 0}, {60, 14}, {-14, 14}}, color = {0, 0, 127}));
  connect(constant1.y, Torque_max) annotation(
    Line(points = {{92, -22}, {130, -22}}, color = {0, 0, 127}));
  connect(constant2.y, Torque_min) annotation(
    Line(points = {{92, -50}, {130, -50}}, color = {0, 0, 127}));
  connect(FuelMpr, switch_fuelmpr.y) annotation(
    Line(points = {{130, 80}, {94, 80}, {94, 122}, {84, 122}}, color = {0, 0, 127}));
  connect(constant8.y, greater1.u1) annotation(
    Line(points = {{71, 177}, {78, 177}, {78, 168}}, color = {0, 0, 127}));
  connect(StarterPower.y, StarterPowerOutput) annotation(
    Line(points = {{184, 186}, {184, 162}, {130, 162}, {130, 138}}, color = {0, 0, 127}));
  connect(and3.y, StarterPower.u) annotation(
    Line(points = {{135, 190}, {150, 190}, {150, 186}, {160, 186}}, color = {255, 0, 255}));
  connect(and2.y, and3.u1) annotation(
    Line(points = {{15, 190}, {112, 190}}, color = {255, 0, 255}));
  connect(greater1.y, and3.u2) annotation(
    Line(points = {{101, 168}, {106, 168}, {106, 182}, {112, 182}}, color = {255, 0, 255}));
  connect(timer.y, greater1.u2) annotation(
    Line(points = {{51, 160}, {78, 160}}, color = {0, 0, 127}));
  connect(and2.y, timer.u) annotation(
    Line(points = {{15, 190}, {20, 190}, {20, 160}, {28, 160}}, color = {255, 0, 255}));
  connect(constant3.y, AccelOff.u1) annotation(
    Line(points = {{-65, 117}, {-54, 117}, {-54, 112}}, color = {0, 0, 127}));
  connect(AccelOff.u2, AccelPedalPosition) annotation(
    Line(points = {{-54, 104}, {-110, 104}}, color = {0, 0, 127}));
  connect(and1.u2, AccelOff.y) annotation(
    Line(points = {{-8, 104}, {-20, 104}, {-20, 112}, {-30, 112}, {-30, 112}}, color = {255, 0, 255}));
  connect(and1.u1, IdleStopFlag.y) annotation(
    Line(points = {{-8, 112}, {-14, 112}, {-14, 140}, {-31, 140}}, color = {255, 0, 255}));
  connect(switch_fuelmpr.u2, and1.y) annotation(
    Line(points = {{60, 122}, {28, 122}, {28, 112}, {16, 112}, {16, 112}}, color = {255, 0, 255}));
  connect(constant4.y, switch_fuelmpr.u1) annotation(
    Line(points = {{40, 136}, {46, 136}, {46, 130}, {60, 130}, {60, 130}}, color = {0, 0, 127}));
  connect(switch_fuelmpr.u3, constant5.y) annotation(
    Line(points = {{60, 114}, {52, 114}, {52, 110}, {48, 110}, {48, 110}}, color = {0, 0, 127}));
  connect(AccelOn.y, and2.u1) annotation(
    Line(points = {{-34, 212}, {-10, 212}, {-10, 190}, {-8, 190}}, color = {255, 0, 255}));
  connect(and2.u2, onOff50.y) annotation(
    Line(points = {{-8, 182}, {-37, 182}}, color = {255, 0, 255}));
  connect(constant7.y, onOff50.reference) annotation(
    Line(points = {{-71, 185}, {-68, 185}, {-68, 188}, {-60, 188}}, color = {0, 0, 127}));
  connect(onOff50.u, EngineSpeed) annotation(
    Line(points = {{-60, 176}, {-98, 176}, {-98, 40}, {-110, 40}}, color = {0, 0, 127}));
  connect(AccelOn.u2, BrakePedalPosition) annotation(
    Line(points = {{-58, 204}, {-94, 204}, {-94, 76}, {-110, 76}, {-110, 76}}, color = {0, 0, 127}));
  connect(constant6.y, AccelOn.u1) annotation(
    Line(points = {{-72, 218}, {-66, 218}, {-66, 212}, {-58, 212}, {-58, 212}}, color = {0, 0, 127}));
  annotation(
    Diagram(coordinateSystem(extent = {{-200, -200}, {200, 200}}, initialScale = 0.5),
               coordinateSystem(initialScale = 0.1)
    ));


end ECU;