within AICE.Examples.METI_2020.Components;

block ECUDrive
  
  parameter String ThrottleMap_drive;
    parameter String ThrottleMap_drive_table;

  Modelica.Blocks.Interfaces.RealOutput throttle_angle_deg annotation(
    Placement(visible = true, transformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealInput Neng annotation(
    Placement(visible = true, transformation(origin = {-110, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealInput Torue_Engine_Target annotation(
    Placement(visible = true, transformation(origin = {-110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable2D combiTable2D(fileName = ThrottleMap_drive, smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, tableName = ThrottleMap_drive_table, tableOnFile = true, verboseRead = true) annotation(
    Placement(visible = true, transformation(origin = {0, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealInput Torque_Engine_Actual annotation(
    Placement(visible = true, transformation(origin = {-110, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Product product annotation(
    Placement(visible = true, transformation(origin = {48, 6}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Nonlinear.Limiter limiter(limitsAtInit = true, uMax = 90, uMin = 0)  annotation(
    Placement(visible = true, transformation(origin = {80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable1D CorrectionFactor(table = [-51, 0.3; -50, 0.3; 0, 1; 50, 3.0; 51, 3.0])  annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Add TorqueError(k1 = 1, k2 = -1)  annotation(
    Placement(visible = true, transformation(origin = {-44, -6}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(combiTable2D.u2, Neng) annotation(
    Line(points = {{-12, 24}, {-61, 24}, {-61, 80}, {-110, 80}}, color = {0, 0, 127}));
  connect(combiTable2D.u1, Torue_Engine_Target) annotation(
    Line(points = {{-12, 36}, {-79, 36}, {-79, 0}, {-110, 0}}, color = {0, 0, 127}));
  connect(combiTable2D.y, product.u1) annotation(
    Line(points = {{12, 30}, {28, 30}, {28, 12}, {36, 12}}, color = {0, 0, 127}));
  connect(limiter.y, throttle_angle_deg) annotation(
    Line(points = {{92, 0}, {102, 0}, {102, 0}, {110, 0}}, color = {0, 0, 127}));
  connect(TorqueError.u1, Torue_Engine_Target) annotation(
    Line(points = {{-56, 0}, {-106, 0}, {-106, 0}, {-110, 0}}, color = {0, 0, 127}));
  connect(TorqueError.u2, Torque_Engine_Actual) annotation(
    Line(points = {{-56, -12}, {-80, -12}, {-80, -80}, {-106, -80}, {-106, -80}, {-110, -80}}, color = {0, 0, 127}));
  connect(CorrectionFactor.u[1], TorqueError.y) annotation(
    Line(points = {{-12, 0}, {-20, 0}, {-20, -6}, {-32, -6}, {-32, -6}}, color = {0, 0, 127}));
  connect(product.u2, CorrectionFactor.y[1]) annotation(
    Line(points = {{36, 0}, {10, 0}, {10, 0}, {12, 0}}, color = {0, 0, 127}));
  connect(limiter.u, product.y) annotation(
    Line(points = {{68, 0}, {64, 0}, {64, 6}, {60, 6}, {60, 6}}, color = {0, 0, 127}));
  annotation(
    Icon(graphics = {Text(origin = {-33, 37}, extent = {{-47, 19}, {121, -93}}, textString = "Driving Torque Controller"), Rectangle(extent = {{-100, 100}, {100, -100}})}, coordinateSystem(initialScale = 0.1)),
    Diagram,
    __OpenModelica_commandLineOptions = "");
end ECUDrive;