within AICE.Examples.METI_2020.Components;

block ECUIdle
  parameter Real Target_Idle_Speed = 650;
  Modelica.Blocks.Sources.Constant targetIdleSpeed(k = Target_Idle_Speed) annotation(
    Placement(visible = true, transformation(origin = {-104, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealOutput throttle_angle_deg annotation(
    Placement(visible = true, transformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealInput Neng annotation(
    Placement(visible = true, transformation(origin = {-110, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealOutput w_engine_idle_radps annotation(
    Placement(visible = true, transformation(origin = {110, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {110, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Continuous.LimPID pid(Ti = 1.0, initType = Modelica.Blocks.Types.InitPID.NoInit, k = 0.01, wd = 0.1, yMax = 3, yMin = -3)  annotation(
    Placement(visible = true, transformation(origin = {-26, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Add add annotation(
    Placement(visible = true, transformation(origin = {30, -6}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable1D TableThrottle_Idle(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [-16.8961, 1.0; 10.146, 3.0; 58.8158, 5.0])  annotation(
    Placement(visible = true, transformation(origin = {-60, -64}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealInput Torue_Engine_Target annotation(
    Placement(visible = true, transformation(origin = {-110, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-110, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(targetIdleSpeed.y, w_engine_idle_radps) annotation(
    Line(points = {{-93, 0}, {-74, 0}, {-74, 70}, {110, 70}}, color = {0, 0, 127}));
  connect(pid.u_s, targetIdleSpeed.y) annotation(
    Line(points = {{-38, 0}, {-93, 0}}, color = {0, 0, 127}));
  connect(pid.u_m, Neng) annotation(
    Line(points = {{-26, -12}, {-68, -12}, {-68, 80}, {-110, 80}}, color = {0, 0, 127}));
  connect(add.u1, pid.y) annotation(
    Line(points = {{18, 0}, {-16, 0}, {-16, 0}, {-14, 0}}, color = {0, 0, 127}));
  connect(add.u2, TableThrottle_Idle.y[1]) annotation(
    Line(points = {{18, -12}, {6, -12}, {6, -64}, {-48, -64}, {-48, -64}}, color = {0, 0, 127}));
  connect(TableThrottle_Idle.u[1], Torue_Engine_Target) annotation(
    Line(points = {{-72, -64}, {-91, -64}, {-91, -80}, {-110, -80}}, color = {0, 0, 127}));
  connect(add.y, throttle_angle_deg) annotation(
    Line(points = {{42, -6}, {74, -6}, {74, 0}, {110, 0}, {110, 0}}, color = {0, 0, 127}));
  annotation(
    Icon(graphics = {Text(origin = {-33, 37}, extent = {{-47, 19}, {121, -93}}, textString = "Idle Speed Controller"), Rectangle(extent = {{-100, 100}, {100, -100}})}, coordinateSystem(initialScale = 0.1)),
    Diagram,
    __OpenModelica_commandLineOptions = "");
end ECUIdle;