within AICE.Examples.METI_2020.Components;

model ECU_Simple
  extends AICE.Icons.Blocks.ECU;
  AICE.Blocks.Interfaces.RealInput AccelPedalOpening annotation(
    Placement(visible = true, transformation(origin = {-100, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput p_boost annotation(
    Placement(visible = true, transformation(origin = {-100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable1D tableThrottle(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0.0, 0.0; 0.1, 10.0; 0.2, 30.0; 0.3, 85; 0.4, 85]) annotation(
    Placement(visible = true, transformation(origin = {-30, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable1D tableP_boost(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [0.0, 0.9; 0.2, 0.9; 0.3, 1.1; 0.4, 1.5; 0.9, 2.5; 1.0, 2.5]) annotation(
    Placement(visible = true, transformation(origin = {-30, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable1D combiTable1D(smoothness = Modelica.Blocks.Types.Smoothness.LinearSegments, table = [-0.1, 0.0; -0.05, 0.0; 0.05, 1.0; 0.1, 1.0]) annotation(
    Placement(visible = true, transformation(origin = { 50, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput ThrottleAngle annotation(
    Placement(visible = true, transformation(origin = {100, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput WasteGateOpening annotation(
    Placement(visible = true, transformation(origin = {100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput FuelMpr annotation(
    Placement(visible = true, transformation(origin = {100, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput StarterVoltage annotation(
    Placement(visible = true, transformation(origin = {100, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant const1(k = 1)  annotation(
    Placement(visible = true, transformation(origin = {50, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant0(k = 0)  annotation(
    Placement(visible = true, transformation(origin = {50, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Gain deg2rad(k = 0.0174532925)  annotation(
    Placement(visible = true, transformation(origin = {10, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Gain pa2bar(k = 0.00001) annotation(
    Placement(visible = true, transformation(origin = {-58, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Add p_boost_diff(k1 = -1)  annotation(
    Placement(visible = true, transformation(origin = {10, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(AccelPedalOpening, tableThrottle.u[1]) annotation(
    Line(points = {{-100, 80}, {-44, 80}, {-44, 80}, {-42, 80}}, color = {0, 0, 127}));
  connect(tableP_boost.u[1], AccelPedalOpening) annotation(
    Line(points = {{-42, 50}, {-60, 50}, {-60, 80}, {-100, 80}, {-100, 80}}, color = {0, 0, 127}));
  connect(const1.y, FuelMpr) annotation(
    Line(points = {{61, -10}, {81.5, -10}, {81.5, -20}, {100, -20}}, color = {0, 0, 127}));
  connect(constant0.y, StarterVoltage) annotation(
    Line(points = {{62, -50}, {80, -50}, {80, -40}, {100, -40}, {100, -40}}, color = {0, 0, 127}));
  connect(combiTable1D.y[1], WasteGateOpening) annotation(
    Line(points = {{62, 30}, {80, 30}, {80, 60}, {100, 60}, {100, 60}}, color = {0, 0, 127}));
  connect(tableThrottle.y[1], deg2rad.u) annotation(
    Line(points = {{-18, 80}, {-2, 80}, {-2, 80}, {-2, 80}}, color = {0, 0, 127}));
  connect(deg2rad.y, ThrottleAngle) annotation(
    Line(points = {{22, 80}, {92, 80}, {92, 80}, {100, 80}}, color = {0, 0, 127}));
  connect(p_boost_diff.y, combiTable1D.u[1]) annotation(
    Line(points = {{22, 30}, {36, 30}, {36, 30}, {38, 30}}, color = {0, 0, 127}));
  connect(p_boost_diff.u2, pa2bar.y) annotation(
    Line(points = {{-2, 24}, {-20, 24}, {-20, 30}, {-46, 30}, {-46, 30}}, color = {0, 0, 127}));
  connect(p_boost_diff.u1, tableP_boost.y[1]) annotation(
    Line(points = {{-2, 36}, {-10, 36}, {-10, 50}, {-18, 50}, {-18, 50}}, color = {0, 0, 127}));
  connect(pa2bar.u, p_boost) annotation(
    Line(points = {{-70, 30}, {-80, 30}, {-80, 60}, {-100, 60}, {-100, 60}}, color = {0, 0, 127}));
end ECU_Simple;