within AICE.Examples.METI_2020.Components;

block EngineRoom
  extends AICE.Icons.HeatTransfer.EngineRoom;
  parameter SI.Temperature TempEngineRoom;
  parameter SI.CoefficientOfHeatTransfer HTCEngineRoom;
  parameter SI.HeatFlowRate HeatrateEngineSurface;

  Modelica.Blocks.Sources.Constant tempEngineRoomConstant(k = TempEngineRoom)  annotation(
    Placement(visible = true, transformation(origin = {0, 66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant hTCEngineRoomConstant(k = HTCEngineRoom)  annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.TemperatureOutput tempEngineRoomOutput annotation(
    Placement(visible = true, transformation(origin = {106, 66}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {106, 66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealOutput hTCEngineRoomOutput annotation(
    Placement(visible = true, transformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant heatrateEngineRoomConst(k = HeatrateEngineSurface) annotation(
    Placement(visible = true, transformation(origin = {0, -66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.HeatFlowRateOutput heatFlowRateOutput annotation(
    Placement(visible = true, transformation(origin = {100, -66}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -66}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(tempEngineRoomConstant.y, tempEngineRoomOutput) annotation(
    Line(points = {{11, 66}, {106, 66}}, color = {0, 0, 127}));
  connect(hTCEngineRoomConstant.y, hTCEngineRoomOutput) annotation(
    Line(points = {{11, 0}, {100, 0}}, color = {0, 0, 127}));
  connect(heatrateEngineRoomConst.y, heatFlowRateOutput) annotation(
    Line(points = {{12, -66}, {100, -66}}, color = {0, 0, 127}));
end EngineRoom;