within AICE.Examples.METI_2020.Components;

model MultiCylinderEngine_FMEPB
  extends Icons.PowerUnits.MultiCylinder;
  extends BaseClasses.MultiCylinderEngineParameters;
  extends AICE.PowerUnits.Combustions.Interfaces.PartialFluidEngine;
  //extends AICE.Blocks.Mechanics.Rotational.Components.BaseClasses.FMEPBParameters;
  AICE.Examples.METI_2020.Components.SingleCylinderEngine[nCylinders] singleCylinderEngines(redeclare each replaceable package Medium = Medium, each useHeatPort = true, each V_displacement = V_displacement / nCylinders, each compressionRatio = compressionRatio, each l_connRod = l_connRod, each offset_crank = offset_crank, each bore = bore, each m_wiebe = m_wiebe, each phi_combustion_begin = phi_combustion_begin, each phi_combustion_period = phi_combustion_period, each c1_woschni_intakeExhaust = c1_woschni_intakeExhaust, each c1_woschni_compressionPower = c1_woschni_compressionPower, each c2_woschni = c2_woschni, each cam_intake(phi_centor = intakeValveCentor, fileName_lift = fileName_lift_intake, fileName_CD = fileName_CD_intake), each valve_intake(CvData = Modelica.Fluid.Types.CvTypes.Av, Av = AICE.Math.diameter2area(d_valve_intake), p_nominal = 1e5, dp_nominal = 1, m_flow_nominal = 0.01), each cam_exhaust(phi_centor = exhaustValveCentor, fileName_lift = fileName_lift_exhaust, fileName_CD = fileName_CD_exhaust), each valve_exhaust(CvData = Modelica.Fluid.Types.CvTypes.Av, Av = AICE.Math.diameter2area(d_valve_exhaust), p_nominal = 1e5, dp_nominal = 1, m_flow_nominal = 0.01), each injector(airByFuel = airByFuel, injectionStart = injectionStart, injectionPeriod = injectionPeriod), chamber(p_start = {p_start_chamber1, p_start_chamber2, p_start_chamber3, p_start_chamber4}, T_start = {T_start_chamber1, T_start_chamber2, T_start_chamber3, T_start_chamber4})) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  // TODO: correct value
  // TODO: correct value
  // TODO: correct value
  // TODO: correct value
  // TODO: correct value
  // TODO: correct value
  AICE.Fluid.Fittings.LumpedManifold intakeManifold(redeclare replaceable package Medium = Medium, final nCylinders = nCylinders, V = V_intakeManifold, p_start = p_start_intakeManifold, use_T_start = true, T_start = T_start_intakeManifold) annotation(
    Placement(visible = true, transformation(origin = {-60, 70}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Fluid.Fittings.LumpedManifold exhaustManifold(redeclare replaceable package Medium = Medium, final nCylinders = nCylinders, V = V_exhaustManifold, p_start = p_start_exhaustManifold, use_T_start = true, T_start = T_start_exhaustManifold) annotation(
    Placement(visible = true, transformation(origin = {60, 70}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  AICE.Mechanics.Rotational.Components.FMEP4CylinderCrankShaft crankShaft(
    redeclare AICE.Blocks.Mechanics.Rotational.Components.BaseClasses.FMEPB fmep(p_cyl_fmep = singleCylinderEngines[1].chamber.medium.p)) annotation(
    Placement(visible = true, transformation(origin = {60, 0}, extent = {{20, -20}, {-20, 20}}, rotation = 0)));
      AICE.Blocks.Interfaces.RealInput fuelMprInput_multi annotation(
    Placement(visible = true, transformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  //ここで＃1気筒の筒内圧を取得しFMEPBに渡す

//8行目の宣言内でのアサインが何故か効いていない．バグ？そこでここで再度初期値定義
initial equation
    singleCylinderEngines[1].chamber.medium.p = p_start_chamber1;
    singleCylinderEngines[2].chamber.medium.p = p_start_chamber2;    
    singleCylinderEngines[3].chamber.medium.p = p_start_chamber3;
    singleCylinderEngines[4].chamber.medium.p = p_start_chamber4; 
    exhaustManifold.volume.medium.p = p_start_exhaustManifold;
    exhaustManifold.volume.medium.T = T_start_exhaustManifold;
    exhaustManifold.volume.medium.Xi[:] = Medium.reference_X[:];
equation
  connect(port_intake, intakeManifold.port_a) annotation(
    Line(points = {{-60, 100}, {-60, 80}}, color = {0, 127, 255}));
  connect(port_exhaust, exhaustManifold.port_a) annotation(
    Line(points = {{+60, 100}, {+60, 80}}, color = {0, 127, 255}));
  connect(intakeManifold.ports_b[:], singleCylinderEngines[:].port_intake) annotation(
    Line(points = {{-60, 60}, {-60, 40}, {-12, 40}, {-12, 20}}, color = {0, 127, 255}, thickness = 1));
  connect(exhaustManifold.ports_b[:], singleCylinderEngines[:].port_exhaust) annotation(
    Line(points = {{+60, 60}, {+60, 40}, {+12, 40}, {+12, 20}}, color = {0, 127, 255}, thickness = 1));
  connect(singleCylinderEngines[:].flange, crankShaft.flanges_b[:]) annotation(
    Line(points = {{20, 0}, {40, 0}}, thickness = 1));
  connect(flange, crankShaft.flange_a) annotation(
    Line(points = {{100, 0}, {80, 0}}));
  for i in 1:nCylinders loop
    connect(singleCylinderEngines[i].heatPort, heatPort) annotation(
      Line(points = {{-20, -20}, {-60, -20}, {-60, -100}, {-100, -100}}, color = {191, 0, 0}, thickness = 1));
  end for;
  
  for i in 1:nCylinders loop
    connect(singleCylinderEngines[i].fuelmpr, fuelMprInput_multi) annotation(
      Line(points = {{-20, 8}, {-98, 8}, {-98, 0}, {-100, 0}}, color = {0, 0, 127}, thickness = 1));
  end for;

  
  annotation(
    Diagram(graphics = {Text(origin = {10, -30}, extent = {{-10, -10}, {10, 10}}, textString = "x 4")}, coordinateSystem(initialScale = 0.1)),
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
  __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end MultiCylinderEngine_FMEPB;
