within AICE.Examples.METI_2020.Components;

block MultiCylinderEngine_TFAOOTII
  extends Icons.PowerUnits.MultiCylinder;
  extends BaseClasses.MultiCylinderEngineParameters;
  
  // Parameters
  parameter AICE.Blocks.Types.Energy energy_port_intake = AICE.Blocks.Types.Energy.Sink annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_port_exhaust = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_heatPort = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  parameter AICE.Blocks.Types.Energy energy_flange = AICE.Blocks.Types.Energy.Source annotation(
    Dialog(tab = "Advanced", group = "Energy directions"));
  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;
  parameter SI.Angle phi_start;

  // interfaces
  AICE.Blocks.Interfaces.AbsolutePressureOutput absolutePressure_intake annotation(
    Placement(visible = true, transformation(origin = {-10, 100}, extent = {{-5, -5}, {5, 5}}, rotation = 90), iconTransformation(origin = {-10, 100}, extent = {{-5, -5}, {5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.TemperatureOutput temperature_intake annotation(
    Placement(visible = true, transformation(origin = {-20, 100}, extent = {{5, 5}, {-5, -5}}, rotation = -90), iconTransformation(origin = {-20, 100}, extent = {{5, 5}, {-5, -5}}, rotation = -90)));
  AICE.Blocks.Interfaces.SpecificEnthalpyOutput specificEnthalpy_outflow_intake annotation(
    Placement(visible = true, transformation(origin = {-30, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90), iconTransformation(origin = {-30, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.MassFractionsOutput[Medium.nXi] massFractions_outflow_intake annotation(
    Placement(visible = true, transformation(origin = {-40, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90), iconTransformation(origin = {-40, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.MassFractionsInput[Medium.nXi] massFractions_mix_intake annotation(
    Placement(visible = true, transformation(origin = {-60, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90), iconTransformation(origin = {-60, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.SpecificEnthalpyInput specificEnthalpy_mix_intake annotation(
    Placement(visible = true, transformation(origin = {-70, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90), iconTransformation(origin = {-70, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.HeatFlowRateInput enthalpyFlowRate_intake annotation(
    Placement(visible = true, transformation(origin = {-90, 100}, extent = {{-5, 5}, {5, -5}}, rotation = -90), iconTransformation(origin = {-90, 100}, extent = {{-5, 5}, {5, -5}}, rotation = -90)));
  AICE.Blocks.Interfaces.MassFlowRateInput massFlowRate_intake annotation(
    Placement(visible = true, transformation(origin = {-80, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90), iconTransformation(origin = {-80, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.AbsolutePressureOutput absolutePressure_exhaust annotation(
    Placement(visible = true, transformation(origin = {90, 100}, extent = {{-5, -5}, {5, 5}}, rotation = 90), iconTransformation(origin = {90, 100}, extent = {{-5, -5}, {5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.TemperatureOutput temperature_exhaust annotation(
    Placement(visible = true, transformation(origin = {80, 100}, extent = {{-5, -5}, {5, 5}}, rotation = 90), iconTransformation(origin = {80, 100}, extent = {{-5, -5}, {5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.SpecificEnthalpyOutput specificEnthalpy_outflow_exhaust annotation(
    Placement(visible = true, transformation(origin = {+70, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90), iconTransformation(origin = {+70, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.MassFractionsOutput[Medium.nXi] massFractions_outflow_exhaust annotation(
    Placement(visible = true, transformation(origin = {+60, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90), iconTransformation(origin = {+60, 100}, extent = {{-5, -5}, {+5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.MassFractionsInput[Medium.nXi] massFractions_mix_exhaust annotation(
    Placement(visible = true, transformation(origin = {+40, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90), iconTransformation(origin = {+40, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.SpecificEnthalpyInput specificEnthalpy_mix_exhaust annotation(
    Placement(visible = true, transformation(origin = {+30, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90), iconTransformation(origin = {+30, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.HeatFlowRateInput enthalpyFlowRate_exhaust annotation(
    Placement(visible = true, transformation(origin = {10, 100}, extent = {{-5, 5}, {5, -5}}, rotation = -90), iconTransformation(origin = {10, 100}, extent = {{-5, 5}, {5, -5}}, rotation = -90)));
  AICE.Blocks.Interfaces.MassFlowRateInput massFlowRate_exhaust annotation(
    Placement(visible = true, transformation(origin = {+20, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90), iconTransformation(origin = {+20, 100}, extent = {{+5, -5}, {-5, 5}}, rotation = 90)));
  AICE.Blocks.Interfaces.AngularVelocityInput angularVelocity annotation(
    Placement(visible = true, transformation(origin = {+100, +60}, extent = {{+10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {+100, +60}, extent = {{+10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.TorqueOutput torque annotation(
    Placement(visible = true, transformation(origin = {+100, -60}, extent = {{-10, -10}, {+10, 10}}, rotation = 0), iconTransformation(origin = {+100, -60}, extent = {{-10, -10}, {+10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.TemperatureInput temperature annotation(
    Placement(visible = true, transformation(origin = {60, -100}, extent = {{+10, -10}, {-10, 10}}, rotation = -90), iconTransformation(origin = {60, -100}, extent = {{+10, -10}, {-10, 10}}, rotation = -90)));
  AICE.Blocks.Interfaces.HeatFlowRateOutput heatFlowRate annotation(
    Placement(visible = true, transformation(origin = {-60, -100}, extent = {{-10, -10}, {+10, 10}}, rotation = -90), iconTransformation(origin = {-60, -100}, extent = {{-10, -10}, {+10, 10}}, rotation = -90)));

  // adaptors
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_intake(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_intake) annotation(
    Placement(visible = true, transformation(origin = {-50, 50}, extent = {{-10, +20}, {10, -20}}, rotation = 90)));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.AdaptorThermoFluid_AOTI adaptor_exhaust(
    redeclare replaceable package Medium = Medium,
    energy = energy_port_exhaust) annotation(
    Placement(visible = true, transformation(origin = {+50, 50}, extent = {{-10, +20}, {10, -20}}, rotation = 90)));
  AICE.Blocks.Mechanics.Rotational.Interfaces.Adaptors.Adaptor_AITO adaptorRotational(
    use_phi_start = true,
    phi_start = phi_start,
    energy = energy_flange) annotation(
    Placement(visible = true, transformation(origin = {50, 0}, extent = {{-10, -20}, {10, 20}}, rotation = 0)));
  AICE.Blocks.Thermal.HeatTransfer.Interfaces.Adaptors.Adaptor_AITO adaptorHeat(
    energy = energy_heatPort) annotation(
    Placement(visible = true, transformation(origin = {-20, -50}, extent = {{-10, -20}, {10, 20}}, rotation = -90)));
 
  // component
  AICE.Examples.METI_2020.Components.MultiCylinderEngine_FMEPB acausalModel(
    redeclare replaceable package Medium = Medium, 
    T_start_chamber1 = T_start_chamber1, 
    T_start_chamber2 = T_start_chamber2, 
    T_start_chamber3 = T_start_chamber3, 
    T_start_chamber4 = T_start_chamber4, 
    T_start_exhaustManifold = T_start_exhaustManifold, 
    T_start_intakeManifold = T_start_intakeManifold, 
    V_displacement = V_displacement, 
    V_exhaustManifold = V_exhaustManifold, 
    V_intakeManifold = V_intakeManifold, 
    airByFuel = airByFuel, 
    bore = bore, 
    c1_woschni_compressionPower = c1_woschni_compressionPower, 
    c1_woschni_intakeExhaust = c1_woschni_intakeExhaust, 
    c2_woschni = c2_woschni, 
    compressionRatio = compressionRatio, 
    d_valve_exhaust = d_valve_exhaust, 
    d_valve_intake = d_valve_intake, 
    exhaustValveCentor = exhaustValveCentor, 
    fileName_CD_exhaust = fileName_CD_exhaust, 
    fileName_CD_intake = fileName_CD_intake, 
    fileName_lift_exhaust = fileName_lift_exhaust, 
    fileName_lift_intake = fileName_lift_intake, 
    injectionPeriod = injectionPeriod, 
    injectionStart = injectionStart, 
    intakeValveCentor = intakeValveCentor, 
    l_connRod = l_connRod, 
    m_wiebe = m_wiebe, 
    offset_crank = offset_crank, 
    p_start_chamber1 = p_start_chamber1, 
    p_start_chamber2 = p_start_chamber2, 
    p_start_chamber3 = p_start_chamber3, 
    p_start_chamber4 = p_start_chamber4, 
    p_start_exhaustManifold = p_start_exhaustManifold, 
    p_start_intakeManifold = p_start_intakeManifold, 
    phi_combustion_begin = phi_combustion_begin, 
    phi_combustion_period = phi_combustion_period, 
    useHeatPort = true) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput fuelMprInput annotation(
    Placement(visible = true, transformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(acausalModel.port_intake, adaptor_intake.port_a) annotation(
    Line(points = {{-12, 20}, {-12, 30}, {-50, 30}, {-50, 40}}, color = {0, 127, 255}));
  connect(acausalModel.port_exhaust, adaptor_exhaust.port_a) annotation(
    Line(points = {{+12, 20}, {+12, 30}, {+50, 30}, {+50, 40}}, color = {0, 127, 255}));
  connect(acausalModel.flange, adaptorRotational.flange_a) annotation(
    Line(points = {{20, 0}, {40, 0}}));
  connect(adaptorRotational.angularVelocity_b, angularVelocity) annotation(
    Line(points = {{60, +12}, {80, +12}, {80, +60}, {100, +60}}, color = {0, 0, 127}));
  connect(adaptorRotational.torque_b, torque) annotation(
    Line(points = {{60, -12}, {80, -12}, {80, -60}, {100, -60}}, color = {0, 0, 127}));
  connect(acausalModel.heatPort, adaptorHeat.port_a) annotation(
    Line(points = {{-20, -20}, {-20, -40}}, color = {191, 0, 0}));
  connect(adaptorHeat.temperature_b, temperature) annotation(
    Line(points = {{-8, -60}, {-8, -80}, {+60, -80}, {+60, -100}}));
  connect(adaptorHeat.heatFlowRate_b, heatFlowRate) annotation(
    Line(points = {{-32, -60}, {-32, -80}, {-60, -80}, {-60, -100}}, color = {0, 0, 127}));

  connect(enthalpyFlowRate_intake, adaptor_intake.enthalpyFlowRate_b) annotation(
    Line(points = {{-90, 100}, {-90, 100}, {-90, 66}, {-66, 66}, {-66, 60}, {-66, 60}}, color = {0, 0, 127}));
  connect(massFlowRate_intake, adaptor_intake.massFlowRate_b) annotation(
    Line(points = {{-80, 100}, {-80, 100}, {-80, 74}, {-62, 74}, {-62, 60}, {-62, 60}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_intake, adaptor_intake.specificEnthalpy_mix_b) annotation(
    Line(points = {{-70, 100}, {-70, 100}, {-70, 80}, {-58, 80}, {-58, 60}, {-58, 60}}, color = {0, 0, 127}));
  connect(massFractions_mix_intake[:], adaptor_intake.massFractions_mix_b[:]) annotation(
    Line(points = {{-60, 100}, {-60, 100}, {-60, 86}, {-54, 86}, {-54, 60}, {-54, 60}}, color = {0, 0, 127}, thickness = 0.5));

  connect(massFractions_outflow_intake[:], adaptor_intake.massFractions_outflow_b[:]) annotation(
    Line(points = {{-40, 100}, {-40, 100}, {-40, 86}, {-46, 86}, {-46, 60}, {-46, 60}}, color = {0, 0, 127}, thickness = 0.5));
  connect(specificEnthalpy_outflow_intake, adaptor_intake.specificEnthalpy_outflow_b) annotation(
    Line(points = {{-30, 100}, {-30, 100}, {-30, 80}, {-42, 80}, {-42, 60}, {-42, 60}}, color = {0, 0, 127}));
  connect(temperature_intake, adaptor_intake.temperature_b) annotation(
    Line(points = {{-20, 100}, {-20, 100}, {-20, 74}, {-38, 74}, {-38, 60}, {-38, 60}}, color = {0, 0, 127}));
  connect(absolutePressure_intake, adaptor_intake.absolutePressure_b) annotation(
    Line(points = {{-10, 100}, {-10, 100}, {-10, 66}, {-34, 66}, {-34, 60}, {-34, 60}}, color = {0, 0, 127}));

  connect(enthalpyFlowRate_exhaust, adaptor_exhaust.enthalpyFlowRate_b) annotation(
    Line(points = {{10, 100}, {10, 100}, {10, 66}, {34, 66}, {34, 60}, {34, 60}}, color = {0, 0, 127}));
  connect(massFlowRate_exhaust, adaptor_exhaust.massFlowRate_b) annotation(
    Line(points = {{20, 100}, {20, 100}, {20, 74}, {38, 74}, {38, 60}, {38, 60}}, color = {0, 0, 127}));
  connect(specificEnthalpy_mix_exhaust, adaptor_exhaust.specificEnthalpy_mix_b) annotation(
    Line(points = {{30, 100}, {30, 100}, {30, 80}, {42, 80}, {42, 60}, {42, 60}}, color = {0, 0, 127}));
  connect(massFractions_mix_exhaust[:], adaptor_exhaust.massFractions_mix_b[:]) annotation(
    Line(points = {{40, 100}, {40, 100}, {40, 86}, {46, 86}, {46, 60}, {46, 60}}, color = {0, 0, 127}, thickness = 0.5));

  connect(massFractions_outflow_exhaust[:], adaptor_exhaust.massFractions_outflow_b[:]) annotation(
    Line(points = {{60, 100}, {60, 100}, {60, 86}, {54, 86}, {54, 60}, {54, 60}}, color = {0, 0, 127}, thickness = 0.5));
  connect(specificEnthalpy_outflow_exhaust, adaptor_exhaust.specificEnthalpy_outflow_b) annotation(
    Line(points = {{70, 100}, {70, 100}, {70, 80}, {58, 80}, {58, 60}, {58, 60}}, color = {0, 0, 127}));
  connect(temperature_exhaust, adaptor_exhaust.temperature_b) annotation(
    Line(points = {{80, 100}, {80, 100}, {80, 74}, {62, 74}, {62, 60}, {62, 60}}, color = {0, 0, 127}));
  connect(absolutePressure_exhaust, adaptor_exhaust.absolutePressure_b) annotation(
    Line(points = {{90, 100}, {90, 100}, {90, 66}, {66, 66}, {66, 60}, {66, 60}}, color = {0, 0, 127}));
 connect(fuelMprInput, acausalModel.fuelMprInput_multi) annotation(
    Line(points = {{-100, 0}, {-22, 0}, {-22, 0}, {-20, 0}}, color = {0, 0, 127}));
end MultiCylinderEngine_TFAOOTII;