within AICE.Examples.METI_2020.Components;

block SampleEngineUnitNA
  extends Icons.PowerUnits.EngineUnit;
  extends AICE.Examples.METI_2020.Components.BaseClasses.PartialPowerUnitWithHeat;
  extends BaseClasses.SampleEngineUnitParameters;
  replaceable package Medium = AICE.Media.IdealGases.Examples.Sample5MixtureGas;
  // components
  AICE.Blocks.Fluid.Compressible.Sources.FixedBoundary_TFAOTI intakeBoundary(redeclare replaceable package Medium = Medium, energy_port = AICE.Blocks.Types.Energy.Source, use_p = true, p = p_intake, use_T = true, T = T_intake) annotation(
    Placement(visible = true, transformation(origin = {-210, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Fittings.SimpleGenericOrifice_TFAIITOO intakePressureDrop(redeclare replaceable package Medium = Medium, diameter = d_intakePipe, zeta = 4) annotation(
    Placement(visible = true, transformation(origin = {-170, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Vessels.ClosedVolume_TFAOOTII intakeVolume(redeclare replaceable package Medium = Medium, V = V_intakePipe, p_start = p_start_intakePipe, use_T_start = true, T_start = T_start_intakePipe) annotation(
    Placement(visible = true, transformation(origin = {-130, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Fluid.Valves.BaseClasses.ValveCharacteristics.Butterfly characteristic annotation(
    Placement(visible = true, transformation(origin = {-130, 180}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Valves.ValveCompressible_TFAIITOO throttle(redeclare replaceable package Medium = Medium, CvData = Modelica.Fluid.Types.CvTypes.Av, Av = AICE.Math.diameter2area(d_throttle), p_nominal = Medium.p_default, dp_nominal = 1, m_flow_nominal = 1e-3) annotation(
    Placement(visible = true, transformation(origin = {-90, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Examples.METI_2020.Components.MultiCylinderEngine_TFAOOTII multiCylinderEngine(redeclare replaceable package Medium = Medium, phi_start = 0.0, V_intakeManifold = V_intakeManifold, p_start_intakeManifold = p_start_intakeManifold, T_start_intakeManifold = T_start_intakeManifold, V_exhaustManifold = V_exhaustManifold, p_start_exhaustManifold = p_start_exhaustManifold, T_start_exhaustManifold = T_start_exhaustManifold, V_displacement = V_displacement, compressionRatio = compressionRatio, l_connRod = l_connRod, offset_crank = offset_crank, bore = bore, intakeValveCentor = intakeValveCentor, d_valve_intake = d_valve_intake, exhaustValveCentor = exhaustValveCentor, d_valve_exhaust = d_valve_exhaust, airByFuel = airByFuel, injectionStart = injectionStart, injectionPeriod = injectionPeriod, p_start_chamber1 = p_start_chamber1, p_start_chamber2 = p_start_chamber2, p_start_chamber3 = p_start_chamber3, p_start_chamber4 = p_start_chamber4, T_start_chamber1 = T_start_chamber1, T_start_chamber2 = T_start_chamber2, T_start_chamber3 = T_start_chamber3, T_start_chamber4 = T_start_chamber4, m_wiebe = m_wiebe, phi_combustion_begin = phi_combustion_begin, phi_combustion_period = phi_combustion_period, c1_woschni_intakeExhaust = c1_woschni_intakeExhaust, c1_woschni_compressionPower = c1_woschni_compressionPower, c2_woschni = c2_woschni, fileName_lift_exhaust = fileName_lift_exhaust, fileName_CD_exhaust = fileName_CD_exhaust, fileName_lift_intake = fileName_lift_intake, fileName_CD_intake = fileName_CD_intake) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Fittings.SimpleGenericOrifice_TFAIITOO exhaustPressureDrop(redeclare replaceable package Medium = Medium, diameter = d_exhaustPipe, zeta = 4) annotation(
    Placement(visible = true, transformation(origin = {150, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Sources.FixedBoundary_TFAOTI exhaustBoundary(redeclare replaceable package Medium = Medium, use_p = true, p = p_exhaust, use_T = true, T = T_exhaust) annotation(
    Placement(visible = true, transformation(origin = {190, 110}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  SI.MassFlowRate 'fuelFlowRates'[nCylinders] = multiCylinderEngine.acausalModel.singleCylinderEngines[:].injector.fuelFlowRate;
  Modelica.Blocks.Sources.RealExpression fuelFlowRates[nCylinders](y = 'fuelFlowRates') annotation(
    Placement(visible = true, transformation(origin = {80, -100}, extent = {{-20, -10}, {20, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Sum fuelFlowRate_total(nin = nCylinders) annotation(
    Placement(visible = true, transformation(origin = {130, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.MassFlowRateOutput fuelFlowRate annotation(
    Placement(visible = true, transformation(origin = {180, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-60, 60}, extent = {{-5, -5}, {5, 5}}, rotation = 0)));
  AICE.Blocks.Interfaces.RealInput fuelMpr annotation(
    Placement(visible = true, transformation(origin = {-240, 120}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-98, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(phi_throttle, characteristic.u) annotation(
    Line(points = {{-240, 0}, {-230, 0}, {-230, 180}, {-140, 180}}, color = {0, 0, 127}));
  connect(characteristic.y, throttle.opening) annotation(
    Line(points = {{-120, 180}, {-90, 180}, {-90, 120}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.angularVelocity, angularVelocity) annotation(
    Line(points = {{20, +12}, {220, +12}, {220, +60}, {240, +60}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.torque, torque) annotation(
    Line(points = {{20, -12}, {220, -12}, {220, -60}, {240, -60}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.temperature, temperature) annotation(
    Line(points = {{+12, -20}, {+12, -160}, {+60, -160}, {+60, -200}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.heatFlowRate, heatFlowRate) annotation(
    Line(points = {{-12, -20}, {-12, -160}, {-60, -160}, {-60, -200}}, color = {0, 0, 127}));
// fuel flow rate monitor code
  connect(fuelFlowRates[:].y, fuelFlowRate_total.u) annotation(
    Line(points = {{100, -100}, {120, -100}}, color = {0, 0, 127}));
  connect(fuelFlowRate_total.y, fuelFlowRate) annotation(
    Line(points = {{140, -100}, {180, -100}}, color = {0, 0, 127}));

  connect(intakeBoundary.enthalpyFlowRate, intakePressureDrop.enthalpyFlowRate_a) annotation(
    Line(points = {{-200, 102}, {-180, 102}, {-180, 102}, {-180, 102}}, color = {0, 0, 127}));
  connect(intakeBoundary.massFlowRate, intakePressureDrop.massFlowRate_a) annotation(
    Line(points = {{-200, 104}, {-180, 104}, {-180, 104}, {-180, 104}}, color = {0, 0, 127}));
  connect(intakeBoundary.specificEnthalpy_mix, intakePressureDrop.specificEnthalpy_outflow_a) annotation(
    Line(points = {{-200, 106}, {-180, 106}, {-180, 106}, {-180, 106}}, color = {0, 0, 127}));
  connect(intakeBoundary.absolutePressure, intakePressureDrop.absolutePressure_a) annotation(
    Line(points = {{-200, 118}, {-180, 118}, {-180, 118}, {-180, 118}}, color = {0, 0, 127}));
  connect(intakeBoundary.temperature, intakePressureDrop.temperature_a) annotation(
    Line(points = {{-200, 116}, {-180, 116}, {-180, 116}, {-180, 116}}, color = {0, 0, 127}));
  connect(intakeBoundary.specificEnthalpy_outflow, intakePressureDrop.specificEnthalpy_mix_a) annotation(
    Line(points = {{-200, 114}, {-180, 114}, {-180, 114}, {-180, 114}}, color = {0, 0, 127}));
  connect(intakeBoundary.massFractions_mix[:], intakePressureDrop.massFractions_outflow_a[:]) annotation(
    Line(points = {{-200, 108}, {-180, 108}, {-180, 108}, {-180, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakeBoundary.massFractions_outflow[:], intakePressureDrop.massFractions_mix_a[:]) annotation(
    Line(points = {{-200, 112}, {-180, 112}, {-180, 112}, {-180, 112}}, color = {0, 0, 127}, thickness = 0.5));

  connect(intakePressureDrop.enthalpyFlowRate_b, intakeVolume.enthalpyFlowRate_a) annotation(
    Line(points = {{-160, 102}, {-140, 102}, {-140, 102}, {-140, 102}}, color = {0, 0, 127}));
  connect(intakePressureDrop.massFlowRate_b, intakeVolume.massFlowRate_a) annotation(
    Line(points = {{-160, 104}, {-140, 104}, {-140, 104}, {-140, 104}}, color = {0, 0, 127}));
  connect(intakePressureDrop.specificEnthalpy_outflow_b, intakeVolume.specificEnthalpy_mix_a) annotation(
    Line(points = {{-160, 106}, {-140, 106}, {-140, 106}, {-140, 106}}, color = {0, 0, 127}));
  connect(intakePressureDrop.specificEnthalpy_mix_b, intakeVolume.specificEnthalpy_outflow_a) annotation(
    Line(points = {{-160, 114}, {-140, 114}, {-140, 114}, {-140, 114}}, color = {0, 0, 127}));
  connect(intakePressureDrop.temperature_b, intakeVolume.temperature_a) annotation(
    Line(points = {{-160, 116}, {-140, 116}, {-140, 116}, {-140, 116}}, color = {0, 0, 127}));
  connect(intakePressureDrop.absolutePressure_b, intakeVolume.absolutePressure_a) annotation(
    Line(points = {{-160, 118}, {-140, 118}, {-140, 118}, {-140, 118}}, color = {0, 0, 127}));
  connect(intakePressureDrop.massFractions_outflow_b[:], intakeVolume.massFractions_mix_a[:]) annotation(
    Line(points = {{-160, 108}, {-140, 108}, {-140, 108}, {-140, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakePressureDrop.massFractions_mix_b[:], intakeVolume.massFractions_outflow_a[:]) annotation(
    Line(points = {{-160, 112}, {-140, 112}, {-140, 112}, {-140, 112}}, color = {0, 0, 127}, thickness = 0.5));

  connect(intakeVolume.enthalpyFlowRate_b, throttle.enthalpyFlowRate_a) annotation(
    Line(points = {{-120, 102}, {-100, 102}, {-100, 102}, {-100, 102}}, color = {0, 0, 127}));
  connect(intakeVolume.massFlowRate_b, throttle.massFlowRate_a) annotation(
    Line(points = {{-120, 104}, {-100, 104}, {-100, 104}, {-100, 104}}, color = {0, 0, 127}));
  connect(intakeVolume.specificEnthalpy_mix_b, throttle.specificEnthalpy_outflow_a) annotation(
    Line(points = {{-120, 106}, {-100, 106}, {-100, 106}, {-100, 106}}, color = {0, 0, 127}));
  connect(intakeVolume.specificEnthalpy_outflow_b, throttle.specificEnthalpy_mix_a) annotation(
    Line(points = {{-120, 114}, {-100, 114}, {-100, 114}, {-100, 114}}, color = {0, 0, 127}));
  connect(intakeVolume.temperature_b, throttle.temperature_a) annotation(
    Line(points = {{-120, 116}, {-100, 116}, {-100, 116}, {-100, 116}}, color = {0, 0, 127}));
  connect(intakeVolume.absolutePressure_b, throttle.absolutePressure_a) annotation(
    Line(points = {{-120, 118}, {-100, 118}, {-100, 118}, {-100, 118}}, color = {0, 0, 127}));
  connect(intakeVolume.massFractions_mix_b[:], throttle.massFractions_outflow_a[:]) annotation(
    Line(points = {{-120, 108}, {-100, 108}, {-100, 108}, {-100, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakeVolume.massFractions_outflow_b[:],throttle.massFractions_mix_a[:]) annotation(
    Line(points = {{-120, 112}, {-100, 112}, {-100, 112}, {-100, 112}}, color = {0, 0, 127}, thickness = 0.5));

  connect(throttle.enthalpyFlowRate_b, multiCylinderEngine.enthalpyFlowRate_intake) annotation(
    Line(points = {{-80, 102}, {-18, 102}, {-18, 20}, {-18, 20}}, color = {0, 0, 127}));
  connect(throttle.massFlowRate_b, multiCylinderEngine.massFlowRate_intake) annotation(
    Line(points = {{-80, 104}, {-16, 104}, {-16, 20}, {-16, 20}}, color = {0, 0, 127}));
  connect(throttle.specificEnthalpy_outflow_b, multiCylinderEngine.specificEnthalpy_mix_intake) annotation(
    Line(points = {{-80, 106}, {-14, 106}, {-14, 20}, {-14, 20}}, color = {0, 0, 127}));
  connect(throttle.specificEnthalpy_mix_b, multiCylinderEngine.specificEnthalpy_outflow_intake) annotation(
    Line(points = {{-80, 114}, {-6, 114}, {-6, 20}, {-6, 20}, {-6, 20}}, color = {0, 0, 127}));
  connect(throttle.temperature_b, multiCylinderEngine.temperature_intake) annotation(
    Line(points = {{-80, 116}, {-4, 116}, {-4, 20}, {-4, 20}}, color = {0, 0, 127}));
  connect(throttle.absolutePressure_b, multiCylinderEngine.absolutePressure_intake) annotation(
    Line(points = {{-80, 118}, {-2, 118}, {-2, 20}, {-2, 20}}, color = {0, 0, 127}));
  connect(throttle.massFractions_outflow_b[:], multiCylinderEngine.massFractions_mix_intake[:]) annotation(
    Line(points = {{-80, 108}, {-12, 108}, {-12, 20}, {-12, 20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(throttle.massFractions_mix_b[:], multiCylinderEngine.massFractions_outflow_intake[:]) annotation(
    Line(points = {{-80, 112}, {-8, 112}, {-8, 20}, {-8, 20}}, color = {0, 0, 127}, thickness = 0.5));

  connect(multiCylinderEngine.enthalpyFlowRate_exhaust, exhaustPressureDrop.enthalpyFlowRate_a) annotation(
    Line(points = {{2, 20}, {2, 20}, {2, 102}, {140, 102}, {140, 102}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.massFlowRate_exhaust, exhaustPressureDrop.massFlowRate_a) annotation(
    Line(points = {{4, 20}, {4, 20}, {4, 104}, {140, 104}, {140, 104}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.specificEnthalpy_mix_exhaust, exhaustPressureDrop.specificEnthalpy_outflow_a) annotation(
    Line(points = {{6, 20}, {6, 20}, {6, 106}, {140, 106}, {140, 106}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.specificEnthalpy_outflow_exhaust, exhaustPressureDrop.specificEnthalpy_mix_a) annotation(
    Line(points = {{14, 20}, {14, 20}, {14, 114}, {140, 114}, {140, 114}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.temperature_exhaust, exhaustPressureDrop.temperature_a) annotation(
    Line(points = {{16, 20}, {16, 20}, {16, 116}, {140, 116}, {140, 116}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.absolutePressure_exhaust, exhaustPressureDrop.absolutePressure_a) annotation(
    Line(points = {{18, 20}, {18, 20}, {18, 118}, {140, 118}, {140, 118}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.massFractions_mix_exhaust[:], exhaustPressureDrop.massFractions_outflow_a[:]) annotation(
    Line(points = {{8, 20}, {8, 20}, {8, 108}, {140, 108}, {140, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(multiCylinderEngine.massFractions_outflow_exhaust[:], exhaustPressureDrop.massFractions_mix_a[:]) annotation(
    Line(points = {{12, 20}, {12, 20}, {12, 112}, {140, 112}, {140, 112}}, color = {0, 0, 127}, thickness = 0.5));

  connect(exhaustPressureDrop.enthalpyFlowRate_b, exhaustBoundary.enthalpyFlowRate) annotation(
    Line(points = {{160, 102}, {180, 102}, {180, 102}, {180, 102}}, color = {0, 0, 127}));
  connect(exhaustPressureDrop.massFlowRate_b, exhaustBoundary.massFlowRate) annotation(
    Line(points = {{160, 104}, {178, 104}, {178, 104}, {180, 104}, {180, 104}}, color = {0, 0, 127}));
  connect(exhaustPressureDrop.specificEnthalpy_outflow_b, exhaustBoundary.specificEnthalpy_mix) annotation(
    Line(points = {{160, 106}, {180, 106}, {180, 106}, {180, 106}}, color = {0, 0, 127}));
  connect(exhaustPressureDrop.specificEnthalpy_mix_b, exhaustBoundary.specificEnthalpy_outflow) annotation(
    Line(points = {{160, 114}, {180, 114}, {180, 114}, {180, 114}}, color = {0, 0, 127}));
  connect(exhaustPressureDrop.temperature_b, exhaustBoundary.temperature) annotation(
    Line(points = {{160, 116}, {180, 116}, {180, 116}, {180, 116}}, color = {0, 0, 127}));
  connect(exhaustPressureDrop.absolutePressure_b, exhaustBoundary.absolutePressure) annotation(
    Line(points = {{160, 118}, {180, 118}, {180, 118}, {180, 118}}, color = {0, 0, 127}));
  connect(exhaustPressureDrop.massFractions_outflow_b[:], exhaustBoundary.massFractions_mix[:]) annotation(
    Line(points = {{160, 108}, {180, 108}, {180, 108}, {180, 108}, {180, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(exhaustPressureDrop.massFractions_mix_b[:], exhaustBoundary.massFractions_outflow[:]) annotation(
    Line(points = {{160, 112}, {180, 112}, {180, 112}, {180, 112}}, color = {0, 0, 127}, thickness = 0.5));
  connect(fuelMpr, multiCylinderEngine.fuelMprInput) annotation(
    Line(points = {{-240, 120}, {-224, 120}, {-224, 38}, {-116, 38}, {-116, 0}, {-20, 0}, {-20, 0}}, color = {0, 0, 127}));


annotation(
    Diagram,
    Icon);
end SampleEngineUnitNA;
