within AICE.Examples.METI_2020.Components;

block SampleEngineUnitTCCACTWC3
  extends Icons.PowerUnits.EngineUnit;
  extends BaseClasses.PartialPowerUnitTCGasoline;
  extends BaseClasses.SampleEngineUnitParameters;
  replaceable package Medium = AICE.Media.IdealGases.Examples.Sample5MixtureGas;
  parameter String dataDir = Modelica.Utilities.Files.loadResource("modelica://AICE/data");
  // components
  AICE.Blocks.Fluid.Compressible.Sources.FixedBoundary_TFAOTI intakeBoundary(redeclare replaceable package Medium = Medium, energy_port = AICE.Blocks.Types.Energy.Source, use_p = true, p = p_intake, use_T = true, T = T_intake) annotation(
    Placement(visible = true, transformation(origin = {-210, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Fittings.SimpleGenericOrifice_TFAIITOO intakePressureDrop(redeclare replaceable package Medium = Medium, diameter = d_intakePipe, zeta = 4) annotation(
    Placement(visible = true, transformation(origin = {-170, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Vessels.ClosedVolume_TFAOOTII intakeVolume(redeclare replaceable package Medium = Medium, V = V_intakePipe, p_start = p_start_intakePipe, use_T_start = true, T_start = T_start_intakePipe) annotation(
    Placement(visible = true, transformation(origin = {-130, 110}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Fluid.Valves.BaseClasses.ValveCharacteristics.Butterfly characteristic annotation(
    Placement(visible = true, transformation(origin = {-110, 160}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Valves.ValveCompressible_TFAIITOO throttle(redeclare replaceable package Medium = Medium, CvData = Modelica.Fluid.Types.CvTypes.Av, Av = AICE.Math.diameter2area(d_throttle), p_nominal = Medium.p_default, dp_nominal = 1, m_flow_nominal = 1e-3) annotation(
    Placement(visible = true, transformation(origin = {-46, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Examples.METI_2020.Components.MultiCylinderEngine_TFAOOTII multiCylinderEngine(redeclare replaceable package Medium = Medium, phi_start = 0.0, V_intakeManifold = V_intakeManifold, p_start_intakeManifold = p_start_intakeManifold, T_start_intakeManifold = T_start_intakeManifold, V_exhaustManifold = V_exhaustManifold, p_start_exhaustManifold = p_start_exhaustManifold, T_start_exhaustManifold = T_start_exhaustManifold, V_displacement = V_displacement, compressionRatio = compressionRatio, l_connRod = l_connRod, offset_crank = offset_crank, bore = bore, intakeValveCentor = intakeValveCentor, d_valve_intake = d_valve_intake, exhaustValveCentor = exhaustValveCentor, d_valve_exhaust = d_valve_exhaust, airByFuel = airByFuel, injectionStart = injectionStart, injectionPeriod = injectionPeriod, p_start_chamber1 = p_start_chamber1, p_start_chamber2 = p_start_chamber2, p_start_chamber3 = p_start_chamber3, p_start_chamber4 = p_start_chamber4, T_start_chamber1 = T_start_chamber1, T_start_chamber2 = T_start_chamber2, T_start_chamber3 = T_start_chamber3, T_start_chamber4 = T_start_chamber4, m_wiebe = m_wiebe, phi_combustion_begin = phi_combustion_begin, phi_combustion_period = phi_combustion_period, c1_woschni_intakeExhaust = c1_woschni_intakeExhaust, c1_woschni_compressionPower = c1_woschni_compressionPower, c2_woschni = c2_woschni, fileName_lift_exhaust = fileName_lift_exhaust, fileName_CD_exhaust = fileName_CD_exhaust, fileName_lift_intake = fileName_lift_intake, fileName_CD_intake = fileName_CD_intake) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Sources.FixedBoundary_TFAOTI exhaustBoundary(redeclare replaceable package Medium = Medium, T = T_exhaust, p = p_intake, use_T = true, use_p = true) annotation(
    Placement(visible = true, transformation(origin = {228, 90}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  SI.MassFlowRate 'fuelFlowRates'[nCylinders] = multiCylinderEngine.acausalModel.singleCylinderEngines[:].injector.fuelFlowRate;
  Modelica.Blocks.Sources.RealExpression fuelFlowRates[nCylinders](y = 'fuelFlowRates') annotation(
    Placement(visible = true, transformation(origin = {80, -100}, extent = {{-20, -10}, {20, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Sum fuelFlowRate_total(nin = nCylinders) annotation(
    Placement(visible = true, transformation(origin = {130, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Interfaces.MassFlowRateOutput fuelFlowRate annotation(
    Placement(visible = true, transformation(origin = {180, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-60, 100}, extent = {{-5, -5}, {5, 5}}, rotation = 90)));
  AICE.Blocks.Fluid.Compressible.Machines.FixGeometryTurboCharger_TFAIIIITOOOO turboCharger(redeclare replaceable package Medium = Medium, Av_wastegate = Av_wastegate, EfficiencyMap_comp = dataDir + "/CompMap_eta.txt", EfficiencyMap_turb = dataDir + "/TurbMapVG60_eta.txt", FluidMachineType_comp = AICE.Fluid.Machines.Types.FluidMachine.Compressor, FluidMachineType_turb = AICE.Fluid.Machines.Types.FluidMachine.Turbine, Inertia = Inertia_tc, MapType_comp = AICE.Fluid.Machines.Types.MapValue.Corrected, MapType_turb = AICE.Fluid.Machines.Types.MapValue.Reduced, MassFlowMap_comp = dataDir + "/CompMap_mf.txt", MassFlowMap_turb = dataDir + "/TurbMapVG60_mf.txt", dia_in_comp = 0.056, dia_in_turb = 0.056, energy_port_1 = AICE.Blocks.Types.Energy.Sink, energy_port_2 = AICE.Blocks.Types.Energy.Source, energy_port_a = AICE.Blocks.Types.Energy.Sink, energy_port_b = AICE.Blocks.Types.Energy.Source, w_shaft_init = w_tc_init) annotation(
    Placement(visible = true, transformation(origin = {49, 100}, extent = {{-10, -20}, {10, 20}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Fittings.SimpleGenericOrifice_TFAIITOO mufflerOrifice(redeclare replaceable package Medium = Medium, diameter = d_intakePipe, zeta = 10) annotation(
    Placement(visible = true, transformation(origin = {190, 90}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Vessels.HeatExchanger_TFAOOOOTIIII chargeAirCooler(redeclare replaceable package Medium = Medium, HxEfficiencyMap = dataDir + "/HxEfficiencyMap.txt", T_cool_start = T_intake, T_hot_start = T_intake, V_cool = 0.01, V_hot = 0.01, p_cool_start = p_intake, p_hot_start = p_start_intakeManifold) annotation(
    Placement(visible = true, transformation(origin = {28, 154}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Sources.FixedBoundary_TFAOTI cacinBoundary(redeclare replaceable package Medium = Medium, T = T_intake, energy_port = AICE.Blocks.Types.Energy.Source, p = p_intake, use_T = true, use_p = true) annotation(
    Placement(visible = true, transformation(origin = {88, 144}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Fittings.SimpleGenericOrifice_TFAIITOO cacinOrifice(redeclare replaceable package Medium = Medium, diameter = d_intakePipe, zeta = 4) annotation(
    Placement(visible = true, transformation(origin = {58, 144}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Sources.FixedBoundary_TFAOTI cacoutBoundary(redeclare replaceable package Medium = Medium, T = T_intake, p = p_start_intakePipe, use_T = true, use_p = true) annotation(
    Placement(visible = true, transformation(origin = {-38, 144}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Fittings.SimpleGenericOrifice_TFAIITOO cacoutOrifice(redeclare replaceable package Medium = Medium, diameter = d_intakePipe, zeta = 4) annotation(
    Placement(visible = true, transformation(origin = {-6, 144}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Blocks.Fluid.Compressible.Pipes.CatalystConversionEfficiency_TFAOOTII catalyst(redeclare replaceable package Medium = Medium, HeatCapacity_can = 10, HeatCapacity_core = 100, T_start = T_start_exhaustPipe, T_vs_eta_conv = [300, 0.1; 400, 0.2; 500, 0.8; 600, 0.9; 700, 0.9], ThermalConductance_ins = 1, ThermalConductivity_core = 1, diameter = 0.001, energy_port_a = AICE.Blocks.Types.Energy.Sink, energy_port_b = AICE.Blocks.Types.Energy.Source, length = 0.2, m_flow_start = 0.1, nParallel = 10000, p_init = p_start_exhaustPipe) annotation(
    Placement(visible = true, transformation(origin = {150, 90}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant heatConst(k = 0) annotation(
    Placement(visible = true, transformation(origin = {128, 114}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant HTCConst(k = 10) annotation(
    Placement(visible = true, transformation(origin = {128, 144}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant TambConst(k = 300) annotation(
    Placement(visible = true, transformation(origin = {128, 174}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(intakeBoundary.absolutePressure, intakePressureDrop.absolutePressure_a) annotation(
    Line(points = {{-200, 118}, {-180, 118}, {-180, 118}, {-180, 118}}, color = {0, 0, 127}));
  connect(intakeBoundary.temperature, intakePressureDrop.temperature_a) annotation(
    Line(points = {{-200, 116}, {-180, 116}}, color = {0, 0, 127}));
  connect(intakeBoundary.specificEnthalpy_outflow, intakePressureDrop.specificEnthalpy_mix_a) annotation(
    Line(points = {{-200, 114}, {-180, 114}}, color = {0, 0, 127}));
  connect(intakeBoundary.massFractions_outflow[:], intakePressureDrop.massFractions_mix_a[:]) annotation(
    Line(points = {{-200, 112}, {-180, 112}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakeBoundary.massFractions_mix[:], intakePressureDrop.massFractions_outflow_a[:]) annotation(
    Line(points = {{-200, 108}, {-180, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakeBoundary.specificEnthalpy_mix, intakePressureDrop.specificEnthalpy_outflow_a) annotation(
    Line(points = {{-200, 106}, {-180, 106}}, color = {0, 0, 127}));
  connect(intakeBoundary.massFlowRate, intakePressureDrop.massFlowRate_a) annotation(
    Line(points = {{-200, 104}, {-180, 104}}, color = {0, 0, 127}));
  connect(intakeBoundary.enthalpyFlowRate, intakePressureDrop.enthalpyFlowRate_a) annotation(
    Line(points = {{-200, 102}, {-180, 102}, {-180, 102}, {-180, 102}}, color = {0, 0, 127}));
//
  connect(intakePressureDrop.absolutePressure_b, intakeVolume.absolutePressure_a) annotation(
    Line(points = {{-160, 118}, {-140, 118}, {-140, 118}, {-140, 118}}, color = {0, 0, 127}));
  connect(intakePressureDrop.temperature_b, intakeVolume.temperature_a) annotation(
    Line(points = {{-160, 116}, {-140, 116}}, color = {0, 0, 127}));
  connect(intakePressureDrop.specificEnthalpy_mix_b, intakeVolume.specificEnthalpy_outflow_a) annotation(
    Line(points = {{-160, 114}, {-140, 114}}, color = {0, 0, 127}));
  connect(intakePressureDrop.massFractions_mix_b[:], intakeVolume.massFractions_outflow_a[:]) annotation(
    Line(points = {{-160, 112}, {-140, 112}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakePressureDrop.massFractions_outflow_b[:], intakeVolume.massFractions_mix_a[:]) annotation(
    Line(points = {{-160, 108}, {-140, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakePressureDrop.specificEnthalpy_outflow_b, intakeVolume.specificEnthalpy_mix_a) annotation(
    Line(points = {{-160, 106}, {-140, 106}}, color = {0, 0, 127}));
  connect(intakePressureDrop.massFlowRate_b, intakeVolume.massFlowRate_a) annotation(
    Line(points = {{-160, 104}, {-140, 104}}, color = {0, 0, 127}));
  connect(intakePressureDrop.enthalpyFlowRate_b, intakeVolume.enthalpyFlowRate_a) annotation(
    Line(points = {{-160, 102}, {-140, 102}, {-140, 102}, {-140, 102}}, color = {0, 0, 127}));
//
  connect(throttle.absolutePressure_b, multiCylinderEngine.absolutePressure_intake) annotation(
    Line(points = {{-36, 88}, {-2, 88}, {-2, 20}}, color = {0, 0, 127}));
  connect(throttle.temperature_b, multiCylinderEngine.temperature_intake) annotation(
    Line(points = {{-36, 86}, {-4, 86}, {-4, 20}}, color = {0, 0, 127}));
  connect(throttle.specificEnthalpy_mix_b, multiCylinderEngine.specificEnthalpy_outflow_intake) annotation(
    Line(points = {{-36, 84}, {-6, 84}, {-6, 20}}, color = {0, 0, 127}));
  connect(throttle.massFractions_mix_b[:], multiCylinderEngine.massFractions_outflow_intake[:]) annotation(
    Line(points = {{-36, 82}, {-8, 82}, {-8, 20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(throttle.massFractions_outflow_b[:], multiCylinderEngine.massFractions_mix_intake[:]) annotation(
    Line(points = {{-36, 78}, {-12, 78}, {-12, 20}}, color = {0, 0, 127}, thickness = 0.5));
  connect(throttle.specificEnthalpy_outflow_b, multiCylinderEngine.specificEnthalpy_mix_intake) annotation(
    Line(points = {{-36, 76}, {-14, 76}, {-14, 20}}, color = {0, 0, 127}));
  connect(throttle.massFlowRate_b, multiCylinderEngine.massFlowRate_intake) annotation(
    Line(points = {{-36, 74}, {-16, 74}, {-16, 20}}, color = {0, 0, 127}));
  connect(throttle.enthalpyFlowRate_b, multiCylinderEngine.enthalpyFlowRate_intake) annotation(
    Line(points = {{-36, 72}, {-18, 72}, {-18, 20}}, color = {0, 0, 127}));
//
  connect(multiCylinderEngine.absolutePressure_exhaust, turboCharger.absolutePressure_1) annotation(
    Line(points = {{18, 20}, {18, 98}, {39, 98}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.temperature_exhaust, turboCharger.temperature_1) annotation(
    Line(points = {{16, 20}, {16, 96}, {39, 96}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.specificEnthalpy_outflow_exhaust, turboCharger.specificEnthalpy_mix_1) annotation(
    Line(points = {{14, 20}, {14, 94}, {39, 94}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.massFractions_outflow_exhaust[:], turboCharger.massFractions_mix_1[:]) annotation(
    Line(points = {{12, 20}, {12, 92}, {39, 92}}, color = {0, 0, 127}, thickness = 0.5));
  connect(multiCylinderEngine.massFractions_mix_exhaust[:], turboCharger.massFractions_outflow_1[:]) annotation(
    Line(points = {{8, 20}, {8, 88}, {39, 88}}, color = {0, 0, 127}, thickness = 0.5));
  connect(multiCylinderEngine.specificEnthalpy_mix_exhaust, turboCharger.specificEnthalpy_outflow_1) annotation(
    Line(points = {{6, 20}, {6, 86}, {39, 86}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.massFlowRate_exhaust, turboCharger.massFlowRate_1) annotation(
    Line(points = {{4, 20}, {4, 84}, {39, 84}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.enthalpyFlowRate_exhaust, turboCharger.enthalpyFlowRate_1) annotation(
    Line(points = {{2, 20}, {2, 82}, {39, 82}}, color = {0, 0, 127}));
//
//
  connect(intakeVolume.absolutePressure_b, turboCharger.absolutePressure_a) annotation(
    Line(points = {{-120, 118}, {39, 118}}, color = {0, 0, 127}));
  connect(intakeVolume.temperature_b, turboCharger.temperature_a) annotation(
    Line(points = {{-120, 116}, {39, 116}}, color = {0, 0, 127}));
  connect(intakeVolume.specificEnthalpy_outflow_b, turboCharger.specificEnthalpy_mix_a) annotation(
    Line(points = {{-120, 114}, {39, 114}}, color = {0, 0, 127}));
  connect(intakeVolume.massFractions_outflow_b[:], turboCharger.massFractions_mix_a[:]) annotation(
    Line(points = {{-120, 112}, {39, 112}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakeVolume.massFractions_mix_b[:], turboCharger.massFractions_outflow_a[:]) annotation(
    Line(points = {{-120, 108}, {39, 108}}, color = {0, 0, 127}, thickness = 0.5));
  connect(intakeVolume.specificEnthalpy_mix_b, turboCharger.specificEnthalpy_outflow_a) annotation(
    Line(points = {{-120, 106}, {39, 106}}, color = {0, 0, 127}));
  connect(intakeVolume.massFlowRate_b, turboCharger.massFlowRate_a) annotation(
    Line(points = {{-120, 104}, {39, 104}}, color = {0, 0, 127}));
  connect(intakeVolume.enthalpyFlowRate_b, turboCharger.enthalpyFlowRate_a) annotation(
    Line(points = {{-120, 102}, {39, 102}}, color = {0, 0, 127}));
//
//
//
//
//
  connect(multiCylinderEngine.angularVelocity, angularVelocity) annotation(
    Line(points = {{20, +12}, {220, +12}, {220, +60}, {240, +60}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.torque, torque) annotation(
    Line(points = {{20, -12}, {220, -12}, {220, -60}, {240, -60}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.temperature, temperature) annotation(
    Line(points = {{+12, -20}, {+12, -160}, {+60, -160}, {+60, -200}}, color = {0, 0, 127}));
  connect(multiCylinderEngine.heatFlowRate, heatFlowRate) annotation(
    Line(points = {{-12, -20}, {-12, -160}, {-60, -160}, {-60, -200}}, color = {0, 0, 127}));
//
//
// fuel flow rate monitor code
  connect(fuelFlowRates[:].y, fuelFlowRate_total.u) annotation(
    Line(points = {{100, -100}, {120, -100}}, color = {0, 0, 127}));
  connect(fuelFlowRate_total.y, fuelFlowRate) annotation(
    Line(points = {{140, -100}, {180, -100}}, color = {0, 0, 127}));
//
//
  connect(exhaustBoundary.absolutePressure, mufflerOrifice.absolutePressure_b) annotation(
    Line(points = {{218, 98}, {200, 98}}, color = {0, 0, 127}));
  connect(exhaustBoundary.temperature, mufflerOrifice.temperature_b) annotation(
    Line(points = {{218, 96}, {200, 96}}, color = {0, 0, 127}));
  connect(exhaustBoundary.specificEnthalpy_outflow, mufflerOrifice.specificEnthalpy_mix_b) annotation(
    Line(points = {{218, 94}, {200, 94}}, color = {0, 0, 127}));
  connect(exhaustBoundary.massFractions_outflow[:], mufflerOrifice.massFractions_mix_b[:]) annotation(
    Line(points = {{218, 92}, {200, 92}}, color = {0, 0, 127}, thickness = 0.5));
  connect(exhaustBoundary.massFractions_mix[:], mufflerOrifice.massFractions_outflow_b[:]) annotation(
    Line(points = {{218, 88}, {200, 88}}, color = {0, 0, 127}, thickness = 0.5));
  connect(exhaustBoundary.specificEnthalpy_mix, mufflerOrifice.specificEnthalpy_outflow_b) annotation(
    Line(points = {{218, 86}, {200, 86}}, color = {0, 0, 127}));
  connect(exhaustBoundary.massFlowRate, mufflerOrifice.massFlowRate_b) annotation(
    Line(points = {{218, 84}, {200, 84}}, color = {0, 0, 127}));
  connect(exhaustBoundary.enthalpyFlowRate, mufflerOrifice.enthalpyFlowRate_b) annotation(
    Line(points = {{218, 82}, {200, 82}}, color = {0, 0, 127}));
  connect(turboCharger.absolutePressure_b, chargeAirCooler.absolutePressure_a) annotation(
    Line(points = {{59, 118}, {100, 118}, {100, 172}, {38, 172}}, color = {0, 0, 127}));
  connect(turboCharger.temperature_b, chargeAirCooler.temperature_a) annotation(
    Line(points = {{59, 116}, {102, 116}, {102, 170}, {38, 170}}, color = {0, 0, 127}));
  connect(turboCharger.specificEnthalpy_mix_b, chargeAirCooler.specificEnthalpy_outflow_a) annotation(
    Line(points = {{59, 114}, {104, 114}, {104, 168}, {38, 168}}, color = {0, 0, 127}));
  connect(turboCharger.massFractions_mix_b[:], chargeAirCooler.massFractions_outflow_a[:]) annotation(
    Line(points = {{59, 112}, {106, 112}, {106, 166}, {38, 166}}, color = {0, 0, 127}, thickness = 0.5));
  connect(turboCharger.massFractions_outflow_b[:], chargeAirCooler.massFractions_mix_a[:]) annotation(
    Line(points = {{59, 108}, {108, 108}, {108, 162}, {38, 162}}, color = {0, 0, 127}, thickness = 0.5));
  connect(turboCharger.specificEnthalpy_outflow_b, chargeAirCooler.specificEnthalpy_mix_a) annotation(
    Line(points = {{59, 106}, {110, 106}, {110, 160}, {38, 160}}, color = {0, 0, 127}));
  connect(turboCharger.massFlowRate_b, chargeAirCooler.massFlowRate_a) annotation(
    Line(points = {{59, 104}, {112, 104}, {112, 158}, {38, 158}}, color = {0, 0, 127}));
  connect(turboCharger.enthalpyFlowRate_b, chargeAirCooler.enthalpyFlowRate_a) annotation(
    Line(points = {{59, 102}, {114, 102}, {114, 156}, {38, 156}}, color = {0, 0, 127}));
  connect(chargeAirCooler.absolutePressure_b, throttle.absolutePressure_a) annotation(
    Line(points = {{18, 172}, {-66, 172}, {-66, 88}, {-56, 88}}, color = {0, 0, 127}));
  connect(chargeAirCooler.temperature_b, throttle.temperature_a) annotation(
    Line(points = {{18, 170}, {-68, 170}, {-68, 86}, {-56, 86}}, color = {0, 0, 127}));
  connect(chargeAirCooler.specificEnthalpy_outflow_b, throttle.specificEnthalpy_mix_a) annotation(
    Line(points = {{18, 168}, {-70, 168}, {-70, 84}, {-56, 84}}, color = {0, 0, 127}));
  connect(chargeAirCooler.massFractions_outflow_b[:], throttle.massFractions_mix_a[:]) annotation(
    Line(points = {{18, 166}, {-72, 166}, {-72, 82}, {-56, 82}}, color = {0, 0, 127}, thickness = 0.5));
  connect(chargeAirCooler.massFractions_mix_b[:], throttle.massFractions_outflow_a[:]) annotation(
    Line(points = {{18, 162}, {-74, 162}, {-74, 78}, {-56, 78}}, color = {0, 0, 127}, thickness = 0.5));
  connect(chargeAirCooler.specificEnthalpy_mix_b, throttle.specificEnthalpy_outflow_a) annotation(
    Line(points = {{18, 160}, {-76, 160}, {-76, 76}, {-56, 76}}, color = {0, 0, 127}));
  connect(chargeAirCooler.massFlowRate_b, throttle.massFlowRate_a) annotation(
    Line(points = {{18, 158}, {-78, 158}, {-78, 74}, {-56, 74}}, color = {0, 0, 127}));
  connect(chargeAirCooler.enthalpyFlowRate_b, throttle.enthalpyFlowRate_a) annotation(
    Line(points = {{18, 156}, {-80, 156}, {-80, 72}, {-56, 72}}, color = {0, 0, 127}));
//
  connect(cacinBoundary.absolutePressure, cacinOrifice.absolutePressure_a) annotation(
    Line(points = {{78, 152}, {68, 152}, {68, 152}, {68, 152}}, color = {0, 0, 127}));
  connect(cacinBoundary.temperature, cacinOrifice.temperature_a) annotation(
    Line(points = {{78, 150}, {68, 150}, {68, 150}, {68, 150}}, color = {0, 0, 127}));
  connect(cacinBoundary.specificEnthalpy_outflow, cacinOrifice.specificEnthalpy_mix_a) annotation(
    Line(points = {{78, 148}, {68, 148}, {68, 148}, {68, 148}}, color = {0, 0, 127}));
  connect(cacinBoundary.massFractions_outflow[:], cacinOrifice.massFractions_mix_a[:]) annotation(
    Line(points = {{78, 146}, {68, 146}, {68, 146}, {68, 146}}, color = {0, 0, 127}, thickness = 0.5));
  connect(cacinBoundary.massFractions_mix[:], cacinOrifice.massFractions_outflow_a[:]) annotation(
    Line(points = {{78, 142}, {68, 142}, {68, 142}, {68, 142}}, color = {0, 0, 127}, thickness = 0.5));
  connect(cacinBoundary.specificEnthalpy_mix, cacinOrifice.specificEnthalpy_outflow_a) annotation(
    Line(points = {{78, 140}, {68, 140}, {68, 140}, {68, 140}}, color = {0, 0, 127}));
  connect(cacinBoundary.massFlowRate, cacinOrifice.massFlowRate_a) annotation(
    Line(points = {{78, 138}, {68, 138}, {68, 138}, {68, 138}}, color = {0, 0, 127}));
  connect(cacinBoundary.enthalpyFlowRate, cacinOrifice.enthalpyFlowRate_a) annotation(
    Line(points = {{78, 136}, {68, 136}, {68, 136}, {68, 136}}, color = {0, 0, 127}));
//
  connect(chargeAirCooler.absolutePressure_1, cacinOrifice.absolutePressure_b) annotation(
    Line(points = {{38, 152}, {48, 152}, {48, 152}, {48, 152}}, color = {0, 0, 127}));
  connect(chargeAirCooler.temperature_1, cacinOrifice.temperature_b) annotation(
    Line(points = {{38, 150}, {48, 150}, {48, 150}, {48, 150}}, color = {0, 0, 127}));
  connect(chargeAirCooler.specificEnthalpy_outflow_1, cacinOrifice.specificEnthalpy_mix_b) annotation(
    Line(points = {{38, 148}, {48, 148}, {48, 148}, {48, 148}}, color = {0, 0, 127}));
  connect(chargeAirCooler.massFractions_outflow_1[:], cacinOrifice.massFractions_mix_b[:]) annotation(
    Line(points = {{38, 146}, {48, 146}, {48, 146}, {48, 146}}, color = {0, 0, 127}, thickness = 0.5));
  connect(chargeAirCooler.massFractions_mix_1[:], cacinOrifice.massFractions_outflow_b[:]) annotation(
    Line(points = {{38, 142}, {48, 142}, {48, 142}, {48, 142}}, color = {0, 0, 127}, thickness = 0.5));
  connect(chargeAirCooler.specificEnthalpy_mix_1, cacinOrifice.specificEnthalpy_outflow_b) annotation(
    Line(points = {{38, 140}, {48, 140}, {48, 140}, {48, 140}}, color = {0, 0, 127}));
  connect(chargeAirCooler.massFlowRate_1, cacinOrifice.massFlowRate_b) annotation(
    Line(points = {{38, 138}, {48, 138}, {48, 138}, {48, 138}}, color = {0, 0, 127}));
  connect(chargeAirCooler.heatFlowRate_1, cacinOrifice.enthalpyFlowRate_b) annotation(
    Line(points = {{38, 136}, {48, 136}, {48, 136}, {48, 136}}, color = {0, 0, 127}));
//
  connect(chargeAirCooler.absolutePressure_2, cacoutOrifice.absolutePressure_a) annotation(
    Line(points = {{18, 152}, {4, 152}, {4, 152}, {4, 152}}, color = {0, 0, 127}));
  connect(chargeAirCooler.temperature_2, cacoutOrifice.temperature_a) annotation(
    Line(points = {{18, 150}, {4, 150}, {4, 150}, {4, 150}}, color = {0, 0, 127}));
  connect(chargeAirCooler.specificEnthalpy_outflow_2, cacoutOrifice.specificEnthalpy_mix_a) annotation(
    Line(points = {{18, 148}, {4, 148}, {4, 148}, {4, 148}}, color = {0, 0, 127}));
  connect(chargeAirCooler.massFractions_outflow_2[:], cacoutOrifice.massFractions_mix_a[:]) annotation(
    Line(points = {{18, 146}, {4, 146}, {4, 146}, {4, 146}}, color = {0, 0, 127}, thickness = 0.5));
  connect(chargeAirCooler.massFractions_mix_2[:], cacoutOrifice.massFractions_outflow_a[:]) annotation(
    Line(points = {{18, 142}, {4, 142}, {4, 142}, {4, 142}}, color = {0, 0, 127}, thickness = 0.5));
  connect(chargeAirCooler.specificEnthalpy_mix_2, cacoutOrifice.specificEnthalpy_outflow_a) annotation(
    Line(points = {{18, 140}, {4, 140}, {4, 140}, {4, 140}}, color = {0, 0, 127}));
  connect(chargeAirCooler.massFlowRate_2, cacoutOrifice.massFlowRate_a) annotation(
    Line(points = {{18, 138}, {4, 138}, {4, 138}, {4, 138}}, color = {0, 0, 127}));
  connect(chargeAirCooler.heatFlowRate_2, cacoutOrifice.enthalpyFlowRate_a) annotation(
    Line(points = {{18, 136}, {4, 136}, {4, 136}, {4, 136}}, color = {0, 0, 127}));
//
  connect(cacoutBoundary.absolutePressure, cacoutOrifice.absolutePressure_b) annotation(
    Line(points = {{-28, 152}, {-16, 152}, {-16, 152}, {-16, 152}}, color = {0, 0, 127}));
  connect(cacoutBoundary.temperature, cacoutOrifice.temperature_b) annotation(
    Line(points = {{-28, 150}, {-16, 150}, {-16, 150}, {-16, 150}}, color = {0, 0, 127}));
  connect(cacoutBoundary.specificEnthalpy_outflow, cacoutOrifice.specificEnthalpy_mix_b) annotation(
    Line(points = {{-28, 148}, {-16, 148}, {-16, 148}, {-16, 148}}, color = {0, 0, 127}));
  connect(cacoutBoundary.massFractions_outflow[:], cacoutOrifice.massFractions_mix_b[:]) annotation(
    Line(points = {{-28, 146}, {-16, 146}, {-16, 146}, {-16, 146}}, color = {0, 0, 127}, thickness = 0.5));
  connect(cacoutBoundary.massFractions_mix[:], cacoutOrifice.massFractions_outflow_b[:]) annotation(
    Line(points = {{-28, 142}, {-16, 142}, {-16, 142}, {-16, 142}}, color = {0, 0, 127}, thickness = 0.5));
  connect(cacoutBoundary.specificEnthalpy_mix, cacoutOrifice.specificEnthalpy_outflow_b) annotation(
    Line(points = {{-28, 140}, {-16, 140}, {-16, 140}, {-16, 140}}, color = {0, 0, 127}));
  connect(cacoutBoundary.massFlowRate, cacoutOrifice.massFlowRate_b) annotation(
    Line(points = {{-28, 138}, {-16, 138}, {-16, 138}, {-16, 138}}, color = {0, 0, 127}));
  connect(cacoutBoundary.enthalpyFlowRate, cacoutOrifice.enthalpyFlowRate_b) annotation(
    Line(points = {{-28, 136}, {-16, 136}, {-16, 136}, {-16, 136}}, color = {0, 0, 127}));
  connect(turboCharger.absolutePressure_2, catalyst.absolutePressure_a) annotation(
    Line(points = {{59, 98}, {140, 98}}, color = {0, 0, 127}));
  connect(turboCharger.temperature_2, catalyst.temperature_a) annotation(
    Line(points = {{59, 96}, {140, 96}}, color = {0, 0, 127}));
  connect(turboCharger.specificEnthalpy_mix_2, catalyst.specificEnthalpy_outflow_a) annotation(
    Line(points = {{59, 94}, {140, 94}}, color = {0, 0, 127}));
  connect(turboCharger.massFractions_mix_2[:], catalyst.massFractions_outflow_a[:]) annotation(
    Line(points = {{59, 92}, {140, 92}}, color = {0, 0, 127}, thickness = 0.5));
  connect(turboCharger.massFractions_outflow_2[:], catalyst.massFractions_mix_a[:]) annotation(
    Line(points = {{59, 88}, {140, 88}}, color = {0, 0, 127}, thickness = 0.5));
  connect(turboCharger.specificEnthalpy_outflow_2, catalyst.specificEnthalpy_mix_a) annotation(
    Line(points = {{59, 86}, {140, 86}}, color = {0, 0, 127}));
  connect(turboCharger.massFlowRate_2, catalyst.massFlowRate_a) annotation(
    Line(points = {{59, 84}, {140, 84}}, color = {0, 0, 127}));
  connect(turboCharger.enthalpyFlowRate_2, catalyst.enthalpyFlowRate_a) annotation(
    Line(points = {{59, 82}, {140, 82}}, color = {0, 0, 127}));
  connect(mufflerOrifice.absolutePressure_a, catalyst.absolutePressure_b) annotation(
    Line(points = {{180, 98}, {160, 98}}, color = {0, 0, 127}));
  connect(mufflerOrifice.temperature_a, catalyst.temperature_b) annotation(
    Line(points = {{180, 96}, {160, 96}}, color = {0, 0, 127}));
  connect(mufflerOrifice.specificEnthalpy_mix_a, catalyst.specificEnthalpy_outflow_b) annotation(
    Line(points = {{180, 94}, {160, 94}}, color = {0, 0, 127}));
  connect(mufflerOrifice.massFractions_mix_a[:], catalyst.massFractions_outflow_b[:]) annotation(
    Line(points = {{180, 92}, {160, 92}}, color = {0, 0, 127}, thickness = 0.5));
  connect(mufflerOrifice.massFractions_outflow_a[:], catalyst.massFractions_mix_b[:]) annotation(
    Line(points = {{180, 88}, {160, 88}}, color = {0, 0, 127}, thickness = 0.5));
  connect(mufflerOrifice.specificEnthalpy_outflow_a, catalyst.specificEnthalpy_mix_b) annotation(
    Line(points = {{180, 86}, {160, 86}}, color = {0, 0, 127}));
  connect(mufflerOrifice.massFlowRate_a, catalyst.massFlowRate_b) annotation(
    Line(points = {{180, 84}, {160, 84}}, color = {0, 0, 127}));
  connect(mufflerOrifice.enthalpyFlowRate_a, catalyst.enthalpyFlowRate_b) annotation(
    Line(points = {{180, 82}, {160, 82}}, color = {0, 0, 127}));
  connect(heatConst.y, catalyst.heatFlowRate_can_a) annotation(
    Line(points = {{140, 114}, {142, 114}, {142, 100}, {142, 100}}, color = {0, 0, 127}));
  connect(heatConst.y, catalyst.heatFlowRate_can_b) annotation(
    Line(points = {{140, 114}, {156, 114}, {156, 100}, {156, 100}}, color = {0, 0, 127}));
  connect(HTCConst.y, catalyst.htc_input) annotation(
    Line(points = {{140, 144}, {148, 144}, {148, 100}, {148, 100}}, color = {0, 0, 127}));
  connect(TambConst.y, catalyst.temperature_amb) annotation(
    Line(points = {{140, 174}, {152, 174}, {152, 100}, {152, 100}}, color = {0, 0, 127}));
  connect(phi_throttle, characteristic.u) annotation(
    Line(points = {{-240, 160}, {-122, 160}}, color = {0, 0, 127}));
  connect(characteristic.y, throttle.opening) annotation(
    Line(points = {{-99, 160}, {-90, 160}, {-90, 96}, {-46, 96}, {-46, 88}}, color = {0, 0, 127}));
  connect(fuelMpr, multiCylinderEngine.fuelMprInput) annotation(
    Line(points = {{-240, 120}, {-226, 120}, {-226, 0}, {-20, 0}, {-20, 0}}, color = {0, 0, 127}));
  connect(p_boost, chargeAirCooler.absolutePressure_b) annotation(
    Line(points = {{-240, 180}, {18, 180}, {18, 172}, {18, 172}}, color = {0, 0, 127}));
  connect(wastegateOpening, turboCharger.wasteGateOpening) annotation(
    Line(points = {{-240, 140}, {-100, 140}, {-100, 60}, {50, 60}, {50, 90}, {50, 90}}, color = {0, 0, 127}));
  annotation(
    experiment(StartTime = 0, StopTime = 0.001, Tolerance = 1e-6, Interval = 2e-6),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end SampleEngineUnitTCCACTWC3;
