within AICE.Fluid.Fittings.Examples;

model TestFixedOrifice
  replaceable package Medium = AICE.RES.GAS.MED.MGC_B;

  extends Modelica.Icons.Example;

  inner Modelica.Fluid.System system annotation(
    Placement(
      visible = true,
      transformation(origin = {-80, 80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Fluid.Sources.Boundary_pT boundary(
    redeclare final package Medium = Medium,
    nPorts = 1, p = 200000, use_T_in = false, use_p_in = false
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-80, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Fluid.Sources.Boundary_pT boundary1(
    redeclare final package Medium = Medium,
    nPorts = 1, p = 101325, use_T_in = false, use_p_in = false
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {82, 40}, extent = {{10, -10}, {-10, 10}}, rotation = 0)
    )
  );

  AICE.Fluid.Fittings.Orifices.FixedOrifice fixedOrifice1(
    redeclare final package Medium = Medium,
    diameter = 0.01
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Fluid.Sources.Boundary_pT boundary2(
    redeclare final package Medium = Medium,
    nPorts = 1, p = 200000
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-80, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Fluid.Sources.Boundary_pT boundary3(
    redeclare final package Medium = Medium,
    nPorts = 1, p = 101325
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {82, -60}, extent = {{-10, 10}, {10, -10}}, rotation = 180)
    )
  );

  Modelica.Fluid.Fittings.SimpleGenericOrifice orifice(
    redeclare final package Medium = Medium,
    diameter = 0.01, use_zeta = true, zeta = 3.78
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

equation

  connect(orifice.port_b, boundary3.ports[1]) annotation(
    Line(points = {{10, -60}, {72, -60}, {72, -60}, {72, -60}}, color = {0, 127, 255}));
  connect(boundary2.ports[1], orifice.port_a) annotation(
    Line(points = {{-70, -60}, {-10, -60}, {-10, -60}, {-10, -60}}, color = {0, 127, 255}));
  connect(fixedOrifice1.port_b, boundary1.ports[1]) annotation(
    Line(points = {{10, 40}, {72, 40}, {72, 40}, {72, 40}}, color = {0, 127, 255}));
  connect(boundary.ports[1], fixedOrifice1.port_a) annotation(
    Line(points = {{-70, 40}, {-10, 40}, {-10, 40}, {-10, 40}}, color = {0, 127, 255}));

end TestFixedOrifice;
