within AICE.Fluid.Fittings;

model LumpedManifold
  extends Icons.Fluid.ClosedVolume;
  extends BaseClasses.PartialManifold;
  extends BaseClasses.LumpedManifoldParameters;

  Modelica.Fluid.Vessels.ClosedVolume volume(
    redeclare replaceable package Medium = Medium,
    nPorts = nCylinders + 1,
    use_portsData = false,
    V = V,
    use_HeatTransfer = false,
    energyDynamics = energyDynamics,
    massDynamics = massDynamics,
    m_flow_nominal = m_flow_nominal,
    m_flow_small = m_flow_small,
    use_Re = use_Re,
    p_start = p_start,
    use_T_start = use_T_start, T_start = T_start,
    h_start = h_start,
    X_start = X_start
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 40}, extent = {{-20, -20}, {20, 20}}, rotation = 0)
    )
  );

equation

  connect(volume.ports[1:nCylinders], ports_b[1:nCylinders])
  annotation(
    Line(points = {{0, 20}, {+5, 20}, {+5, 0}, {+100, 0}}, color = {0, 127, 255}, thickness = 0.5)
  );
  connect(volume.ports[nCylinders+1], port_a)
  annotation(
    Line(points = {{0, 20}, {-5, 20}, {-5, 0}, {-100, 0}}, color = {0, 127, 255})
  );

end LumpedManifold;
