within AICE.Fluid.Fittings;

model LumpedManifold2
  extends Icons.Fluid.ClosedVolume;
  extends BaseClasses.PartialManifold;
  extends BaseClasses.LumpedManifoldParameters;

  Modelica.Fluid.Vessels.ClosedVolume volume(
    redeclare replaceable package Medium = Medium, T_start = T_start,
    V = V,
    X_start = X_start,
    energyDynamics = energyDynamics,
    h_start = h_start,
    m_flow_nominal = m_flow_nominal,
    m_flow_small = m_flow_small,
    massDynamics = massDynamics,
    nPorts = nCylinders + 1,
    p_start = p_start,
    use_HeatTransfer = true,
    use_Re = use_Re,
    use_T_start = use_T_start,
    use_portsData = false
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 40}, extent = {{-20, -20}, {20, 20}}, rotation = 0)
    )
  );
  Modelica.Thermal.HeatTransfer.Interfaces.HeatPort_a heatPort annotation(
    Placement(visible = true, transformation(origin = {-46, 98}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-46, 98}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation

  connect(volume.ports[1:nCylinders], ports_b[1:nCylinders])
  annotation(
    Line(points = {{0, 20}, {+5, 20}, {+5, 0}, {+100, 0}}, color = {0, 127, 255}, thickness = 0.5)
  );
  connect(volume.ports[nCylinders+1], port_a)
  annotation(
    Line(points = {{0, 20}, {-5, 20}, {-5, 0}, {-100, 0}}, color = {0, 127, 255})
  );
  connect(volume.heatPort, heatPort) annotation(
    Line(points = {{-20, 40}, {-46, 40}, {-46, 98}, {-46, 98}}, color = {191, 0, 0}));
end LumpedManifold2;
