within AICE.Fluid.Machines;

model TurbineFixGeom
  extends BaseClasses.PartialTurboMachine(FluidMachineType = AICE.Fluid.Machines.Types.FluidMachine.Turbine,
                                          MapType = AICE.Fluid.Machines.Types.MapValue.Reduced
                                          );
  replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;


  Modelica.Blocks.Tables.CombiTable2D massFlow_corMap(fileName = MassFlowMap, tableName = "table1", tableOnFile = true) annotation(
    Placement(visible = true, transformation(origin = {-50, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Tables.CombiTable2D efficiencyMap(fileName = EfficiencyMap, tableName = "table1", tableOnFile = true) annotation(
    Placement(visible = true, transformation(origin = {-50, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));

algorithm
    mflow_map := max(0, massFlow_corMap.y);
    massFlow_corMap.u2 := speed_map;
    massFlow_corMap.u1 := pi_ratio;
    eta_ad := max(0.01, efficiencyMap.y);
    efficiencyMap.u2 := speed_map;
    efficiencyMap.u1 := pi_ratio;
  
equation

  annotation(
    Icon(coordinateSystem(grid = {0.01, 0.01})),
    Diagram(coordinateSystem(extent = {{-200, -200}, {200, 200}}, grid = {0, 0})));


annotation(
    Icon(coordinateSystem(initialScale = 0.1)),
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end TurbineFixGeom;
