within AICE.Fluid.Machines;

model TurbineFixGeomWG
  //AICE.Fluid.Machines.Compressor Turbine;
    extends Modelica.Fluid.Interfaces.PartialTwoPort;

    extends BaseClasses.CommonParameters;
    replaceable package Medium = Modelica.Media.Interfaces.PartialMedium;
    parameter Modelica.SIunits.Area Av_wastegate;
    /*parameter AICE.Blocks.Types.Energy energy
  annotation(
    Dialog(tab="Advanced", group="Energy directions")
  );*/
    
  TurbineFixGeom turbine(redeclare replaceable package Medium = Medium, EfficiencyMap = EfficiencyMap, FluidMachineType = FluidMachineType, MapType = MapType, MassFlowMap = MassFlowMap, allowFlowReversal = false, dia_in = dia_in) annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Valves.ValveCompressible wastegate(redeclare replaceable package Medium = Medium, Av = Av_wastegate, CvData = Modelica.Fluid.Types.CvTypes.Av, allowFlowReversal = false, dp_nominal = 1000, filteredOpening = true) annotation(
    Placement(visible = true, transformation(origin = {0, -40}, extent = {{10, -10}, {-10, 10}}, rotation = 180)));
  AICE.Blocks.Interfaces.RealInput WasgeGateOpening annotation(
    Placement(visible = true, transformation(origin = {0, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 90), iconTransformation(origin = {0, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation(
    Placement(visible = true, transformation(origin = {0, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(port_a, turbine.port_a) annotation(
    Line(points = {{-100, 0}, {-10, 0}, {-10, 0}, {-10, 0}}));
  connect(turbine.port_b, port_b) annotation(
    Line(points = {{10, 0}, {98, 0}, {98, 0}, {100, 0}}, color = {0, 127, 255}));
  connect(wastegate.port_b, port_b) annotation(
    Line(points = {{10, -40}, {-60, -40}, {-60, 0}, {-100, 0}}, color = {0, 127, 255}));
  connect(wastegate.port_a, port_a) annotation(
    Line(points = {{-10, -40}, {58, -40}, {58, 0}, {100, 0}}, color = {0, 127, 255}));
  connect(WasgeGateOpening, wastegate.opening) annotation(
    Line(points = {{0, -100}, {0, -48}}, color = {0, 0, 127}));
  connect(turbine.flange_a, flange_a) annotation(
    Line(points = {{0, 10}, {0, 10}, {0, 100}, {0, 100}}));
end TurbineFixGeomWG;