within AICE.Fluid.Pipes.BaseClasses;

partial model PartialPipeReactionModel
  replaceable package Medium = Media.Interfaces.PartialCombustionMixtureMedium "Medium in the reaction model" annotation(
    choicesAllMatching = true);
  extends DynamicPipeParameters;
  parameter Integer n=nNodes "Number of reaction segments" annotation(
    Dialog(tab = "Internal Interface", enable = false),
    Evaluate = true);
  
  // Inputs provided to reaction model
  input Medium.ThermodynamicState[n] states "Thermodynamic states of reaction segments";
  input SI.AmountOfSubstance[n, Medium.nXi] MXis "Mole of reaction segments";
  // Outputs provided from reaction model
  output SI.MolarFlowRate[Medium.nXi] MbXi_flow;
  //output SI.HeatFlowRate Qb_flow;
  annotation(
    Icon(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}), graphics = {Ellipse(extent = {{-60, 64}, {60, -56}}, lineColor = {0, 0, 0}, fillPattern = FillPattern.Sphere, fillColor = {255, 170, 0}), Text(extent = {{-38, 26}, {40, -14}}, lineColor = {0, 0, 0}, textString = "%name")}));
end PartialPipeReactionModel;