within AICE.Fluid.Pipes.BaseClasses;

model RateSpecifiedReaction
  replaceable package Medium = AICE.Media.IdealGases.Examples.Sample5MixtureGas;
  
 extends PartialTimeBasedReaction(final nReaction = Medium.nCombustion, final stoichiometric_products = Medium.combustionStoichiometric_products, final stoichiometric_reactants = Medium.combustionStoichiometric_reactants);


  Modelica.Blocks.Interfaces.BooleanOutput combusts annotation(
    Placement(visible = true, transformation(origin = {-50, 40}, extent = {{5, -5}, {-5, 5}}, rotation = -90)));
  //parameter SI.Angle phi_combustion_period "Anglar period until 1-exp(-a_wiebe) of fuel burns";

  //Real[n, nReaction] theta = phi_currentReaction[:, :] / phi_combustion_period;

  // 触媒浄化率全体とセル当たり
  parameter Real eta_conv = 0.9;
  parameter Real eta_conv_cell = eta_conv^(1/n); //n個のセル通過(n乗)で入力した浄化率eta_convとなる
  
equation
  for i in 1:n loop
    for jReaction in 1:nReaction loop
      reactionRates[i, jReaction] = if reacts[i, jReaction] then reactableAmounts[i, jReaction] * eta_conv_cell else 0.0;
    end for;
    reactionHeatFlows[i, :] = reactionRates[i, :] .* (Medium.combustionLHV[:] .+ Hs_balance[i, :]);
  end for;
// `combusts` :: Any reaction is occurring.
  combusts = Modelica.Math.BooleanVectors.anyTrue(Modelica.Math.BooleanVectors.anyTrue(reacts));
end RateSpecifiedReaction;