within AICE.Fluid.Valves.Examples;

model TestCamBasedValve
  replaceable package Medium = AICE.RES.GAS.MED.MGC_B;
  
  extends Modelica.Icons.Example;
  inner Modelica.Fluid.System system annotation(
    Placement(visible = true, transformation(origin = {-86, 84}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.Boundary_pT boundary(redeclare final package Medium = Medium, nPorts = 1, p = 200000, use_T_in = false, use_p_in = false) annotation(
    Placement(visible = true, transformation(origin = {-80, 34}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.Boundary_pT boundary1(redeclare final package Medium = Medium, nPorts = 1, p = 101325, use_T_in = false, use_p_in = false) annotation(
    Placement(visible = true, transformation(origin = {82, 34}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.Boundary_pT boundary2(redeclare final package Medium = Medium, nPorts = 1, p = 200000,use_T_in = false, use_p_in = false)  annotation(
    Placement(visible = true, transformation(origin = {-80, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.Boundary_pT boundary3(redeclare final package Medium = Medium, nPorts = 1, p = 101325,use_T_in = false, use_p_in = false)  annotation(
    Placement(visible = true, transformation(origin = {82, -60}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Fluid.Valves.ValveLinear valveLinear1(redeclare final package Medium = Medium, dp_nominal (displayUnit = "Pa") = 1, m_flow_nominal = 2e-7) annotation(
    Placement(visible = true, transformation(origin = {0, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Sine sine2(freqHz = 13)  annotation(
    Placement(visible = true, transformation(origin = {-70, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Abs abs1 annotation(
    Placement(visible = true, transformation(origin = {-30, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Fluid.Valves.CamBasedValve camBasedValve1(redeclare final package Medium = Medium) annotation(
    Placement(visible = true, transformation(origin = {2, 34}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant const(k = 0)  annotation(
    Placement(visible = true, transformation(origin = {-42, 56}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp1(duration = 1, height = 360)  annotation(
    Placement(visible = true, transformation(origin = {-22, 86}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(ramp1.y, camBasedValve1.phi_crank) annotation(
    Line(points = {{-11, 86}, {2, 86}, {2, 43}}, color = {0, 0, 127}));
  connect(const.y, camBasedValve1.phi_offset) annotation(
    Line(points = {{-30, 56}, {-20, 56}, {-20, 40}, {-7, 40}}, color = {0, 0, 127}));
  connect(boundary.ports[1], camBasedValve1.port_a) annotation(
    Line(points = {{-70, 34}, {-8, 34}}, color = {0, 127, 255}));
  connect(camBasedValve1.port_b, boundary1.ports[1]) annotation(
    Line(points = {{12, 34}, {72, 34}}, color = {0, 127, 255}));
  connect(abs1.y, valveLinear1.opening) annotation(
    Line(points = {{-18, -20}, {0, -20}, {0, -52}}, color = {0, 0, 127}));
  connect(boundary2.ports[1], valveLinear1.port_a) annotation(
    Line(points = {{-70, -60}, {-10, -60}}, color = {0, 127, 255}));
  connect(valveLinear1.port_b, boundary3.ports[1]) annotation(
    Line(points = {{10, -60}, {72, -60}}, color = {0, 127, 255}));
  connect(sine2.y, abs1.u) annotation(
    Line(points = {{-58, -20}, {-42, -20}, {-42, -20}, {-42, -20}}, color = {0, 0, 127}));
end TestCamBasedValve;
