within AICE.Fluid.Vessels.BaseClasses;

model HeatExchanger
  extends AICE.Icons.Fluid.HeatExchanger;
  extends ClosedVolumeParameters_hot;
  extends ClosedVolumeParameters_cool;
  extends PartialHeatExchanger(
    redeclare Modelica.Fluid.Vessels.ClosedVolume volumeAcausal_hot(
      redeclare package Medium = Medium,
      V = V_hot, 
      final use_HeatTransfer = true, 
      energyDynamics = energyDynamics_hot, 
      massDynamics = massDynamics_hot, 
      m_flow_nominal = m_hot_flow_nominal, 
      m_flow_small = m_hot_flow_small, 
      use_Re = use_Re_hot, 
      p_start = p_hot_start, 
      use_T_start = use_T_hot_start, 
      T_start = T_hot_start, 
      h_start = h_hot_start, 
      X_start = X_hot_start), 
    redeclare Modelica.Fluid.Vessels.ClosedVolume volumeAcausal_cool(
      redeclare package Medium = Medium, 
      V = V_cool, 
      final use_HeatTransfer = true, 
      energyDynamics = energyDynamics_cool, 
      massDynamics = massDynamics_cool, 
      m_flow_nominal = m_cool_flow_nominal, 
      m_flow_small = m_cool_flow_small, 
      use_Re = use_Re_cool, 
      p_start = p_cool_start, 
      use_T_start = use_T_cool_start, 
      T_start = T_cool_start, 
      h_start = h_cool_start, 
      X_start = X_cool_start
      )
    );
    
  initial equation
    volumeAcausal_cool.medium.p = p_cool_start;
    volumeAcausal_cool.medium.T = T_cool_start;
    volumeAcausal_cool.medium.h = h_cool_start;
    volumeAcausal_cool.medium.Xi[:] = X_cool_start[:];

  annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
end HeatExchanger;