within AICE.Fluid.Vessels.BaseClasses;

model HeatExchangerGasPathAOTI

  replaceable package Medium_hot = AICE.Media.IdealGases.Examples.Sample5MixtureGas;

  Modelica.Fluid.Sources.FixedBoundary intakeBoundary(redeclare replaceable package Medium = Medium_hot, T = 400, p = 100000, use_T = true, use_p = true, nPorts = 1) annotation(
    Placement(visible = true, transformation(origin = {-62, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Fittings.SimpleGenericOrifice intakePressureDrop(redeclare replaceable package Medium = Medium_hot, diameter = 0.01, zeta = 4) annotation(
    Placement(visible = true, transformation(origin = {-30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.FixedBoundary exhaustBoundary(redeclare package Medium = Medium_hot, T = 300, p = 99000, use_T = true, use_p = true, nPorts = 1) annotation(
    Placement(visible = true, transformation(origin = {82, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Fluid.Fittings.SimpleGenericOrifice exhaustPressureDrop(redeclare package Medium = Medium_hot, diameter = 0.01, zeta = 4) annotation(
    Placement(visible = true, transformation(origin = {30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Pipes.DynamicPipe pipe_hot(redeclare replaceable package Medium = Medium_hot,diameter = 0.01, length = 0.1)  annotation(
    Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  AICE.Blocks.Fluid.Compressible.Interfaces.Adaptors.Adaptor_AOTI adaptor_a annotation(
    Placement(visible = true, transformation(origin = {-60, -54}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
equation
  connect(intakeBoundary.ports[1], intakePressureDrop.port_a) annotation(
    Line(points = {{-52, 0}, {-40, 0}}, color = {0, 127, 255}));
  connect(exhaustPressureDrop.port_b, exhaustBoundary.ports[1]) annotation(
    Line(points = {{40, 0}, {72, 0}}, color = {0, 127, 255}));
  connect(intakePressureDrop.port_b, pipe_hot.port_a) annotation(
    Line(points = {{-20, 0}, {-10, 0}}, color = {0, 127, 255}));
  connect(pipe_hot.port_b, exhaustPressureDrop.port_a) annotation(
    Line(points = {{10, 0}, {20, 0}}, color = {0, 127, 255}));
end HeatExchangerGasPathAOTI;