within AICE.Fluid.Vessels.BaseClasses;

partial model PartialHeatExchanger
  extends DualFlowHeatExchange;
  replaceable Modelica.Fluid.Vessels.BaseClasses.PartialLumpedVessel volumeAcausal_hot(redeclare replaceable package Medium = Medium, 
     nPorts = 2, use_portsData = false) annotation(
    Placement(visible = true, transformation(origin = {0, 48}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  replaceable Modelica.Fluid.Vessels.BaseClasses.PartialLumpedVessel volumeAcausal_cool(redeclare replaceable package Medium = Medium,
     nPorts = 2, use_portsData = false) annotation(
    Placement(visible = true, transformation(origin = {0, -48}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  AICE.Fluid.Vessels.BaseClasses.PartialHeatTransfer heatTransfer annotation(
    Placement(visible = true, transformation(origin = {-50, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
   SI.Temperature T_hot_chamber(min=250, max=400), T_cool_chamber(min=250, max=400);
   
equation
  heatTransfer.Q_flow = q_hx;
  volumeAcausal_hot.medium.T = T_hot_chamber;
  volumeAcausal_cool.medium.T = T_cool_chamber;

  connect(port_a, volumeAcausal_hot.ports[1]) annotation(
    Line(points = {{-100, 0}, {0, 0}, {0, 28}, {0, 28}}));
  connect(volumeAcausal_hot.ports[2], port_b) annotation(
    Line(points = {{0, 28}, {0, 28}, {0, 0}, {100, 0}, {100, 0}}, color = {0, 127, 255}));
  connect(port_1, volumeAcausal_cool.ports[1]) annotation(
    Line(points = {{0, 100}, {40, 100}, {40, -68}, {0, -68}, {0, -68}}));
  connect(volumeAcausal_cool.ports[2], port_2) annotation(
    Line(points = {{0, -68}, {40, -68}, {40, -100}, {0, -100}, {0, -100}}, color = {0, 127, 255}));
  connect(volumeAcausal_hot.heatPort, heatTransfer.port_a) annotation(
    Line(points = {{-20, 48}, {-30, 48}, {-30, -28}, {-72, -28}, {-72, -50}, {-60, -50}, {-60, -50}}, color = {191, 0, 0}));
  connect(heatTransfer.port_b, volumeAcausal_cool.heatPort) annotation(
    Line(points = {{-40, -50}, {-20, -50}, {-20, -48}, {-20, -48}}, color = {191, 0, 0}));
end PartialHeatExchanger;