within AICE.Math.Examples;
model AngleDifference
  import Modelica.Constants.pi;

  import AICE.Math.AngleDifference4Stroke.Difference;

  import AICE.CarUnits;
  import Modelica.SIunits;

  extends Modelica.Icons.Example;

  SIunits.Angle rad4Hz, rad6Hz;
  CarUnits.Angle_deg deg8Hz;

  Difference diff2Hz;
  Difference diff4Hz;
  Difference diff6Hz;
  Difference diff8Hz;
  Difference diff10Hz;

  Real
    _6Hz_eq_8Hz, _6Hz_ne_8Hz,
    _6Hz_lt_8Hz, _6Hz_le_8Hz,
    _6Hz_gt_8Hz, _6Hz_ge_8Hz;

equation

  rad4Hz = time * 4 * 2*pi;
  rad6Hz = time * 6 * 2*pi;
  deg8Hz = time * 8 * 360;

  diff4Hz = Difference.fromAngle(rad4Hz);
  diff6Hz = Difference.fromAngle(rad6Hz);
  diff8Hz = Difference.fromAngle(deg8Hz, unit=Difference.UnitKind.deg);

  diff10Hz = diff4Hz + diff6Hz;
  diff2Hz  = diff8Hz - diff6Hz;

  _6Hz_eq_8Hz = if diff6Hz == diff8Hz then 1.0 else 0.0;
  _6Hz_ne_8Hz = if diff6Hz <> diff8Hz then 1.0 else 0.0;
  _6Hz_lt_8Hz = if diff6Hz <  diff8Hz then 1.0 else 0.0;
  _6Hz_le_8Hz = if diff6Hz <= diff8Hz then 1.0 else 0.0;
  _6Hz_gt_8Hz = if diff6Hz >  diff8Hz then 1.0 else 0.0;
  _6Hz_ge_8Hz = if diff6Hz >= diff8Hz then 1.0 else 0.0;

end AngleDifference;
