within AICE.Math;

block MovingAverage
  parameter SI.Time period = 0.1;
  Real x, x2, x_inte, x_inte2, x_inte_diff, x_ma;
  //Real y;
  //discrete Boolean engaged(start=false);
  Blocks.Interfaces.RealInput realInput annotation(
    Placement(visible = true, transformation(origin = {-106, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-106, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Blocks.Interfaces.RealOutput realOutput annotation(
    Placement(visible = true, transformation(origin = {106, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {106, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  x = realInput;
  x2 = delay(x, period);
  x_ma = realOutput;
  x_inte_diff = x_inte - x_inte2;
  x_ma = x_inte_diff / period;
  der(x_inte) = x;
  if time > period then
    der(x_inte2) = x2;
  else
    der(x_inte2) = 0;
  end if annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
  annotation(
    experiment(StartTime = 0, StopTime = 5, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end MovingAverage;