within AICE.Mechanics.Rotational.Components;

model FMEPA4CylinderCrankShaft
  extends AICE.Icons.Rotational.CrankShaft;

  extends Interfaces.Partial4CylinderCrankShaft;

  extends AICE.Blocks.Mechanics.Rotational.Components.BaseClasses.FMEPAParameters;

  AICE.Mechanics.Rotational.Components.PhaseDelays phaseDelays(
    nFlanges_b = nCylinders,
    delays = {
      CarUnits.Conversions.from_deg(0),
      CarUnits.Conversions.from_deg(180),
      CarUnits.Conversions.from_deg(540),
      CarUnits.Conversions.from_deg(360)
    }
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {50, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  AICE.ENG.MVE.FMEPA fmep(
    C0_Nm = C0_Nm,
    C1_NmpRPM = C1_NmpRPM,
    C2_NmpRPM2 = C2_NmpRPM2
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-50, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

equation

  connect(flange_a, fmep.flange_a) annotation(
    Line(points = {{-100, 0}, {-60, 0}}, color = {95, 95, 95})
  );
  connect(fmep.flange_b, phaseDelays.flange_a) annotation(
    Line(points = {{ -40, 0}, { 40, 0}}, color = {95, 95, 95})
  );
  connect(phaseDelays.flanges_b[:], flanges_b[:]) annotation(
    Line(points = {{  60, 0}, {100, 0}}, color = {95, 95, 95}, thickness = 0.5)
  );

annotation(
    Icon());
end FMEPA4CylinderCrankShaft;
