within AICE.Mechanics.Rotational.Components;

model Ideal4CylinderCrankShaft
  extends AICE.Icons.Rotational.CrankShaft;

  extends Interfaces.Partial4CylinderCrankShaft;

  AICE.Mechanics.Rotational.Components.PhaseDelays phaseDelays(
    nFlanges_b = nCylinders,
    delays = {
      CarUnits.Conversions.from_deg(0),
      CarUnits.Conversions.from_deg(180),
      CarUnits.Conversions.from_deg(540),
      CarUnits.Conversions.from_deg(360)
    }
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

equation

  connect(flange_a, phaseDelays.flange_a) annotation(
    Line(points = {{-100, 0}, {-10, 0}})
  );
  connect(phaseDelays.flanges_b, flanges_b) annotation(
    Line(points = {{10, 0}, {100, 0}}, thickness = 0.5)
  );

end Ideal4CylinderCrankShaft;
