within AICE.Mechanics.Rotational.Components;

model MultipleIdealGear
  extends Modelica.Mechanics.Rotational.Icons.Gear;
  extends
    Modelica.Mechanics.Rotational.Interfaces.PartialElementaryTwoFlangesAndSupport2;

  Modelica.Blocks.Interfaces.IntegerInput position
  annotation(
    Placement(
      visible = true,
      transformation(origin = {0, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90),
      iconTransformation(origin = {0, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90)
    )
  );

  parameter Integer nPosition(min=1) = size(ratios, 1)
  annotation(Evaluate = true);

  parameter SI.DimensionlessRatio[nPosition] ratios;
  discrete SI.DimensionlessRatio ratio = ratios[position];

  SI.Angle phi_a = flange_a.phi - phi_support
    "Angle between left shaft flange and support";
  SI.Angle phi_b = flange_b.phi - phi_support
    "Angle between right shaft flange and support";

  SI.AngularVelocity w_a = der(phi_a);
  SI.AngularVelocity w_b = der(phi_b);

  SI.Power power_a = w_a * flange_a.tau;
  SI.Power power_b = w_b * flange_b.tau;

equation

  w_a = ratio * w_b;
  0 = power_a + power_b;

end MultipleIdealGear;
