within AICE.Mechanics.Rotational.Components.Tests.Gears;

block TorqueCurve
  extends Modelica.Blocks.Interfaces.SISO(
    u(final unit = "rad/s", displayUnit = "rpm"),
    y(final unit = "N.m")
  );

  parameter SI.Torque peakTorque
    "Max torque";
  parameter CarUnits.AngularVelocity w_peak
    "Angular velocity at torque peak";

  SI.DimensionlessRatio w_normalized = u / w_peak;

equation

  y = max(0.0, peakTorque * ( 1 - (w_normalized - 1) ^ 2));

end TorqueCurve;