within AICE.Media.IdealGases.Examples;

package Sample5MixtureGas
  extends AICE.Media.IdealGases.CombustionMixtureGasNasa(
    mediumName = "OctaneMixtureWithAir",
    reducedX = false,
    data = {
      Modelica.Media.IdealGases.Common.SingleGasesData.N2,
      Modelica.Media.IdealGases.Common.SingleGasesData.O2,
      Modelica.Media.IdealGases.Common.SingleGasesData.C8H18_n_octane,
      Modelica.Media.IdealGases.Common.SingleGasesData.H2O,
      Modelica.Media.IdealGases.Common.SingleGasesData.CO2
    },
    fluidConstants = {
      Modelica.Media.IdealGases.Common.FluidData.N2,
      Modelica.Media.IdealGases.Common.FluidData.O2,
      Modelica.Media.IdealGases.Common.FluidData.C8H18_n_octane,
      Modelica.Media.IdealGases.Common.FluidData.H2O,
      Modelica.Media.IdealGases.Common.FluidData.CO2
    },
    substanceNames = {"Nitrogen", "Oxygen", "C8H18_n_octane", "H2O", "CO2"},
    reference_X      = {0.768, 0.232, 0.000, 0.000, 0.000},  // [kg/kg]
    reference_X_fuel = {0.000, 0.000, 1.000, 0.000, 0.000},  // [kg/kg]
    nCombustion = 1,
    combustionStoichiometric_reactants = {{ 0.0, 12.5,  1.0,  0.0,  0.0}},  // [mol/mol]
    combustionStoichiometric_products  = {{ 0.0,  0.0,  0.0,  9.0,  8.0}},  // [mol/mol]
    combustionLHV = {5500000.0}  // [J/mol]
  );
end Sample5MixtureGas;
