within AICE.PowerUnits.Combustions.Chambers.BaseClasses.HeatTransfers;

model ConstantHeatTransfer
    "ConstantHeatTransfer: Constant heat transfer coefficient"

  extends PartialChamberHeatTransfer;

  parameter SI.CoefficientOfHeatTransfer alpha0
      "constant heat transfer coefficient";

equation
  Q_flows = {(alpha0+k)*surfaceAreas[i]*(heatPorts[i].T - Ts[i]) for i in 1:n};

  annotation(
    Documentation(
      info=
"<html>
Simple heat transfer correlation with constant heat transfer coefficient.
</html>"
    )
  );

end ConstantHeatTransfer;
