within AICE.PowerUnits.Combustions.Chambers.BaseClasses.ReactionModels.Functions;

function calcurateReactableAmount
  /*
   * reactableAmount = min(
   *   max(M, 0) / s
   *   for s, M in zip(stoichiometric, MXi)
   *   if s > 0
   * )
   */
  extends Modelica.Icons.Function;

  input SI.StoichiometricNumber[:] stoichiometric;
  input SI.AmountOfSubstance[size(stoichiometric,1)] MXi;
  output SI.AmountOfSubstance reactableAmount;

protected
  SI.AmountOfSubstance temp_reactableAmount;
  Boolean reactableFound;

algorithm
  reactableFound := false;
  reactableAmount := 0;

  for iXi in 1:size(stoichiometric,1) loop
    if stoichiometric[iXi] > 0 then
      temp_reactableAmount := max(0, MXi[iXi]) / stoichiometric[iXi];
      if not reactableFound then
        reactableFound := true;
        reactableAmount := temp_reactableAmount;
      else
        reactableAmount := min(reactableAmount, temp_reactableAmount);
      end if;
    end if;
  end for;

end calcurateReactableAmount;
