within AICE.PowerUnits.Combustions.Examples.BaseClasses;

partial model SimpleEngineUnitDefaultValues1
  extends SimpleEngineUnitParameters(
    // pressures [Pa] (displayed by [bar])
    p_supercharged =
       1.2090e5,
    p_start_intakePipe =
       1.2090e5,
    p_start_intakeManifold =
       0.8710e5,
    p_start_chamber1 =
      57.0000e5,
    p_start_chamber2 =
       0.9000e5,
    p_start_chamber3 =
       2.1370e5,
    p_start_chamber4 =
       1.2000e5,
    p_start_exhaustManifold =
       1.1396e5,
    p_exhaust =
       1.1396e5,

    // temperatures [K] (displayed by [degC])
    T_supercharged =
       315.35,
    T_start_intakePipe =
       315.35,
    T_start_intakeManifold =
       373.85,
    T_start_chamber1 =
      3000.00,
    T_start_chamber2 =
       370.00,
    T_start_chamber3 =
      1406.00,
    T_start_chamber4 =
      1100.00,
    T_engineRoom =
       450.15,
    T_start_exhaustManifold =
      1147.89,
    T_exhaust =
      1147.89,

    // diameters [m] (displayed by [mm])
    d_intakePipe =
      100.00e-3,
    d_throttle =
       50.00e-3,
    d_valve_intake =
       40.98e-3,
    d_valve_exhaust =
       35.39e-3,
    d_exhaustPipe =
      100.00e-3,

    // volumes [m3] (displayed by [mL])
    V_intakePipe =
       392.6991e-6,
    V_intakeManifold =
      3296.6100e-6,
    V_displacement =
      1497.8074e-6,
    V_exhaustManifold =
      1784.5150e-6,
    compressionRatio = 
      12.5,

    // other default values
    l_connRod =
         0.172,
    offset_crank =
         0.0,
    bore =
         0.0745,
    fuelPerCycle =
         0.031244e-3,
    injectionStart =
        -0.680678,
    injectionPeriod =
         0.0174533,
    reference_T_vap =
       773.15,
    m_wiebe =
         2,
    phi_combustion_begin =
         0.0,
    phi_combustion_period =
         0.945968,
    c1_woschni_intakeExhaust =
         6.18,
    c1_woschni_compressionPower =
         2.28,
    c2_woschni =
         0.00324,

    // table data paths
    fileName_lift_intake  = Files.loadResource(
      "modelica://AICE/Resources/TableData/Valve/liftFromAngle_ValidationGT_intake.txt"
    ),
    fileName_cd_intake    = Files.loadResource(
      "modelica://AICE/Resources/TableData/Valve/GT_validation_intake_valve_cd.txt"
    ),
    fileName_lift_exhaust = Files.loadResource(
      "modelica://AICE/Resources/TableData/Valve/liftFromAngle_ValidationGT_exhaust.txt"
    ),
    fileName_cd_exhaust   = Files.loadResource(
      "modelica://AICE/Resources/TableData/Valve/GT_validation_exhaust_valve_cd.txt"
    )
  );
end SimpleEngineUnitDefaultValues1;
