within AICE.PowerUnits.Combustions.Examples;

model TestEngineUnit1
  extends Modelica.Icons.Example;

  Modelica.Blocks.Sources.Constant deg_throttleOpening(
    k = 18
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-80, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Blocks.Math.UnitConversions.From_deg from_deg1
  annotation(
    Placement(
      visible = true,
      transformation(origin = {-55, 50}, extent = {{-5, -5}, {5, 5}}, rotation = 0)
    )
  );

  AICE.PowerUnits.Combustions.Examples.SimpleEngineUnit engineUnit
  annotation(
    Placement(
      visible = true,
      transformation(origin = {-20, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Mechanics.Rotational.Sources.Speed speed(
    exact = true, phi(start = 0)
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {20, 50}, extent = {{10, -10}, {-10, 10}}, rotation = 0)
    )
  );

  Modelica.Blocks.Math.UnitConversions.From_rpm from_rpm1
  annotation(
    Placement(
      visible = true,
      transformation(origin = {55, 50}, extent = {{5, -5}, {-5, 5}}, rotation = 0)
    )
  );

  Modelica.Blocks.Sources.Constant rpm_engineSpeed(
    k = 2000
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {80, 50}, extent = {{10, -10}, {-10, 10}}, rotation = 0)
    )
  );

equation

  connect(engineUnit.flange, speed.flange) annotation(
    Line(points = {{-10, 50}, {10, 50}})
  );

  connect(deg_throttleOpening.y, from_deg1.u) annotation(
    Line(points = {{-70, 50}, {-60, 50}}, color = {0, 0, 127})
  );
  connect(from_deg1.y, engineUnit.phi_throttleOpening) annotation(
    Line(points = {{-50, 50}, {-30, 50}}, color = {0, 0, 127})
  );

  connect(rpm_engineSpeed.y, from_rpm1.u) annotation(
    Line(points = {{+70, 50}, {+60, 50}}, color = {0, 0, 127})
  );

  connect(from_rpm1.y, speed.w_ref) annotation(
    Line(points = {{+50, 50}, {+30, 50}}, color = {0, 0, 127})
  );

  annotation(
    experiment(
      StartTime = 0, StopTime = 0.08,
      Tolerance = 1e-6
    )
  );

end TestEngineUnit1;
