within AICE.PowerUnits.Combustions;

package Types
  extends Modelica.Icons.TypesPackage;

  type Stroke = enumeration(
    compression "Piston compresses mixture in the cylinder",
    power "Mixture burns and expands",
    exhaust "Piston discharges the burned gas to the outside",
    intake "Piston draws in mixture of air and fuel"
  );

  type WoschniC1 = Real(unit = "1")
    "Woschni C1 constant " +
    "(ratio of flow velocity to piston average speed)";

  type WoschniC2 = Real(unit = "m2.s/(kg.K)")
    "Woschni C2 constant " +
    "(represents fluid velocity due to combustion from p, T and compression ratio)";

end Types;
