within AICE.Research.AlgebraicLoops.Components;

block Accel2Throttle

  type AccelOpening = Real(unit="1", min=0.0, max=100.0);
  type ThrottleOpening = SI.Angle(min=0, max=SI.Conversions.from_deg(90));

  Real accel_normalized(min=0.0, max=1.0) = accel / 100.0;

  Modelica.Blocks.Interfaces.RealInput accel(
    unit="1", min=0.0, max=100.0
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0),
      iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)
    )
  );
  Modelica.Blocks.Interfaces.RealOutput throttle(
    unit="rad", displayUnit="deg", min=0.0, max=SI.Conversions.from_deg(90)
  ) annotation(
    Placement(
      visible = true,
      transformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0),
      iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  parameter ThrottleOpening throttle_min = SI.Conversions.from_deg(89);
  parameter ThrottleOpening throttle_max = SI.Conversions.from_deg(90);

algorithm

  throttle := (
    (1-accel_normalized) * throttle_min
    + (accel_normalized) * throttle_max
  );

end Accel2Throttle;
