within AICE.Research.Frederic_Pipe;

model OpenClosedLineTest

  replaceable package Medium =
    AICE.RES.GAS.MED.MGC_B
    annotation(choicesAllMatching = true,X = {0.75,0.25,0.0,0.0,0.0});

  extends Modelica.Icons.Example;

  AICE.RES.SOU.SpTUA PLEFT(
    redeclare replaceable package Medium = Medium,
    X_sou = {0.1, 0.9, 0.0, 0.0, 0.0}
  )
  annotation(
    Placement(
      visible = true,
      transformation(origin = {-42, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );
    
  Modelica.Blocks.Sources.Constant const(k = 50)  annotation(
    Placement(visible = true, transformation(origin = {-88, -14}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));

  AICE.PDE.DEV.EXP.EXP0A line01(
    redeclare replaceable package Medium = Medium,
    CONSTRAINTP = 1, DIN = 0.04, DOUT= 0.04, EonD = 0.001, FPERT = 0,
    KTHPERT = 0, L = 2.0, N = 15, NPERT = 0, T_CONSTRAINT = 1., useHeatPort = true
  )
  annotation(
    Placement(
      visible = true,
      transformation(origin = {-10, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Blocks.Sources.Ramp ramp(duration = 0.006, height = 1, offset = 1, startTime = 0.05)  annotation(
    Placement(visible = true, transformation(origin = {-128, 42}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Add add1 annotation(
    Placement(visible = true, transformation(origin = {-88, 32}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp1(duration = 0.002, height = -1, offset = 0, startTime = 0.2) annotation(
    Placement(visible = true, transformation(origin = {-156, 26}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Thermal.HeatTransfer.Sources.FixedTemperature TEXT(T = 298.15)  annotation(
    Placement(visible = true, transformation(origin = {-42, -36}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Constant constant1(k = 30) annotation(
    Placement(visible = true, transformation(origin = {126, -20}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));

  AICE.RES.SOU.SpTUA PRIGHT(
    redeclare replaceable package Medium = Medium,
    X_sou = {0.2, 0.8, 0.0, 0.0, 0.0}
  )
  annotation(
    Placement(
      visible = true,
      transformation(origin = {66, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)
    )
  );

  Modelica.Blocks.Sources.Ramp ramp2(duration = 0.006, height = 2, offset = 1, startTime = 0.15) annotation(
    Placement(visible = true, transformation(origin = {158, 64}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Add add annotation(
    Placement(visible = true, transformation(origin = {100, 44}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Ramp ramp3(duration = 0.006, height = -2, offset = 0, startTime = 0.3) annotation(
    Placement(visible = true, transformation(origin = {160, 22}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));

  AICE.RES.VOL.VOL1U endvolume(
    redeclare replaceable package Medium = Medium,
    V0 = 1.e-4
  )
  annotation(
    Placement(
      visible = true,
      transformation(origin = {18, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  AICE.RES.ORI.ORI1U orifice(
    redeclare replaceable package Medium = Medium
  )
  annotation(
    Placement(
      visible = true,
      transformation(origin = {42, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)
    )
  );

  Modelica.Blocks.Sources.Ramp ramp4(duration = 0.006, height = 1.e-4, offset = 0, startTime = 5) annotation(
    Placement(visible = true, transformation(origin = {2, 52}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(PLEFT.GP, line01.GP1) annotation(
    Line(points = {{-32, 0}, {-20, 0}}));
  connect(const.y, PLEFT.T) annotation(
    Line(points = {{-77, -14}, {-51.75, -14}, {-51.75, -6}, {-50, -6}}, color = {0, 0, 127}));
  connect(ramp.y, add1.u1) annotation(
    Line(points = {{-117, 42}, {-108.5, 42}, {-108.5, 38}, {-100, 38}}, color = {0, 0, 127}));
  connect(add1.y, PLEFT.PIN) annotation(
    Line(points = {{-77, 32}, {-56, 32}, {-56, 6}, {-50, 6}}, color = {0, 0, 127}));
  connect(ramp1.y, add1.u2) annotation(
    Line(points = {{-145, 26}, {-100, 26}}, color = {0, 0, 127}));
  connect(TEXT.port, line01.heatPort) annotation(
    Line(points = {{-32, -36}, {-20, -36}, {-20, -10}}, color = {191, 0, 0}));
  connect(constant1.y, PRIGHT.T) annotation(
    Line(points = {{115, -20}, {82.5, -20}, {82.5, -6}, {74, -6}}, color = {0, 0, 127}));
  connect(ramp2.y, add.u1) annotation(
    Line(points = {{147, 64}, {130.5, 64}, {130.5, 50}, {112, 50}}, color = {0, 0, 127}));
  connect(add.y, PRIGHT.PIN) annotation(
    Line(points = {{89, 44}, {77.5, 44}, {77.5, 6}, {74, 6}}, color = {0, 0, 127}));
  connect(ramp3.y, add.u2) annotation(
    Line(points = {{149, 22}, {131.5, 22}, {131.5, 38}, {112, 38}}, color = {0, 0, 127}));
  connect(line01.GP2, endvolume.GP1) annotation(
    Line(points = {{0, 0}, {8, 0}, {8, 0}, {8, 0}}));
  connect(endvolume.GP2, orifice.GP1) annotation(
    Line(points = {{28, 0}, {32, 0}, {32, 0}, {32, 0}}));
  connect(orifice.GP2, PRIGHT.GP) annotation(
    Line(points = {{52, 0}, {56, 0}, {56, 0}, {56, 0}}));
  connect(ramp4.y, orifice.Area) annotation(
    Line(points = {{14, 52}, {42, 52}, {42, 8}, {42, 8}}, color = {0, 0, 127}));
protected
  annotation(
    Icon(coordinateSystem(initialScale = 0.5)),
    Diagram(coordinateSystem(initialScale = 0.5)),
    experiment(StartTime = 0, StopTime = 0.5, Tolerance = 1e-6, Interval = 0.00025),
    uses(AICE(version = "0.1"), Modelica(version = "3.2.3")));





end OpenClosedLineTest;
