within AICE.Research.MSL_DynamicPipe;

model ShockTubeTest "Test Pulsation(pressure wave and flow reversal)"
  import Pipes = Modelica.Fluid.Pipes;
  extends Modelica.Icons.Example;
  replaceable package Medium = Modelica.Media.Air.DryAirNasa constrainedby Modelica.Media.Interfaces.PartialMedium;
  //replaceable package Medium=Modelica.Media.Water.StandardWater constrainedby Modelica.Media.Interfaces.PartialMedium;
  inner Modelica.Fluid.System system(energyDynamics = Modelica.Fluid.Types.Dynamics.SteadyStateInitial, momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyStateInitial) annotation(
    Placement(visible = true, transformation(extent = {{-88, 52}, {-68, 72}}, rotation = 0)));
  Modelica.Fluid.Pipes.DynamicPipe pipe(redeclare package Medium = Medium, diameter = 0.06, length = 9.024, modelStructure = Modelica.Fluid.Types.ModelStructure.a_v_b, nNodes = 100, p_a_start = 150000, p_b_start = 150000) annotation(
    Placement(visible = true, transformation(origin = {-2, 8}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  Modelica.Fluid.Sources.Boundary_pT boundary2( redeclare package Medium = Medium,nPorts = 1, p = 150000, use_T_in = false, use_p_in = true) annotation(
    Placement(visible = true, transformation(origin = {56, 8}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.MassFlowSource_T boundary1(redeclare package Medium=Medium, m_flow = 0, nPorts = 1)  annotation(
    Placement(visible = true, transformation(origin = {-64, 8}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step1(height = -0.5e5, offset = 1.5e5, startTime = 0.01)  annotation(
    Placement(visible = true, transformation(origin = {100, 16}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
equation
  connect(boundary1.ports[1], pipe.port_a) annotation(
    Line(points = {{-54, 8}, {-22, 8}}, color = {0, 127, 255}));
  connect(pipe.port_b, boundary2.ports[1]) annotation(
    Line(points = {{18, 8}, {46, 8}}, color = {0, 127, 255}));
  connect(step1.y, boundary2.p_in) annotation(
    Line(points = {{89, 16}, {67, 16}, {67, 16}, {69, 16}}, color = {0, 0, 127}));
  annotation(
    Diagram(coordinateSystem(extent = {{-150, -100}, {150, 100}}, initialScale = 0.1), graphics = {Text(origin = {-74, 31}, extent = {{-58, 19}, {28, -13}}, textString = "閉塞端の境界条件：m=0"), Text(origin = {68, 69}, lineColor = {0, 0, 255}, extent = {{-78, -5}, {74, -47}}, textString = "圧力：初期1.5bar，0.01s後に1.0barへとステップ変化させる"), Text(origin = {-148, 117}, extent = {{6, -11}, {76, -43}}, textString = "Medium : DryAirNasa"), Text(origin = {-88, 15}, lineColor = {0, 170, 0}, extent = {{6, -11}, {198, -79}}, textString = "pipe : diameter = 0.06m, Length = 9.024m, 100分割"), Text(origin = {-30, -57}, extent = {{-58, 19}, {70, -19}}, textString = "PointA(閉塞端から44mm)：N(2)"), Text(origin = {-34, -69}, extent = {{-58, 19}, {92, -27}}, textString = "PointB(閉塞端から7504mm)：N(83)")}),
    uses(Modelica(version = "3.2.2")));
    end ShockTubeTest;
