within AICE.Research.MSL_DynamicPipe;

model TestPulsation "Test Pulsation(pressure wave and flow reversal)"
  import Pipes = Modelica.Fluid.Pipes;
  extends Modelica.Icons.Example;
  replaceable package Medium = Modelica.Media.Air.DryAirNasa constrainedby Modelica.Media.Interfaces.PartialMedium;
  //replaceable package Medium=Modelica.Media.Water.StandardWater constrainedby Modelica.Media.Interfaces.PartialMedium;
  inner Modelica.Fluid.System system(energyDynamics = Modelica.Fluid.Types.Dynamics.SteadyStateInitial, momentumDynamics = Modelica.Fluid.Types.Dynamics.SteadyStateInitial) annotation(
    Placement(visible = true, transformation(extent = {{16, 56}, {36, 76}}, rotation = 0)));
  Modelica.Fluid.Sources.Boundary_pT boundary1( redeclare package Medium = Medium,nPorts = 1, p = 150000, use_p_in = false) annotation(
    Placement(visible = true, transformation(origin = {-60, 8}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Pipes.DynamicPipe pipe1(redeclare package Medium = Medium, diameter = 0.06, length = 1, modelStructure = Modelica.Fluid.Types.ModelStructure.a_v_b, nNodes = 100, p_a_start = 150000, p_b_start = 150000, use_T_start = true) annotation(
    Placement(visible = true, transformation(origin = {30, 8}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.Boundary_pT boundary2(redeclare package Medium = Medium,nPorts = 1, p = 150000, use_T_in = false, use_p_in = true) annotation(
    Placement(visible = true, transformation(origin = {86, 8}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step1(height = -0.5e5, offset = 1.5e5, startTime = 0.1)  annotation(
    Placement(visible = true, transformation(origin = {130, 16}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Fluid.Vessels.ClosedVolume volume(redeclare package Medium=Medium, V = 1.9227e-3, nPorts = 2)  annotation(
    Placement(visible = true, transformation(origin = {-18, 18}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(volume.ports[2], pipe1.port_a) annotation(
    Line(points = {{-18, 8}, {20, 8}, {20, 8}, {20, 8}}, color = {0, 127, 255}));
  connect(boundary1.ports[1], volume.ports[1]) annotation(
    Line(points = {{-50, 8}, {-20, 8}, {-20, 8}, {-18, 8}}, color = {0, 127, 255}, thickness = 0.5));
  connect(pipe1.port_b, boundary2.ports[1]) annotation(
    Line(points = {{40, 8}, {76, 8}}, color = {0, 127, 255}));
  connect(step1.y, boundary2.p_in) annotation(
    Line(points = {{118, 16}, {98, 16}, {98, 16}, {98, 16}}, color = {0, 0, 127}));
  annotation(
    Diagram(coordinateSystem(extent = {{-150, -100}, {150, 100}}, initialScale = 0.1), graphics = {Text(origin = {-82, 55}, lineColor = {255, 0, 0}, extent = {{-58, 19}, {54, -33}}, textString = "圧力：1.5⇔1.0barでパルス変化"), Text(origin = {70, 67}, lineColor = {0, 0, 255}, extent = {{6, -11}, {74, -47}}, textString = "圧力：1.0barで固定"), Text(origin = {-148, 117}, extent = {{6, -11}, {76, -43}}, textString = "Medium : DryAirNasa"), Text(origin = {-74, 7}, lineColor = {0, 170, 0}, extent = {{6, -11}, {198, -79}}, textString = "pipe1～3: diameter = 0.06 [m], Length = 9.024[m]"), Rectangle(origin = {-91, 8}, lineColor = {255, 0, 0}, lineThickness = 2, extent = {{-49, 30}, {49, -30}}), Rectangle(origin = {121, 0}, lineColor = {0, 0, 255}, lineThickness = 2, extent = {{-49, 30}, {-11, -10}}), Rectangle(origin = {11, -2}, lineColor = {0, 170, 0}, lineThickness = 2, extent = {{-49, 30}, {57, -10}})}),
    uses(Modelica(version = "3.2.2")));end TestPulsation;
