within AICE.Research.StreamConnector.Comparison.SimpleVolume;

model After
  replaceable package Medium = AICE.RES.GAS.MED.MGC_B;
  extends Modelica.Icons.Example;

  inner Modelica.Fluid.System system annotation(
    Placement(visible = true, transformation(origin = {70, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );

  // ============================================
  Modelica.Fluid.Sources.Boundary_pT source(
    redeclare replaceable package Medium = Medium,
    nPorts = 1, use_T_in = true, use_p_in = true
  ) annotation(
    Placement(visible = true, transformation(origin = {-50, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );
  AICE.Fluid.Fittings.Orifices.FixedOrifice orifice1(
    redeclare replaceable package Medium = Medium, diameter = 0.01
  ) annotation(
    Placement(visible = true, transformation(origin = {-10, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );
  Modelica.Fluid.Vessels.ClosedVolume volume1(
    redeclare replaceable package Medium = Medium,
    nPorts = 1, use_portsData = false, use_T_start = true,
    V = 2,
    p_start = 101325, T_start = 303.15
  ) annotation(
    Placement(visible = true, transformation(origin = {30, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );

equation

  source.p_in = (101325 + 20000);
  source.T_in = 30+273.15;

  connect(source.ports[1], orifice1.port_a) annotation(
    Line(points = {{-40, 10}, {-20, 10}}));
  connect(orifice1.port_b, volume1.ports[1]) annotation(
    Line(points = {{0, 10}, {30, 10}}));
  annotation(
    experiment(StartTime = 0, StopTime = 100, Tolerance = 1e-06, Interval = 0.002)
  );
end After;
