within AICE.Research.StreamConnector.Comparison.SimpleVolume;

model Before

  replaceable package Medium = AICE.RES.GAS.MED.MGC_B;
  extends Modelica.Icons.Example;

  // ============================================

  AICE.RES.SOU.SpTUA source(
    redeclare replaceable package Medium = Medium
  ) annotation(
    Placement(visible = true, transformation(origin = {-50, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );
  AICE.RES.ORI.ORIU0 orifice1(
    redeclare replaceable package Medium = Medium, D = 0.01
  ) annotation(
    Placement(visible = true, transformation(origin = {-10, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );
  AICE.RES.VOL.VOL1U volume1(
    redeclare replaceable package Medium = Medium,
    V0 = 2,
    pStart(displayUnit = "Pa") = 101325, TStart = 303.15
  ) annotation(
    Placement(visible = true, transformation(origin = {30, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );

equation

  source.PIN = (101325 + 20000) / 1e5;
  source.T = 30;

  connect(source.GP, orifice1.GP1) annotation(
    Line(points = {{-40, 10}, {-20, 10}}));
  connect(orifice1.GP2, volume1.GP1) annotation(
    Line(points = {{0, 10}, {20, 10}}));
  annotation(
    experiment(StartTime = 0, StopTime = 100, Tolerance = 1e-06, Interval = 0.002)
  );
end Before;
