within AICE.Research.StreamConnector.Comparison.SingleOrifice;

model After
  replaceable package Medium = AICE.RES.GAS.MED.MGC_B;
  extends Modelica.Icons.Example;

  inner Modelica.Fluid.System system annotation(
    Placement(visible = true, transformation(origin = {70, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );

  // ============================================
  Modelica.Fluid.Sources.Boundary_pT source(
    redeclare replaceable package Medium = Medium,
    nPorts = 1, use_T_in = true, use_p_in = true
  ) annotation(
    Placement(visible = true, transformation(origin = {-90, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );

  Modelica.Fluid.Sources.Boundary_pT sink(
    redeclare replaceable package Medium = Medium,
    nPorts = 1, use_T_in = true, use_p_in = true
  ) annotation(
    Placement(visible = true, transformation(origin = {90, 10}, extent = {{10, -10}, {-10, 10}}, rotation = 0))
  );
  AICE.Fluid.Fittings.Orifices.FixedOrifice orifice1(
    redeclare replaceable package Medium = Medium, diameter = 0.01
  ) annotation(
    Placement(visible = true, transformation(origin = {-50, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );

equation

  source.p_in = (101325 + 100000 * sin(2 * Modelica.Constants.pi * time));
  sink.p_in   = (101325);

  source.T_in = 30+273.15;
  sink.T_in   = 30+273.15;

  connect(source.ports[1], orifice1.port_a) annotation(
    Line(points = {{-80, 10}, {-60, 10}, {-60, 10}, {-60, 10}}, color = {0, 127, 255}));
  connect(orifice1.port_b, sink.ports[1]) annotation(
    Line(points = {{-40, 10}, {80, 10}, {80, 10}, {80, 10}}, color = {0, 127, 255}));
  annotation(
    experiment(StartTime = 0, StopTime = 100, Tolerance = 1e-06, Interval = 0.002)
  );
end After;
