within AICE.Research.StreamConnector.Comparison.SingleOrifice;

model Before
  replaceable package Medium = AICE.RES.GAS.MED.MGC_B;
  extends Modelica.Icons.Example;

  // ============================================
  AICE.RES.SOU.SpTUA source(
    redeclare replaceable package Medium = Medium
  ) annotation(
    Placement(visible = true, transformation(origin = {-90, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );
  AICE.RES.SOU.SpTUA sink(
    redeclare replaceable package Medium = Medium
  ) annotation(
    Placement(visible = true, transformation(origin = {90, 10}, extent = {{10, -10}, {-10, 10}}, rotation = 0))
  );
  AICE.RES.ORI.ORIU0 orifice1(
    redeclare replaceable package Medium = Medium, D = 0.01
  ) annotation(
    Placement(visible = true, transformation(origin = {-50, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0))
  );

equation

  source.PIN = (101325 + 100000 * sin(2 * Modelica.Constants.pi * time)) / 1e5;
  sink.PIN   = (101325) / 1e5;

  source.T = 30;
  sink.T  = 30;

  connect(source.GP, orifice1.GP1) annotation(
    Line(points = {{-80, 10}, {-60, 10}, {-60, 10}, {-60, 10}}));
  connect(orifice1.GP2, sink.GP) annotation(
    Line(points = {{-40, 10}, {80, 10}, {80, 10}, {80, 10}}));
  annotation(
    experiment(StartTime = 0, StopTime = 100, Tolerance = 1e-06, Interval = 0.002)
  );
end Before;
