within AICE.Research;

model TestVolumeReinit
  replaceable package Medium = AICE.Media.IdealGases.Examples.Sample5MixtureGas;
  //Modelica.Fluid.Vessels.ClosedVolume
  AICE.Research.VolumeReinit volume(redeclare package Medium = Medium, energyDynamics = Modelica.Fluid.Types.Dynamics.FixedInitial, massDynamics = Modelica.Fluid.Types.Dynamics.FixedInitial, nPorts = 1, portsData = {Modelica.Fluid.Vessels.BaseClasses.VesselPortsData(diameter = 0.00000001)}, use_HeatTransfer = false, use_portsData = true)  annotation(
    Placement(visible = true, transformation(origin = {0, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Fluid.Sources.FixedBoundary boundary(redeclare package Medium = Medium, nPorts = 1, use_T = true, use_p = true)  annotation(
    Placement(visible = true, transformation(origin = {-58, 4}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
/*
  when time == 0.5 then
    reinit(volume.medium.p, 99000);
    reinit(volume.m, 1.1);
  end when;
  */
  connect(boundary.ports[1], volume.ports[1]) annotation(
    Line(points = {{-48, 4}, {0, 4}, {0, 30}, {0, 30}}, color = {0, 127, 255}));
annotation(
    experiment(StartTime = 0, StopTime = 1, Tolerance = 1e-6, Interval = 0.002),
    __OpenModelica_simulationFlags(lv = "LOG_STATS", outputFormat = "mat", s = "dassl"));
end TestVolumeReinit;